/**
 * ASTASParser.java
 * 
 * Copyright (c) 2006 David Holroyd
 */

package uk.co.badgersinfoil.metaas.impl;

import java.io.Reader;
import org.antlr.runtime.RecognitionException;
import org.asdt.core.internal.antlr.AS3Parser;
import uk.co.badgersinfoil.metaas.ActionScriptParser;
import uk.co.badgersinfoil.metaas.SyntaxException;
import uk.co.badgersinfoil.metaas.dom.ASCompilationUnit;
import uk.co.badgersinfoil.metaas.impl.antlr.LinkedListTree;


public class ASTActionScriptParser implements ActionScriptParser {

	public ASCompilationUnit parse(Reader in) {
		AS3Parser parser = ASTUtils.parse(in);
		LinkedListTree cu;
		try {
			cu = ASTUtils.tree(parser.compilationUnit());
		} catch (RecognitionException e) {
			throw new SyntaxException(e);
		}
		return new AS3ASTCompilationUnit(cu);
	}
}