lexer grammar E4XLexer;
@header {
package uk.co.badgersinfoil.metaas.impl.parser.e4x;
}

T19 : '<' ;
T20 : '/>' ;
T21 : '>' ;
T22 : '</' ;
T23 : '{' ;
T24 : '}' ;
T25 : '=' ;
T26 : '<>' ;
T27 : '</>' ;

// $ANTLR src "uk/co/badgersinfoil/metaas/impl/parser/e4x/E4X.g" 147
XML_WS			:	(' ' | '\t' | '\n' | '\r')+;

// $ANTLR src "uk/co/badgersinfoil/metaas/impl/parser/e4x/E4X.g" 149
XML_NAME		:	XML_NAME_START XML_NAME_PART*;


// $ANTLR src "uk/co/badgersinfoil/metaas/impl/parser/e4x/E4X.g" 152
XML_ATTRIBUTE_VALUE
	:	'\'' ( options {greedy=false;} : . )* '\''
	|	'"' ( options {greedy=false;} : . )* '"'
	;



// $ANTLR src "uk/co/badgersinfoil/metaas/impl/parser/e4x/E4X.g" 159
XML_PI			:	'<?' ( options {greedy=false;} : . )* '?>';

// TODO: exclude the sequence '--' from being allowed,
// $ANTLR src "uk/co/badgersinfoil/metaas/impl/parser/e4x/E4X.g" 162
XML_COMMENT		:	'<!--' ( options {greedy=false;} : . )* '-->';

// $ANTLR src "uk/co/badgersinfoil/metaas/impl/parser/e4x/E4X.g" 164
XML_CDATA		:	'<![CDATA[' ( options {greedy=false;} : . )* ']]>';

// $ANTLR src "uk/co/badgersinfoil/metaas/impl/parser/e4x/E4X.g" 166
fragment XML_NAME_START	:	UNICODE_LETTER | '_' | ':';
// $ANTLR src "uk/co/badgersinfoil/metaas/impl/parser/e4x/E4X.g" 167
fragment XML_NAME_PART	:	UNICODE_LETTER | UNICODE_DIGIT | '.' | '-' | '_' | ':';

// TODO: and the rest of unicode?
// $ANTLR src "uk/co/badgersinfoil/metaas/impl/parser/e4x/E4X.g" 170
fragment UNICODE_LETTER	:	'a'..'z' | 'A'..'Z';
// $ANTLR src "uk/co/badgersinfoil/metaas/impl/parser/e4x/E4X.g" 171
fragment UNICODE_DIGIT	:	'0'..'9';

// $ANTLR src "uk/co/badgersinfoil/metaas/impl/parser/e4x/E4X.g" 173
XML_TEXT
	:	(~('<' | '{'))
	;
