// $ANTLR 3.0b4 org/asdt/core/internal/antlr/as3.g3 2006-12-17 16:49:28

package org.asdt.core.internal.antlr;

import uk.co.badgersinfoil.metaas.impl.antlr.LinkedListTree;
import uk.co.badgersinfoil.metaas.impl.antlr.LinkedListTreeAdaptor;
import uk.co.badgersinfoil.metaas.impl.antlr.LinkedListToken;
import uk.co.badgersinfoil.metaas.impl.antlr.LinkedListTokenStream;
import uk.co.badgersinfoil.metaas.impl.antlr.LinkedListTokenSource;
import java.io.StringReader;
import java.io.Reader;
import java.io.IOException;
import uk.co.badgersinfoil.metaas.impl.parser.E4XHelper;
import uk.co.badgersinfoil.metaas.impl.parser.e4x.E4X;
import uk.co.badgersinfoil.metaas.impl.parser.e4x.E4XLexer;
import uk.co.badgersinfoil.metaas.impl.ASTUtils;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;

import org.antlr.runtime.tree.*;

/**********************************************************
 * ActionScript Development Tool 
 * Copyright (C) 2005 asdt.org 
 * 
 * http://www.asdt.org
 * http://sourceforge.net/projects/aseclipseplugin/
 *
 * This program is free software; 
 * you can redistribute it and/or modify it under the terms of 
 * the GNU General Public License as published by the 
 * Free Software Foundation; either version 2 of the License, 
 * or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the 
 * Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
 * 
 * Created on 29 sept 2005
 * 
 **********************************************************


**
 *	@author Martin Schnabel
 */
public class AS3Parser extends Parser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "COMPILATION_UNIT", "TYPE_BLOCK", "METHOD_DEF", "VAR_DEF", "ANNOTATIONS", "ANNOTATION", "ANNOTATION_PARAMS", "ANNOTATION_PARAM", "MODIFIERS", "NAMESPACE_DEF", "CLASS_DEF", "INTERFACE_DEF", "PARAMS", "PARAM", "TYPE_SPEC", "BLOCK", "EXPR", "ELIST", "EXPR_STMNT", "ENCPS_EXPR", "VAR_INIT", "METHOD_CALL", "PROPERTY_OR_IDENTIFIER", "PROPERTY_ACCESS", "TYPE_NAME", "ARRAY_ACC", "UNARY_PLUS", "UNARY_MINUS", "POST_INC", "POST_DEC", "ARRAY_LITERAL", "ELEMENT", "OBJECT_LITERAL", "OBJECT_FIELD", "FUNC_DEF", "FOR_INIT", "FOR_CONDITION", "FOR_ITERATOR", "FOR_EACH", "SWITCH_STATEMENT_LIST", "IDENTIFIER", "GET", "SET", "DEFAULT_XML_NAMESPACE", "PACKAGE", "LCURLY", "RCURLY", "SEMI", "IMPORT", "CLASS", "IDENT", "INTERFACE", "EXTENDS", "COMMA", "IMPLEMENTS", "FUNCTION", "VAR", "CONST", "ASSIGN", "LPAREN", "RPAREN", "REST", "WHILE", "DO", "IF", "ELSE", "SWITCH", "CASE", "COLON", "DEFAULT", "FOR", "EACH", "IN", "STAR", "DOT", "DBL_COLON", "LBRACK", "RBRACK", "PUBLIC", "PRIVATE", "STATIC", "STAR_ASSIGN", "DIV_ASSIGN", "MOD_ASSIGN", "PLUS_ASSIGN", "MINUS_ASSIGN", "SL_ASSIGN", "SR_ASSIGN", "BSR_ASSIGN", "BAND_ASSIGN", "BXOR_ASSIGN", "BOR_ASSIGN", "LAND_ASSIGN", "LOR_ASSIGN", "QUESTION", "LOR", "LAND", "BOR", "BXOR", "BAND", "STRICT_EQUAL", "STRICT_NOT_EQUAL", "NOT_EQUAL", "EQUAL", "LT", "GT", "LE", "GE", "SL", "SR", "BSR", "PLUS", "MINUS", "DIV", "MOD", "INC", "DEC", "LNOT", "BNOT", "E4X_DESC", "E4X_ATTRI", "STRING_LITERAL", "TRUE", "FALSE", "HEX_LITERAL", "DECIMAL_LITERAL", "OCTAL_LITERAL", "FLOAT_LITERAL", "ESC", "HEX_DIGIT", "EXPONENT", "WS", "NL", "BOM", "SL_COMMENT", "ML_COMMENT", "OCT_DIGIT", "CTRLCHAR_ESC", "UNICODE_ESC", "OCTAL_ESC", "'with'", "'throw'", "'try'", "'catch'", "'finally'", "'return'", "'continue'", "'break'", "'void'", "'protected'", "'internal'", "'final'", "'enumerable'", "'explicit'", "'override'", "'dynamic'", "'is'", "'as'", "'delete'", "'typeof'", "'null'", "'undefined'", "'new'"
    };
    public static final int COMMA=57;
    public static final int CONST=61;
    public static final int SR_ASSIGN=91;
    public static final int STRICT_EQUAL=104;
    public static final int UNICODE_ESC=142;
    public static final int ELEMENT=35;
    public static final int MINUS=116;
    public static final int EXPR=20;
    public static final int VAR_INIT=24;
    public static final int FALSE=127;
    public static final int TYPE_BLOCK=5;
    public static final int PROPERTY_ACCESS=27;
    public static final int ARRAY_ACC=29;
    public static final int DEFAULT_XML_NAMESPACE=47;
    public static final int IMPORT=52;
    public static final int BOR=101;
    public static final int PACKAGE=48;
    public static final int LAND_ASSIGN=96;
    public static final int DOT=78;
    public static final int SR=113;
    public static final int POST_INC=32;
    public static final int PRIVATE=83;
    public static final int COMPILATION_UNIT=4;
    public static final int GET=45;
    public static final int LCURLY=49;
    public static final int FUNCTION=59;
    public static final int UNARY_MINUS=31;
    public static final int METHOD_CALL=25;
    public static final int STRICT_NOT_EQUAL=105;
    public static final int LOR_ASSIGN=97;
    public static final int STRING_LITERAL=125;
    public static final int LE=110;
    public static final int OBJECT_FIELD=37;
    public static final int RPAREN=64;
    public static final int STAR_ASSIGN=85;
    public static final int PLUS=115;
    public static final int PARAMS=16;
    public static final int OCTAL_ESC=143;
    public static final int EXTENDS=56;
    public static final int MINUS_ASSIGN=89;
    public static final int OBJECT_LITERAL=36;
    public static final int VAR_DEF=7;
    public static final int FUNC_DEF=38;
    public static final int DECIMAL_LITERAL=129;
    public static final int IDENT=54;
    public static final int MOD_ASSIGN=87;
    public static final int FLOAT_LITERAL=131;
    public static final int WS=135;
    public static final int TYPE_SPEC=18;
    public static final int BSR=114;
    public static final int LT=108;
    public static final int SL_ASSIGN=90;
    public static final int ANNOTATIONS=8;
    public static final int ANNOTATION_PARAMS=10;
    public static final int LAND=100;
    public static final int UNARY_PLUS=30;
    public static final int LBRACK=80;
    public static final int SEMI=51;
    public static final int STATIC=84;
    public static final int GE=111;
    public static final int CASE=71;
    public static final int CTRLCHAR_ESC=141;
    public static final int LNOT=121;
    public static final int ENCPS_EXPR=23;
    public static final int INTERFACE=55;
    public static final int DIV_ASSIGN=86;
    public static final int EQUAL=107;
    public static final int ELSE=69;
    public static final int MODIFIERS=12;
    public static final int BOM=137;
    public static final int NAMESPACE_DEF=13;
    public static final int ANNOTATION=9;
    public static final int COLON=72;
    public static final int SL=112;
    public static final int DIV=117;
    public static final int IDENTIFIER=44;
    public static final int SET=46;
    public static final int ARRAY_LITERAL=34;
    public static final int TRUE=126;
    public static final int EACH=75;
    public static final int METHOD_DEF=6;
    public static final int PUBLIC=82;
    public static final int LOR=99;
    public static final int BNOT=122;
    public static final int INC=119;
    public static final int POST_DEC=33;
    public static final int MOD=118;
    public static final int FOR_EACH=42;
    public static final int OCTAL_LITERAL=130;
    public static final int PLUS_ASSIGN=88;
    public static final int QUESTION=98;
    public static final int HEX_LITERAL=128;
    public static final int BLOCK=19;
    public static final int RCURLY=50;
    public static final int NL=136;
    public static final int PROPERTY_OR_IDENTIFIER=26;
    public static final int BOR_ASSIGN=95;
    public static final int ASSIGN=62;
    public static final int FOR_ITERATOR=41;
    public static final int PARAM=17;
    public static final int LPAREN=63;
    public static final int HEX_DIGIT=133;
    public static final int ML_COMMENT=139;
    public static final int CLASS_DEF=14;
    public static final int SL_COMMENT=138;
    public static final int BAND=103;
    public static final int TYPE_NAME=28;
    public static final int ELIST=21;
    public static final int NOT_EQUAL=106;
    public static final int BAND_ASSIGN=93;
    public static final int FOR_CONDITION=40;
    public static final int DO=67;
    public static final int IMPLEMENTS=58;
    public static final int WHILE=66;
    public static final int SWITCH=70;
    public static final int SWITCH_STATEMENT_LIST=43;
    public static final int FOR_INIT=39;
    public static final int BXOR_ASSIGN=94;
    public static final int EXPR_STMNT=22;
    public static final int GT=109;
    public static final int E4X_ATTRI=124;
    public static final int BSR_ASSIGN=92;
    public static final int ESC=132;
    public static final int ANNOTATION_PARAM=11;
    public static final int IN=76;
    public static final int INTERFACE_DEF=15;
    public static final int VAR=60;
    public static final int CLASS=53;
    public static final int DBL_COLON=79;
    public static final int DEC=120;
    public static final int EXPONENT=134;
    public static final int OCT_DIGIT=140;
    public static final int E4X_DESC=123;
    public static final int IF=68;
    public static final int EOF=-1;
    public static final int FOR=74;
    public static final int RBRACK=81;
    public static final int DEFAULT=73;
    public static final int REST=65;
    public static final int BXOR=102;
    public static final int STAR=77;

        public AS3Parser(TokenStream input) {
            super(input);
            ruleMemo = new HashMap[108+1];
         }
        
    protected TreeAdaptor adaptor = new CommonTreeAdaptor();

    public void setTreeAdaptor(TreeAdaptor adaptor) {
        this.adaptor = adaptor;
    }
    public TreeAdaptor getTreeAdaptor() {
        return adaptor;
    }

    public String[] getTokenNames() { return tokenNames; }
    public String getGrammarFileName() { return "org/asdt/core/internal/antlr/as3.g3"; }

    
    	protected void mismatch(IntStream input, int ttype, BitSet follow)
    		throws RecognitionException
    	{
    		throw new MismatchedTokenException(ttype, input);
    	}
    	
    	private AS3ParserLexer lexer;
    	private CharStream cs;
    
    	public void setInput(AS3ParserLexer lexer, CharStream cs) {
    		this.lexer = lexer;
    		this.cs = cs;
    	}
    
    	/**
    	 * Handle 'island grammar' for embeded XML-literal documents.
    	 */
    	private LinkedListTree parseXMLLiteral(LinkedListToken startMarker) throws RecognitionException {
    		return E4XHelper.parseXMLLiteral(startMarker, lexer, cs, (LinkedListTokenStream)input);
    	}


    public static class compilationUnit_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start compilationUnit
    // org/asdt/core/internal/antlr/as3.g3:115:1: compilationUnit : ( as2CompilationUnit | as3CompilationUnit ) -> ^( COMPILATION_UNIT ( as2CompilationUnit )? ( as3CompilationUnit )? ) ;
    public compilationUnit_return compilationUnit() throws RecognitionException {   
        compilationUnit_return retval = new compilationUnit_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        as2CompilationUnit_return as2CompilationUnit1 = null;

        as3CompilationUnit_return as3CompilationUnit2 = null;

        List list_as3CompilationUnit=new ArrayList();
        List list_as2CompilationUnit=new ArrayList();

        try {
            // org/asdt/core/internal/antlr/as3.g3:119:4: ( ( as2CompilationUnit | as3CompilationUnit ) -> ^( COMPILATION_UNIT ( as2CompilationUnit )? ( as3CompilationUnit )? ) )
            // org/asdt/core/internal/antlr/as3.g3:119:4: ( as2CompilationUnit | as3CompilationUnit )
            {
            // org/asdt/core/internal/antlr/as3.g3:119:4: ( as2CompilationUnit | as3CompilationUnit )
            int alt1=2;
            int LA1_0 = input.LA(1);
            if ( ((LA1_0>=IMPORT && LA1_0<=CLASS)||LA1_0==INTERFACE) ) {
                alt1=1;
            }
            else if ( (LA1_0==PACKAGE) ) {
                alt1=2;
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("119:4: ( as2CompilationUnit | as3CompilationUnit )", 1, 0, input);

                throw nvae;
            }
            switch (alt1) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:119:6: as2CompilationUnit
                    {
                    pushFollow(FOLLOW_as2CompilationUnit_in_compilationUnit239);
                    as2CompilationUnit1=as2CompilationUnit();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) list_as2CompilationUnit.add(as2CompilationUnit1.tree);

                    }
                    break;
                case 2 :
                    // org/asdt/core/internal/antlr/as3.g3:120:5: as3CompilationUnit
                    {
                    pushFollow(FOLLOW_as3CompilationUnit_in_compilationUnit245);
                    as3CompilationUnit2=as3CompilationUnit();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) list_as3CompilationUnit.add(as3CompilationUnit2.tree);

                    }
                    break;

            }


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 121:5: -> ^( COMPILATION_UNIT ( as2CompilationUnit )? ( as3CompilationUnit )? )
            {
                // org/asdt/core/internal/antlr/as3.g3:121:8: ^( COMPILATION_UNIT ( as2CompilationUnit )? ( as3CompilationUnit )? )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(COMPILATION_UNIT, "COMPILATION_UNIT"), root_1);

                // org/asdt/core/internal/antlr/as3.g3:121:27: ( as2CompilationUnit )?
                {
                int n_1 = list_as2CompilationUnit == null ? 0 : list_as2CompilationUnit.size();
                 


                if ( n_1 > 1 ) throw new RuntimeException("as2CompilationUnit list has > 1 elements");
                if ( n_1==1 ) {
                    int i_1 = 0;
                    adaptor.addChild(root_1, list_as2CompilationUnit.get(i_1));

                    }
                }
                // org/asdt/core/internal/antlr/as3.g3:121:47: ( as3CompilationUnit )?
                {
                int n_1 = list_as3CompilationUnit == null ? 0 : list_as3CompilationUnit.size();
                 


                if ( n_1 > 1 ) throw new RuntimeException("as3CompilationUnit list has > 1 elements");
                if ( n_1==1 ) {
                    int i_1 = 0;
                    adaptor.addChild(root_1, list_as3CompilationUnit.get(i_1));

                    }
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end compilationUnit

    public static class as2CompilationUnit_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start as2CompilationUnit
    // org/asdt/core/internal/antlr/as3.g3:124:1: as2CompilationUnit : ( ( importDefinition )* classDefinition[null, null] | interfaceDefinition[null, null] );
    public as2CompilationUnit_return as2CompilationUnit() throws RecognitionException {   
        as2CompilationUnit_return retval = new as2CompilationUnit_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        importDefinition_return importDefinition3 = null;

        classDefinition_return classDefinition4 = null;

        interfaceDefinition_return interfaceDefinition5 = null;



        try {
            // org/asdt/core/internal/antlr/as3.g3:125:4: ( ( importDefinition )* classDefinition[null, null] | interfaceDefinition[null, null] )
            int alt3=2;
            int LA3_0 = input.LA(1);
            if ( ((LA3_0>=IMPORT && LA3_0<=CLASS)) ) {
                alt3=1;
            }
            else if ( (LA3_0==INTERFACE) ) {
                alt3=2;
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("124:1: as2CompilationUnit : ( ( importDefinition )* classDefinition[null, null] | interfaceDefinition[null, null] );", 3, 0, input);

                throw nvae;
            }
            switch (alt3) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:125:4: ( importDefinition )* classDefinition[null, null]
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    // org/asdt/core/internal/antlr/as3.g3:125:4: ( importDefinition )*
                    loop2:
                    do {
                        int alt2=2;
                        int LA2_0 = input.LA(1);
                        if ( (LA2_0==IMPORT) ) {
                            alt2=1;
                        }


                        switch (alt2) {
                    	case 1 :
                    	    // org/asdt/core/internal/antlr/as3.g3:125:4: importDefinition
                    	    {
                    	    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    	    pushFollow(FOLLOW_importDefinition_in_as2CompilationUnit272);
                    	    importDefinition3=importDefinition();
                    	    _fsp--;
                    	    if (failed) return retval;
                    	    if ( backtracking==0 ) adaptor.addChild(root_1, importDefinition3.tree);

                    	    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    	    }
                    	    break;

                    	default :
                    	    break loop2;
                        }
                    } while (true);

                    pushFollow(FOLLOW_classDefinition_in_as2CompilationUnit277);
                    classDefinition4=classDefinition(null,  null);
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, classDefinition4.tree);

                    }
                    break;
                case 2 :
                    // org/asdt/core/internal/antlr/as3.g3:127:4: interfaceDefinition[null, null]
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_interfaceDefinition_in_as2CompilationUnit283);
                    interfaceDefinition5=interfaceDefinition(null,  null);
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, interfaceDefinition5.tree);

                    }
                    break;

            }
        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end as2CompilationUnit

    public static class as3CompilationUnit_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start as3CompilationUnit
    // org/asdt/core/internal/antlr/as3.g3:130:1: as3CompilationUnit : packageDecl EOF! ;
    public as3CompilationUnit_return as3CompilationUnit() throws RecognitionException {   
        as3CompilationUnit_return retval = new as3CompilationUnit_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token EOF7=null;
        packageDecl_return packageDecl6 = null;


        LinkedListTree EOF7_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:131:4: ( packageDecl EOF! )
            // org/asdt/core/internal/antlr/as3.g3:131:4: packageDecl EOF!
            {
            root_0 = (LinkedListTree)adaptor.nil();

            pushFollow(FOLLOW_packageDecl_in_as3CompilationUnit295);
            packageDecl6=packageDecl();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, packageDecl6.tree);
            EOF7=(Token)input.LT(1);
            match(input,EOF,FOLLOW_EOF_in_as3CompilationUnit299); if (failed) return retval;

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end as3CompilationUnit

    public static class packageDecl_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start packageDecl
    // org/asdt/core/internal/antlr/as3.g3:135:1: packageDecl : PACKAGE^ ( identifier )? packageBlock ;
    public packageDecl_return packageDecl() throws RecognitionException {   
        packageDecl_return retval = new packageDecl_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token PACKAGE8=null;
        identifier_return identifier9 = null;

        packageBlock_return packageBlock10 = null;


        LinkedListTree PACKAGE8_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:136:4: ( PACKAGE^ ( identifier )? packageBlock )
            // org/asdt/core/internal/antlr/as3.g3:136:4: PACKAGE^ ( identifier )? packageBlock
            {
            root_0 = (LinkedListTree)adaptor.nil();

            PACKAGE8=(Token)input.LT(1);
            match(input,PACKAGE,FOLLOW_PACKAGE_in_packageDecl311); if (failed) return retval;
            if ( backtracking==0 ) {
            PACKAGE8_tree = (LinkedListTree)adaptor.create(PACKAGE8);
            root_0 = (LinkedListTree)adaptor.becomeRoot(PACKAGE8_tree, root_0);
            }
            // org/asdt/core/internal/antlr/as3.g3:136:13: ( identifier )?
            int alt4=2;
            int LA4_0 = input.LA(1);
            if ( (LA4_0==IDENT) ) {
                alt4=1;
            }
            switch (alt4) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:136:13: identifier
                    {
                    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_identifier_in_packageDecl314);
                    identifier9=identifier();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_1, identifier9.tree);

                    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    }
                    break;

            }

            pushFollow(FOLLOW_packageBlock_in_packageDecl319);
            packageBlock10=packageBlock();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, packageBlock10.tree);

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end packageDecl

    public static class packageBlock_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start packageBlock
    // org/asdt/core/internal/antlr/as3.g3:140:1: packageBlock : LCURLY ( packageBlockEntry )* RCURLY -> ^( BLOCK ( packageBlockEntry )* ) ;
    public packageBlock_return packageBlock() throws RecognitionException {   
        packageBlock_return retval = new packageBlock_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token LCURLY11=null;
        Token RCURLY13=null;
        packageBlockEntry_return packageBlockEntry12 = null;

        List list_packageBlockEntry=new ArrayList();
        List list_RCURLY=new ArrayList();
        List list_LCURLY=new ArrayList();
        LinkedListTree LCURLY11_tree=null;
        LinkedListTree RCURLY13_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:141:4: ( LCURLY ( packageBlockEntry )* RCURLY -> ^( BLOCK ( packageBlockEntry )* ) )
            // org/asdt/core/internal/antlr/as3.g3:141:4: LCURLY ( packageBlockEntry )* RCURLY
            {
            LCURLY11=(Token)input.LT(1);
            match(input,LCURLY,FOLLOW_LCURLY_in_packageBlock330); if (failed) return retval;
            if ( backtracking==0 ) list_LCURLY.add(LCURLY11);

            // org/asdt/core/internal/antlr/as3.g3:142:3: ( packageBlockEntry )*
            loop5:
            do {
                int alt5=2;
                int LA5_0 = input.LA(1);
                if ( ((LA5_0>=SEMI && LA5_0<=INTERFACE)||(LA5_0>=FUNCTION && LA5_0<=CONST)||LA5_0==LBRACK||(LA5_0>=PUBLIC && LA5_0<=STATIC)||(LA5_0>=153 && LA5_0<=159)) ) {
                    alt5=1;
                }


                switch (alt5) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:142:3: packageBlockEntry
            	    {
            	    pushFollow(FOLLOW_packageBlockEntry_in_packageBlock334);
            	    packageBlockEntry12=packageBlockEntry();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) list_packageBlockEntry.add(packageBlockEntry12.tree);

            	    }
            	    break;

            	default :
            	    break loop5;
                }
            } while (true);

            RCURLY13=(Token)input.LT(1);
            match(input,RCURLY,FOLLOW_RCURLY_in_packageBlock339); if (failed) return retval;
            if ( backtracking==0 ) list_RCURLY.add(RCURLY13);


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 144:3: -> ^( BLOCK ( packageBlockEntry )* )
            {
                // org/asdt/core/internal/antlr/as3.g3:144:6: ^( BLOCK ( packageBlockEntry )* )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(BLOCK, "BLOCK"), root_1);

                // org/asdt/core/internal/antlr/as3.g3:144:14: ( packageBlockEntry )*
                {
                int n_1 = list_packageBlockEntry == null ? 0 : list_packageBlockEntry.size();
                 


                for (int i_1=0; i_1<n_1; i_1++) {
                    adaptor.addChild(root_1, list_packageBlockEntry.get(i_1));

                }
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end packageBlock

    public static class packageBlockEntry_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start packageBlockEntry
    // org/asdt/core/internal/antlr/as3.g3:147:1: packageBlockEntry : ( importDefinition | annos= annotations! mods= modifiers! ( classDefinition[$annos.tree,$mods.tree] | interfaceDefinition[$annos.tree,$mods.tree] | variableDefinition[$annos.tree,$mods.tree] | methodDefinition[$annos.tree,$mods.tree] | namespaceDefinition[$annos.tree,$mods.tree] ) | SEMI! ) ;
    public packageBlockEntry_return packageBlockEntry() throws RecognitionException {   
        packageBlockEntry_return retval = new packageBlockEntry_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token SEMI20=null;
        annotations_return annos = null;

        modifiers_return mods = null;

        importDefinition_return importDefinition14 = null;

        classDefinition_return classDefinition15 = null;

        interfaceDefinition_return interfaceDefinition16 = null;

        variableDefinition_return variableDefinition17 = null;

        methodDefinition_return methodDefinition18 = null;

        namespaceDefinition_return namespaceDefinition19 = null;


        LinkedListTree SEMI20_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:148:4: ( ( importDefinition | annos= annotations! mods= modifiers! ( classDefinition[$annos.tree,$mods.tree] | interfaceDefinition[$annos.tree,$mods.tree] | variableDefinition[$annos.tree,$mods.tree] | methodDefinition[$annos.tree,$mods.tree] | namespaceDefinition[$annos.tree,$mods.tree] ) | SEMI! ) )
            // org/asdt/core/internal/antlr/as3.g3:148:4: ( importDefinition | annos= annotations! mods= modifiers! ( classDefinition[$annos.tree,$mods.tree] | interfaceDefinition[$annos.tree,$mods.tree] | variableDefinition[$annos.tree,$mods.tree] | methodDefinition[$annos.tree,$mods.tree] | namespaceDefinition[$annos.tree,$mods.tree] ) | SEMI! )
            {
            root_0 = (LinkedListTree)adaptor.nil();

            // org/asdt/core/internal/antlr/as3.g3:148:4: ( importDefinition | annos= annotations! mods= modifiers! ( classDefinition[$annos.tree,$mods.tree] | interfaceDefinition[$annos.tree,$mods.tree] | variableDefinition[$annos.tree,$mods.tree] | methodDefinition[$annos.tree,$mods.tree] | namespaceDefinition[$annos.tree,$mods.tree] ) | SEMI! )
            int alt7=3;
            switch ( input.LA(1) ) {
            case IMPORT:
                alt7=1;
                break;
            case CLASS:
            case IDENT:
            case INTERFACE:
            case FUNCTION:
            case VAR:
            case CONST:
            case LBRACK:
            case PUBLIC:
            case PRIVATE:
            case STATIC:
            case 153:
            case 154:
            case 155:
            case 156:
            case 157:
            case 158:
            case 159:
                alt7=2;
                break;
            case SEMI:
                alt7=3;
                break;
            default:
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("148:4: ( importDefinition | annos= annotations! mods= modifiers! ( classDefinition[$annos.tree,$mods.tree] | interfaceDefinition[$annos.tree,$mods.tree] | variableDefinition[$annos.tree,$mods.tree] | methodDefinition[$annos.tree,$mods.tree] | namespaceDefinition[$annos.tree,$mods.tree] ) | SEMI! )", 7, 0, input);

                throw nvae;
            }

            switch (alt7) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:148:6: importDefinition
                    {
                    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_importDefinition_in_packageBlockEntry363);
                    importDefinition14=importDefinition();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_1, importDefinition14.tree);

                    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    }
                    break;
                case 2 :
                    // org/asdt/core/internal/antlr/as3.g3:149:5: annos= annotations! mods= modifiers! ( classDefinition[$annos.tree,$mods.tree] | interfaceDefinition[$annos.tree,$mods.tree] | variableDefinition[$annos.tree,$mods.tree] | methodDefinition[$annos.tree,$mods.tree] | namespaceDefinition[$annos.tree,$mods.tree] )
                    {
                    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_annotations_in_packageBlockEntry371);
                    annos=annotations();
                    _fsp--;
                    if (failed) return retval;
                    pushFollow(FOLLOW_modifiers_in_packageBlockEntry376);
                    mods=modifiers();
                    _fsp--;
                    if (failed) return retval;
                    // org/asdt/core/internal/antlr/as3.g3:150:4: ( classDefinition[$annos.tree,$mods.tree] | interfaceDefinition[$annos.tree,$mods.tree] | variableDefinition[$annos.tree,$mods.tree] | methodDefinition[$annos.tree,$mods.tree] | namespaceDefinition[$annos.tree,$mods.tree] )
                    int alt6=5;
                    switch ( input.LA(1) ) {
                    case CLASS:
                        alt6=1;
                        break;
                    case INTERFACE:
                        alt6=2;
                        break;
                    case VAR:
                    case CONST:
                        alt6=3;
                        break;
                    case FUNCTION:
                        alt6=4;
                        break;
                    case IDENT:
                        alt6=5;
                        break;
                    default:
                        if (backtracking>0) {failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("150:4: ( classDefinition[$annos.tree,$mods.tree] | interfaceDefinition[$annos.tree,$mods.tree] | variableDefinition[$annos.tree,$mods.tree] | methodDefinition[$annos.tree,$mods.tree] | namespaceDefinition[$annos.tree,$mods.tree] )", 6, 0, input);

                        throw nvae;
                    }

                    switch (alt6) {
                        case 1 :
                            // org/asdt/core/internal/antlr/as3.g3:150:6: classDefinition[$annos.tree,$mods.tree]
                            {
                            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

                            pushFollow(FOLLOW_classDefinition_in_packageBlockEntry384);
                            classDefinition15=classDefinition(((LinkedListTree)annos.tree), ((LinkedListTree)mods.tree));
                            _fsp--;
                            if (failed) return retval;
                            if ( backtracking==0 ) adaptor.addChild(root_2, classDefinition15.tree);

                            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

                            }
                            break;
                        case 2 :
                            // org/asdt/core/internal/antlr/as3.g3:151:6: interfaceDefinition[$annos.tree,$mods.tree]
                            {
                            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

                            pushFollow(FOLLOW_interfaceDefinition_in_packageBlockEntry392);
                            interfaceDefinition16=interfaceDefinition(((LinkedListTree)annos.tree), ((LinkedListTree)mods.tree));
                            _fsp--;
                            if (failed) return retval;
                            if ( backtracking==0 ) adaptor.addChild(root_2, interfaceDefinition16.tree);

                            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

                            }
                            break;
                        case 3 :
                            // org/asdt/core/internal/antlr/as3.g3:152:6: variableDefinition[$annos.tree,$mods.tree]
                            {
                            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

                            pushFollow(FOLLOW_variableDefinition_in_packageBlockEntry400);
                            variableDefinition17=variableDefinition(((LinkedListTree)annos.tree), ((LinkedListTree)mods.tree));
                            _fsp--;
                            if (failed) return retval;
                            if ( backtracking==0 ) adaptor.addChild(root_2, variableDefinition17.tree);

                            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

                            }
                            break;
                        case 4 :
                            // org/asdt/core/internal/antlr/as3.g3:153:6: methodDefinition[$annos.tree,$mods.tree]
                            {
                            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

                            pushFollow(FOLLOW_methodDefinition_in_packageBlockEntry408);
                            methodDefinition18=methodDefinition(((LinkedListTree)annos.tree), ((LinkedListTree)mods.tree));
                            _fsp--;
                            if (failed) return retval;
                            if ( backtracking==0 ) adaptor.addChild(root_2, methodDefinition18.tree);

                            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

                            }
                            break;
                        case 5 :
                            // org/asdt/core/internal/antlr/as3.g3:154:6: namespaceDefinition[$annos.tree,$mods.tree]
                            {
                            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

                            pushFollow(FOLLOW_namespaceDefinition_in_packageBlockEntry416);
                            namespaceDefinition19=namespaceDefinition(((LinkedListTree)annos.tree), ((LinkedListTree)mods.tree));
                            _fsp--;
                            if (failed) return retval;
                            if ( backtracking==0 ) adaptor.addChild(root_2, namespaceDefinition19.tree);

                            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

                            }
                            break;

                    }


                    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    }
                    break;
                case 3 :
                    // org/asdt/core/internal/antlr/as3.g3:156:5: SEMI!
                    {
                    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    SEMI20=(Token)input.LT(1);
                    match(input,SEMI,FOLLOW_SEMI_in_packageBlockEntry428); if (failed) return retval;

                    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    }
                    break;

            }


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end packageBlockEntry

    public static class endOfFile_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start endOfFile
    // org/asdt/core/internal/antlr/as3.g3:160:1: endOfFile : EOF! ;
    public endOfFile_return endOfFile() throws RecognitionException {   
        endOfFile_return retval = new endOfFile_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token EOF21=null;

        LinkedListTree EOF21_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:161:4: ( EOF! )
            // org/asdt/core/internal/antlr/as3.g3:161:4: EOF!
            {
            root_0 = (LinkedListTree)adaptor.nil();

            EOF21=(Token)input.LT(1);
            match(input,EOF,FOLLOW_EOF_in_endOfFile444); if (failed) return retval;

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end endOfFile

    public static class importDefinition_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start importDefinition
    // org/asdt/core/internal/antlr/as3.g3:164:1: importDefinition : IMPORT^ identifierStar ({...}? SEMI! )? ;
    public importDefinition_return importDefinition() throws RecognitionException {   
        importDefinition_return retval = new importDefinition_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token IMPORT22=null;
        Token SEMI24=null;
        identifierStar_return identifierStar23 = null;


        LinkedListTree IMPORT22_tree=null;
        LinkedListTree SEMI24_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:165:4: ( IMPORT^ identifierStar ({...}? SEMI! )? )
            // org/asdt/core/internal/antlr/as3.g3:165:4: IMPORT^ identifierStar ({...}? SEMI! )?
            {
            root_0 = (LinkedListTree)adaptor.nil();

            IMPORT22=(Token)input.LT(1);
            match(input,IMPORT,FOLLOW_IMPORT_in_importDefinition456); if (failed) return retval;
            if ( backtracking==0 ) {
            IMPORT22_tree = (LinkedListTree)adaptor.create(IMPORT22);
            root_0 = (LinkedListTree)adaptor.becomeRoot(IMPORT22_tree, root_0);
            }
            pushFollow(FOLLOW_identifierStar_in_importDefinition459);
            identifierStar23=identifierStar();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, identifierStar23.tree);
            // org/asdt/core/internal/antlr/as3.g3:165:27: ({...}? SEMI! )?
            int alt8=2;
            int LA8_0 = input.LA(1);
            if ( (LA8_0==SEMI) ) {
                if ( (input.LA(1)==SEMI) ) {
                    alt8=1;
                }
            }
            switch (alt8) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:165:28: {...}? SEMI!
                    {
                    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    if ( !(input.LA(1)==SEMI) ) {
                        if (backtracking>0) {failed=true; return retval;}
                        throw new FailedPredicateException(input, "importDefinition", "input.LA(1)==SEMI");
                    }
                    SEMI24=(Token)input.LT(1);
                    match(input,SEMI,FOLLOW_SEMI_in_importDefinition463); if (failed) return retval;

                    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    }
                    break;

            }


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end importDefinition

    public static class classDefinition_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start classDefinition
    // org/asdt/core/internal/antlr/as3.g3:169:1: classDefinition[LinkedListTree annos, LinkedListTree mods] : CLASS IDENT classExtendsClause implementsClause typeBlock -> ^( CLASS_DEF CLASS IDENT classExtendsClause implementsClause typeBlock ) ;
    public classDefinition_return classDefinition(LinkedListTree annos, LinkedListTree mods) throws RecognitionException {   
        classDefinition_return retval = new classDefinition_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token CLASS25=null;
        Token IDENT26=null;
        classExtendsClause_return classExtendsClause27 = null;

        implementsClause_return implementsClause28 = null;

        typeBlock_return typeBlock29 = null;

        List list_implementsClause=new ArrayList();
        List list_classExtendsClause=new ArrayList();
        List list_typeBlock=new ArrayList();
        List list_CLASS=new ArrayList();
        List list_IDENT=new ArrayList();
        LinkedListTree CLASS25_tree=null;
        LinkedListTree IDENT26_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:170:4: ( CLASS IDENT classExtendsClause implementsClause typeBlock -> ^( CLASS_DEF CLASS IDENT classExtendsClause implementsClause typeBlock ) )
            // org/asdt/core/internal/antlr/as3.g3:170:4: CLASS IDENT classExtendsClause implementsClause typeBlock
            {
            CLASS25=(Token)input.LT(1);
            match(input,CLASS,FOLLOW_CLASS_in_classDefinition480); if (failed) return retval;
            if ( backtracking==0 ) list_CLASS.add(CLASS25);

            IDENT26=(Token)input.LT(1);
            match(input,IDENT,FOLLOW_IDENT_in_classDefinition482); if (failed) return retval;
            if ( backtracking==0 ) list_IDENT.add(IDENT26);

            pushFollow(FOLLOW_classExtendsClause_in_classDefinition486);
            classExtendsClause27=classExtendsClause();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_classExtendsClause.add(classExtendsClause27.tree);
            pushFollow(FOLLOW_implementsClause_in_classDefinition490);
            implementsClause28=implementsClause();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_implementsClause.add(implementsClause28.tree);
            pushFollow(FOLLOW_typeBlock_in_classDefinition494);
            typeBlock29=typeBlock();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_typeBlock.add(typeBlock29.tree);

            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 174:3: -> ^( CLASS_DEF CLASS IDENT classExtendsClause implementsClause typeBlock )
            {
                // org/asdt/core/internal/antlr/as3.g3:174:6: ^( CLASS_DEF CLASS IDENT classExtendsClause implementsClause typeBlock )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(CLASS_DEF, "CLASS_DEF"), root_1);

                adaptor.addChild(root_1, mods);
                adaptor.addChild(root_1, (Token)list_CLASS.get(i_0));
                adaptor.addChild(root_1, (Token)list_IDENT.get(i_0));
                adaptor.addChild(root_1, list_classExtendsClause.get(i_0));
                adaptor.addChild(root_1, list_implementsClause.get(i_0));
                adaptor.addChild(root_1, list_typeBlock.get(i_0));

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end classDefinition

    public static class interfaceDefinition_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start interfaceDefinition
    // org/asdt/core/internal/antlr/as3.g3:177:1: interfaceDefinition[LinkedListTree annos, Tree mods] : INTERFACE IDENT interfaceExtendsClause typeBlock -> ^( INTERFACE_DEF INTERFACE IDENT interfaceExtendsClause typeBlock ) ;
    public interfaceDefinition_return interfaceDefinition(LinkedListTree annos, Tree mods) throws RecognitionException {   
        interfaceDefinition_return retval = new interfaceDefinition_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token INTERFACE30=null;
        Token IDENT31=null;
        interfaceExtendsClause_return interfaceExtendsClause32 = null;

        typeBlock_return typeBlock33 = null;

        List list_typeBlock=new ArrayList();
        List list_interfaceExtendsClause=new ArrayList();
        List list_INTERFACE=new ArrayList();
        List list_IDENT=new ArrayList();
        LinkedListTree INTERFACE30_tree=null;
        LinkedListTree IDENT31_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:178:4: ( INTERFACE IDENT interfaceExtendsClause typeBlock -> ^( INTERFACE_DEF INTERFACE IDENT interfaceExtendsClause typeBlock ) )
            // org/asdt/core/internal/antlr/as3.g3:178:4: INTERFACE IDENT interfaceExtendsClause typeBlock
            {
            INTERFACE30=(Token)input.LT(1);
            match(input,INTERFACE,FOLLOW_INTERFACE_in_interfaceDefinition526); if (failed) return retval;
            if ( backtracking==0 ) list_INTERFACE.add(INTERFACE30);

            IDENT31=(Token)input.LT(1);
            match(input,IDENT,FOLLOW_IDENT_in_interfaceDefinition528); if (failed) return retval;
            if ( backtracking==0 ) list_IDENT.add(IDENT31);

            pushFollow(FOLLOW_interfaceExtendsClause_in_interfaceDefinition532);
            interfaceExtendsClause32=interfaceExtendsClause();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_interfaceExtendsClause.add(interfaceExtendsClause32.tree);
            pushFollow(FOLLOW_typeBlock_in_interfaceDefinition536);
            typeBlock33=typeBlock();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_typeBlock.add(typeBlock33.tree);

            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 181:3: -> ^( INTERFACE_DEF INTERFACE IDENT interfaceExtendsClause typeBlock )
            {
                // org/asdt/core/internal/antlr/as3.g3:181:6: ^( INTERFACE_DEF INTERFACE IDENT interfaceExtendsClause typeBlock )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(INTERFACE_DEF, "INTERFACE_DEF"), root_1);

                adaptor.addChild(root_1, (Token)list_INTERFACE.get(i_0));
                adaptor.addChild(root_1, (Token)list_IDENT.get(i_0));
                adaptor.addChild(root_1, list_interfaceExtendsClause.get(i_0));
                adaptor.addChild(root_1, list_typeBlock.get(i_0));

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end interfaceDefinition

    public static class classExtendsClause_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start classExtendsClause
    // org/asdt/core/internal/antlr/as3.g3:183:1: classExtendsClause : ( EXTENDS^ identifier )? ;
    public classExtendsClause_return classExtendsClause() throws RecognitionException {   
        classExtendsClause_return retval = new classExtendsClause_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token EXTENDS34=null;
        identifier_return identifier35 = null;


        LinkedListTree EXTENDS34_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:184:4: ( ( EXTENDS^ identifier )? )
            // org/asdt/core/internal/antlr/as3.g3:184:4: ( EXTENDS^ identifier )?
            {
            root_0 = (LinkedListTree)adaptor.nil();

            // org/asdt/core/internal/antlr/as3.g3:184:4: ( EXTENDS^ identifier )?
            int alt9=2;
            int LA9_0 = input.LA(1);
            if ( (LA9_0==EXTENDS) ) {
                alt9=1;
            }
            switch (alt9) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:184:5: EXTENDS^ identifier
                    {
                    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    EXTENDS34=(Token)input.LT(1);
                    match(input,EXTENDS,FOLLOW_EXTENDS_in_classExtendsClause564); if (failed) return retval;
                    if ( backtracking==0 ) {
                    EXTENDS34_tree = (LinkedListTree)adaptor.create(EXTENDS34);
                    root_1 = (LinkedListTree)adaptor.becomeRoot(EXTENDS34_tree, root_1);
                    }
                    pushFollow(FOLLOW_identifier_in_classExtendsClause567);
                    identifier35=identifier();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_1, identifier35.tree);

                    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    }
                    break;

            }


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end classExtendsClause

    public static class interfaceExtendsClause_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start interfaceExtendsClause
    // org/asdt/core/internal/antlr/as3.g3:186:1: interfaceExtendsClause : ( EXTENDS^ identifier ( COMMA! identifier )* )? ;
    public interfaceExtendsClause_return interfaceExtendsClause() throws RecognitionException {   
        interfaceExtendsClause_return retval = new interfaceExtendsClause_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token EXTENDS36=null;
        Token COMMA38=null;
        identifier_return identifier37 = null;

        identifier_return identifier39 = null;


        LinkedListTree EXTENDS36_tree=null;
        LinkedListTree COMMA38_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:187:4: ( ( EXTENDS^ identifier ( COMMA! identifier )* )? )
            // org/asdt/core/internal/antlr/as3.g3:187:4: ( EXTENDS^ identifier ( COMMA! identifier )* )?
            {
            root_0 = (LinkedListTree)adaptor.nil();

            // org/asdt/core/internal/antlr/as3.g3:187:4: ( EXTENDS^ identifier ( COMMA! identifier )* )?
            int alt11=2;
            int LA11_0 = input.LA(1);
            if ( (LA11_0==EXTENDS) ) {
                alt11=1;
            }
            switch (alt11) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:187:5: EXTENDS^ identifier ( COMMA! identifier )*
                    {
                    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    EXTENDS36=(Token)input.LT(1);
                    match(input,EXTENDS,FOLLOW_EXTENDS_in_interfaceExtendsClause580); if (failed) return retval;
                    if ( backtracking==0 ) {
                    EXTENDS36_tree = (LinkedListTree)adaptor.create(EXTENDS36);
                    root_1 = (LinkedListTree)adaptor.becomeRoot(EXTENDS36_tree, root_1);
                    }
                    pushFollow(FOLLOW_identifier_in_interfaceExtendsClause583);
                    identifier37=identifier();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_1, identifier37.tree);
                    // org/asdt/core/internal/antlr/as3.g3:187:25: ( COMMA! identifier )*
                    loop10:
                    do {
                        int alt10=2;
                        int LA10_0 = input.LA(1);
                        if ( (LA10_0==COMMA) ) {
                            alt10=1;
                        }


                        switch (alt10) {
                    	case 1 :
                    	    // org/asdt/core/internal/antlr/as3.g3:187:27: COMMA! identifier
                    	    {
                    	    LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

                    	    COMMA38=(Token)input.LT(1);
                    	    match(input,COMMA,FOLLOW_COMMA_in_interfaceExtendsClause587); if (failed) return retval;
                    	    pushFollow(FOLLOW_identifier_in_interfaceExtendsClause590);
                    	    identifier39=identifier();
                    	    _fsp--;
                    	    if (failed) return retval;
                    	    if ( backtracking==0 ) adaptor.addChild(root_2, identifier39.tree);

                    	    if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

                    	    }
                    	    break;

                    	default :
                    	    break loop10;
                        }
                    } while (true);


                    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    }
                    break;

            }


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end interfaceExtendsClause

    public static class implementsClause_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start implementsClause
    // org/asdt/core/internal/antlr/as3.g3:189:1: implementsClause : ( IMPLEMENTS^ identifier ( COMMA! identifier )* )? ;
    public implementsClause_return implementsClause() throws RecognitionException {   
        implementsClause_return retval = new implementsClause_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token IMPLEMENTS40=null;
        Token COMMA42=null;
        identifier_return identifier41 = null;

        identifier_return identifier43 = null;


        LinkedListTree IMPLEMENTS40_tree=null;
        LinkedListTree COMMA42_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:190:4: ( ( IMPLEMENTS^ identifier ( COMMA! identifier )* )? )
            // org/asdt/core/internal/antlr/as3.g3:190:4: ( IMPLEMENTS^ identifier ( COMMA! identifier )* )?
            {
            root_0 = (LinkedListTree)adaptor.nil();

            // org/asdt/core/internal/antlr/as3.g3:190:4: ( IMPLEMENTS^ identifier ( COMMA! identifier )* )?
            int alt13=2;
            int LA13_0 = input.LA(1);
            if ( (LA13_0==IMPLEMENTS) ) {
                alt13=1;
            }
            switch (alt13) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:190:5: IMPLEMENTS^ identifier ( COMMA! identifier )*
                    {
                    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    IMPLEMENTS40=(Token)input.LT(1);
                    match(input,IMPLEMENTS,FOLLOW_IMPLEMENTS_in_implementsClause605); if (failed) return retval;
                    if ( backtracking==0 ) {
                    IMPLEMENTS40_tree = (LinkedListTree)adaptor.create(IMPLEMENTS40);
                    root_1 = (LinkedListTree)adaptor.becomeRoot(IMPLEMENTS40_tree, root_1);
                    }
                    pushFollow(FOLLOW_identifier_in_implementsClause608);
                    identifier41=identifier();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_1, identifier41.tree);
                    // org/asdt/core/internal/antlr/as3.g3:190:28: ( COMMA! identifier )*
                    loop12:
                    do {
                        int alt12=2;
                        int LA12_0 = input.LA(1);
                        if ( (LA12_0==COMMA) ) {
                            alt12=1;
                        }


                        switch (alt12) {
                    	case 1 :
                    	    // org/asdt/core/internal/antlr/as3.g3:190:30: COMMA! identifier
                    	    {
                    	    LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

                    	    COMMA42=(Token)input.LT(1);
                    	    match(input,COMMA,FOLLOW_COMMA_in_implementsClause612); if (failed) return retval;
                    	    pushFollow(FOLLOW_identifier_in_implementsClause615);
                    	    identifier43=identifier();
                    	    _fsp--;
                    	    if (failed) return retval;
                    	    if ( backtracking==0 ) adaptor.addChild(root_2, identifier43.tree);

                    	    if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

                    	    }
                    	    break;

                    	default :
                    	    break loop12;
                        }
                    } while (true);


                    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    }
                    break;

            }


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end implementsClause

    public static class typeBlock_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start typeBlock
    // org/asdt/core/internal/antlr/as3.g3:192:1: typeBlock : LCURLY ( typeBlockEntry )* RCURLY -> ^( TYPE_BLOCK ( typeBlockEntry )* ) ;
    public typeBlock_return typeBlock() throws RecognitionException {   
        typeBlock_return retval = new typeBlock_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token LCURLY44=null;
        Token RCURLY46=null;
        typeBlockEntry_return typeBlockEntry45 = null;

        List list_typeBlockEntry=new ArrayList();
        List list_RCURLY=new ArrayList();
        List list_LCURLY=new ArrayList();
        LinkedListTree LCURLY44_tree=null;
        LinkedListTree RCURLY46_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:193:4: ( LCURLY ( typeBlockEntry )* RCURLY -> ^( TYPE_BLOCK ( typeBlockEntry )* ) )
            // org/asdt/core/internal/antlr/as3.g3:193:4: LCURLY ( typeBlockEntry )* RCURLY
            {
            LCURLY44=(Token)input.LT(1);
            match(input,LCURLY,FOLLOW_LCURLY_in_typeBlock629); if (failed) return retval;
            if ( backtracking==0 ) list_LCURLY.add(LCURLY44);

            // org/asdt/core/internal/antlr/as3.g3:194:3: ( typeBlockEntry )*
            loop14:
            do {
                int alt14=2;
                int LA14_0 = input.LA(1);
                if ( ((LA14_0>=SEMI && LA14_0<=IMPORT)||(LA14_0>=FUNCTION && LA14_0<=CONST)||LA14_0==LBRACK||(LA14_0>=PUBLIC && LA14_0<=STATIC)||(LA14_0>=153 && LA14_0<=159)) ) {
                    alt14=1;
                }


                switch (alt14) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:194:3: typeBlockEntry
            	    {
            	    pushFollow(FOLLOW_typeBlockEntry_in_typeBlock633);
            	    typeBlockEntry45=typeBlockEntry();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) list_typeBlockEntry.add(typeBlockEntry45.tree);

            	    }
            	    break;

            	default :
            	    break loop14;
                }
            } while (true);

            RCURLY46=(Token)input.LT(1);
            match(input,RCURLY,FOLLOW_RCURLY_in_typeBlock638); if (failed) return retval;
            if ( backtracking==0 ) list_RCURLY.add(RCURLY46);


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 196:3: -> ^( TYPE_BLOCK ( typeBlockEntry )* )
            {
                // org/asdt/core/internal/antlr/as3.g3:196:6: ^( TYPE_BLOCK ( typeBlockEntry )* )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(TYPE_BLOCK, "TYPE_BLOCK"), root_1);

                // org/asdt/core/internal/antlr/as3.g3:196:19: ( typeBlockEntry )*
                {
                int n_1 = list_typeBlockEntry == null ? 0 : list_typeBlockEntry.size();
                 


                for (int i_1=0; i_1<n_1; i_1++) {
                    adaptor.addChild(root_1, list_typeBlockEntry.get(i_1));

                }
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end typeBlock

    public static class typeBlockEntry_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start typeBlockEntry
    // org/asdt/core/internal/antlr/as3.g3:199:1: typeBlockEntry : (annos= annotations! m= modifiers! ( variableDefinition[$annos.tree,$m.tree] | methodDefinition[$annos.tree,$m.tree] ) | SEMI | importDefinition ) ;
    public typeBlockEntry_return typeBlockEntry() throws RecognitionException {   
        typeBlockEntry_return retval = new typeBlockEntry_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token SEMI49=null;
        annotations_return annos = null;

        modifiers_return m = null;

        variableDefinition_return variableDefinition47 = null;

        methodDefinition_return methodDefinition48 = null;

        importDefinition_return importDefinition50 = null;


        LinkedListTree SEMI49_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:200:4: ( (annos= annotations! m= modifiers! ( variableDefinition[$annos.tree,$m.tree] | methodDefinition[$annos.tree,$m.tree] ) | SEMI | importDefinition ) )
            // org/asdt/core/internal/antlr/as3.g3:200:4: (annos= annotations! m= modifiers! ( variableDefinition[$annos.tree,$m.tree] | methodDefinition[$annos.tree,$m.tree] ) | SEMI | importDefinition )
            {
            root_0 = (LinkedListTree)adaptor.nil();

            // org/asdt/core/internal/antlr/as3.g3:200:4: (annos= annotations! m= modifiers! ( variableDefinition[$annos.tree,$m.tree] | methodDefinition[$annos.tree,$m.tree] ) | SEMI | importDefinition )
            int alt16=3;
            switch ( input.LA(1) ) {
            case FUNCTION:
            case VAR:
            case CONST:
            case LBRACK:
            case PUBLIC:
            case PRIVATE:
            case STATIC:
            case 153:
            case 154:
            case 155:
            case 156:
            case 157:
            case 158:
            case 159:
                alt16=1;
                break;
            case SEMI:
                alt16=2;
                break;
            case IMPORT:
                alt16=3;
                break;
            default:
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("200:4: (annos= annotations! m= modifiers! ( variableDefinition[$annos.tree,$m.tree] | methodDefinition[$annos.tree,$m.tree] ) | SEMI | importDefinition )", 16, 0, input);

                throw nvae;
            }

            switch (alt16) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:200:6: annos= annotations! m= modifiers! ( variableDefinition[$annos.tree,$m.tree] | methodDefinition[$annos.tree,$m.tree] )
                    {
                    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_annotations_in_typeBlockEntry664);
                    annos=annotations();
                    _fsp--;
                    if (failed) return retval;
                    pushFollow(FOLLOW_modifiers_in_typeBlockEntry669);
                    m=modifiers();
                    _fsp--;
                    if (failed) return retval;
                    // org/asdt/core/internal/antlr/as3.g3:201:4: ( variableDefinition[$annos.tree,$m.tree] | methodDefinition[$annos.tree,$m.tree] )
                    int alt15=2;
                    int LA15_0 = input.LA(1);
                    if ( ((LA15_0>=VAR && LA15_0<=CONST)) ) {
                        alt15=1;
                    }
                    else if ( (LA15_0==FUNCTION) ) {
                        alt15=2;
                    }
                    else {
                        if (backtracking>0) {failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("201:4: ( variableDefinition[$annos.tree,$m.tree] | methodDefinition[$annos.tree,$m.tree] )", 15, 0, input);

                        throw nvae;
                    }
                    switch (alt15) {
                        case 1 :
                            // org/asdt/core/internal/antlr/as3.g3:201:6: variableDefinition[$annos.tree,$m.tree]
                            {
                            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

                            pushFollow(FOLLOW_variableDefinition_in_typeBlockEntry677);
                            variableDefinition47=variableDefinition(((LinkedListTree)annos.tree), ((LinkedListTree)m.tree));
                            _fsp--;
                            if (failed) return retval;
                            if ( backtracking==0 ) adaptor.addChild(root_2, variableDefinition47.tree);

                            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

                            }
                            break;
                        case 2 :
                            // org/asdt/core/internal/antlr/as3.g3:202:6: methodDefinition[$annos.tree,$m.tree]
                            {
                            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

                            pushFollow(FOLLOW_methodDefinition_in_typeBlockEntry685);
                            methodDefinition48=methodDefinition(((LinkedListTree)annos.tree), ((LinkedListTree)m.tree));
                            _fsp--;
                            if (failed) return retval;
                            if ( backtracking==0 ) adaptor.addChild(root_2, methodDefinition48.tree);

                            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

                            }
                            break;

                    }


                    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    }
                    break;
                case 2 :
                    // org/asdt/core/internal/antlr/as3.g3:204:5: SEMI
                    {
                    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    SEMI49=(Token)input.LT(1);
                    match(input,SEMI,FOLLOW_SEMI_in_typeBlockEntry697); if (failed) return retval;
                    if ( backtracking==0 ) {
                    SEMI49_tree = (LinkedListTree)adaptor.create(SEMI49);
                    adaptor.addChild(root_1, SEMI49_tree);
                    }

                    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    }
                    break;
                case 3 :
                    // org/asdt/core/internal/antlr/as3.g3:205:5: importDefinition
                    {
                    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_importDefinition_in_typeBlockEntry703);
                    importDefinition50=importDefinition();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_1, importDefinition50.tree);

                    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    }
                    break;

            }


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end typeBlockEntry

    public static class methodDefinition_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start methodDefinition
    // org/asdt/core/internal/antlr/as3.g3:209:1: methodDefinition[LinkedListTree annos, Tree mods] : functionDecl IDENT parameterDeclarationList typeExpression ( block )? -> ^( METHOD_DEF functionDecl IDENT parameterDeclarationList typeExpression ( block )? ) ;
    public methodDefinition_return methodDefinition(LinkedListTree annos, Tree mods) throws RecognitionException {   
        methodDefinition_return retval = new methodDefinition_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token IDENT52=null;
        functionDecl_return functionDecl51 = null;

        parameterDeclarationList_return parameterDeclarationList53 = null;

        typeExpression_return typeExpression54 = null;

        block_return block55 = null;

        List list_typeExpression=new ArrayList();
        List list_parameterDeclarationList=new ArrayList();
        List list_functionDecl=new ArrayList();
        List list_block=new ArrayList();
        List list_IDENT=new ArrayList();
        LinkedListTree IDENT52_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:210:4: ( functionDecl IDENT parameterDeclarationList typeExpression ( block )? -> ^( METHOD_DEF functionDecl IDENT parameterDeclarationList typeExpression ( block )? ) )
            // org/asdt/core/internal/antlr/as3.g3:210:4: functionDecl IDENT parameterDeclarationList typeExpression ( block )?
            {
            pushFollow(FOLLOW_functionDecl_in_methodDefinition719);
            functionDecl51=functionDecl();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_functionDecl.add(functionDecl51.tree);
            IDENT52=(Token)input.LT(1);
            match(input,IDENT,FOLLOW_IDENT_in_methodDefinition721); if (failed) return retval;
            if ( backtracking==0 ) list_IDENT.add(IDENT52);

            pushFollow(FOLLOW_parameterDeclarationList_in_methodDefinition725);
            parameterDeclarationList53=parameterDeclarationList();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_parameterDeclarationList.add(parameterDeclarationList53.tree);
            pushFollow(FOLLOW_typeExpression_in_methodDefinition729);
            typeExpression54=typeExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_typeExpression.add(typeExpression54.tree);
            // org/asdt/core/internal/antlr/as3.g3:213:3: ( block )?
            int alt17=2;
            int LA17_0 = input.LA(1);
            if ( (LA17_0==LCURLY) ) {
                alt17=1;
            }
            switch (alt17) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:213:4: block
                    {
                    pushFollow(FOLLOW_block_in_methodDefinition734);
                    block55=block();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) list_block.add(block55.tree);

                    }
                    break;

            }


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 214:3: -> ^( METHOD_DEF functionDecl IDENT parameterDeclarationList typeExpression ( block )? )
            {
                // org/asdt/core/internal/antlr/as3.g3:214:6: ^( METHOD_DEF functionDecl IDENT parameterDeclarationList typeExpression ( block )? )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(METHOD_DEF, "METHOD_DEF"), root_1);

                adaptor.addChild(root_1, annos);
                adaptor.addChild(root_1, mods);
                adaptor.addChild(root_1, list_functionDecl.get(i_0));
                adaptor.addChild(root_1, (Token)list_IDENT.get(i_0));
                adaptor.addChild(root_1, list_parameterDeclarationList.get(i_0));
                adaptor.addChild(root_1, list_typeExpression.get(i_0));
                // org/asdt/core/internal/antlr/as3.g3:218:5: ( block )?
                {
                int n_1 = list_block == null ? 0 : list_block.size();
                 


                if ( n_1 > 1 ) throw new RuntimeException("block list has > 1 elements");
                if ( n_1==1 ) {
                    int i_1 = 0;
                    adaptor.addChild(root_1, list_block.get(i_1));

                    }
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end methodDefinition

    public static class functionDecl_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start functionDecl
    // org/asdt/core/internal/antlr/as3.g3:221:1: functionDecl : FUNCTION^ (role= accessorRole )? ;
    public functionDecl_return functionDecl() throws RecognitionException {   
        functionDecl_return retval = new functionDecl_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token FUNCTION56=null;
        accessorRole_return role = null;


        LinkedListTree FUNCTION56_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:222:4: ( FUNCTION^ (role= accessorRole )? )
            // org/asdt/core/internal/antlr/as3.g3:222:4: FUNCTION^ (role= accessorRole )?
            {
            root_0 = (LinkedListTree)adaptor.nil();

            FUNCTION56=(Token)input.LT(1);
            match(input,FUNCTION,FOLLOW_FUNCTION_in_functionDecl800); if (failed) return retval;
            if ( backtracking==0 ) {
            FUNCTION56_tree = (LinkedListTree)adaptor.create(FUNCTION56);
            root_0 = (LinkedListTree)adaptor.becomeRoot(FUNCTION56_tree, root_0);
            }
            // org/asdt/core/internal/antlr/as3.g3:222:14: (role= accessorRole )?
            int alt18=2;
            int LA18_0 = input.LA(1);
            if ( (LA18_0==IDENT) ) {
                int LA18_1 = input.LA(2);
                if ( (LA18_1==IDENT) ) {
                    alt18=1;
                }
            }
            switch (alt18) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:222:15: role= accessorRole
                    {
                    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_accessorRole_in_functionDecl806);
                    role=accessorRole();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_1, role.tree);

                    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    }
                    break;

            }


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end functionDecl

    public static class accessorRole_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start accessorRole
    // org/asdt/core/internal/antlr/as3.g3:225:1: accessorRole : ( getKeyword | setKeyword );
    public accessorRole_return accessorRole() throws RecognitionException {   
        accessorRole_return retval = new accessorRole_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        getKeyword_return getKeyword57 = null;

        setKeyword_return setKeyword58 = null;



        try {
            // org/asdt/core/internal/antlr/as3.g3:226:4: ( getKeyword | setKeyword )
            int alt19=2;
            int LA19_0 = input.LA(1);
            if ( (LA19_0==IDENT) ) {
                if ( (input.LT(1).getText().equals("get")) ) {
                    alt19=1;
                }
                else if ( (input.LT(1).getText().equals("set")) ) {
                    alt19=2;
                }
                else {
                    if (backtracking>0) {failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("225:1: accessorRole : ( getKeyword | setKeyword );", 19, 1, input);

                    throw nvae;
                }
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("225:1: accessorRole : ( getKeyword | setKeyword );", 19, 0, input);

                throw nvae;
            }
            switch (alt19) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:226:4: getKeyword
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_getKeyword_in_accessorRole819);
                    getKeyword57=getKeyword();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, getKeyword57.tree);

                    }
                    break;
                case 2 :
                    // org/asdt/core/internal/antlr/as3.g3:226:17: setKeyword
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_setKeyword_in_accessorRole823);
                    setKeyword58=setKeyword();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, setKeyword58.tree);

                    }
                    break;

            }
        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end accessorRole

    public static class getKeyword_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start getKeyword
    // org/asdt/core/internal/antlr/as3.g3:229:1: getKeyword : {...}?i= IDENT -> GET[$i] ;
    public getKeyword_return getKeyword() throws RecognitionException {   
        getKeyword_return retval = new getKeyword_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token i=null;
        List list_IDENT=new ArrayList();
        LinkedListTree i_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:230:4: ({...}?i= IDENT -> GET[$i] )
            // org/asdt/core/internal/antlr/as3.g3:230:4: {...}?i= IDENT
            {
            if ( !(input.LT(1).getText().equals("get")) ) {
                if (backtracking>0) {failed=true; return retval;}
                throw new FailedPredicateException(input, "getKeyword", "input.LT(1).getText().equals(\"get\")");
            }
            i=(Token)input.LT(1);
            match(input,IDENT,FOLLOW_IDENT_in_getKeyword838); if (failed) return retval;
            if ( backtracking==0 ) list_IDENT.add(i);


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 231:3: -> GET[$i]
            {
                adaptor.addChild(root_0, adaptor.create(GET, i));

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end getKeyword

    public static class setKeyword_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start setKeyword
    // org/asdt/core/internal/antlr/as3.g3:234:1: setKeyword : {...}?i= IDENT -> SET[$i] ;
    public setKeyword_return setKeyword() throws RecognitionException {   
        setKeyword_return retval = new setKeyword_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token i=null;
        List list_IDENT=new ArrayList();
        LinkedListTree i_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:235:4: ({...}?i= IDENT -> SET[$i] )
            // org/asdt/core/internal/antlr/as3.g3:235:4: {...}?i= IDENT
            {
            if ( !(input.LT(1).getText().equals("set")) ) {
                if (backtracking>0) {failed=true; return retval;}
                throw new FailedPredicateException(input, "setKeyword", "input.LT(1).getText().equals(\"set\")");
            }
            i=(Token)input.LT(1);
            match(input,IDENT,FOLLOW_IDENT_in_setKeyword860); if (failed) return retval;
            if ( backtracking==0 ) list_IDENT.add(i);


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 236:3: -> SET[$i]
            {
                adaptor.addChild(root_0, adaptor.create(SET, i));

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end setKeyword

    public static class namespaceDefinition_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start namespaceDefinition
    // org/asdt/core/internal/antlr/as3.g3:239:1: namespaceDefinition[LinkedListTree annos, Tree mods] : namespaceKeyword IDENT -> ^( NAMESPACE_DEF namespaceKeyword IDENT ) ;
    public namespaceDefinition_return namespaceDefinition(LinkedListTree annos, Tree mods) throws RecognitionException {   
        namespaceDefinition_return retval = new namespaceDefinition_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token IDENT60=null;
        namespaceKeyword_return namespaceKeyword59 = null;

        List list_namespaceKeyword=new ArrayList();
        List list_IDENT=new ArrayList();
        LinkedListTree IDENT60_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:240:4: ( namespaceKeyword IDENT -> ^( NAMESPACE_DEF namespaceKeyword IDENT ) )
            // org/asdt/core/internal/antlr/as3.g3:240:4: namespaceKeyword IDENT
            {
            pushFollow(FOLLOW_namespaceKeyword_in_namespaceDefinition879);
            namespaceKeyword59=namespaceKeyword();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_namespaceKeyword.add(namespaceKeyword59.tree);
            IDENT60=(Token)input.LT(1);
            match(input,IDENT,FOLLOW_IDENT_in_namespaceDefinition881); if (failed) return retval;
            if ( backtracking==0 ) list_IDENT.add(IDENT60);


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 241:3: -> ^( NAMESPACE_DEF namespaceKeyword IDENT )
            {
                // org/asdt/core/internal/antlr/as3.g3:241:6: ^( NAMESPACE_DEF namespaceKeyword IDENT )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(NAMESPACE_DEF, "NAMESPACE_DEF"), root_1);

                adaptor.addChild(root_1, annos);
                adaptor.addChild(root_1, mods);
                adaptor.addChild(root_1, list_namespaceKeyword.get(i_0));
                adaptor.addChild(root_1, (Token)list_IDENT.get(i_0));

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end namespaceDefinition

    public static class namespaceKeyword_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start namespaceKeyword
    // org/asdt/core/internal/antlr/as3.g3:243:1: namespaceKeyword : {...}? IDENT ;
    public namespaceKeyword_return namespaceKeyword() throws RecognitionException {   
        namespaceKeyword_return retval = new namespaceKeyword_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token IDENT61=null;

        LinkedListTree IDENT61_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:244:4: ({...}? IDENT )
            // org/asdt/core/internal/antlr/as3.g3:244:4: {...}? IDENT
            {
            root_0 = (LinkedListTree)adaptor.nil();

            if ( !(input.LT(1).getText().equals("namespace")) ) {
                if (backtracking>0) {failed=true; return retval;}
                throw new FailedPredicateException(input, "namespaceKeyword", "input.LT(1).getText().equals(\"namespace\")");
            }
            IDENT61=(Token)input.LT(1);
            match(input,IDENT,FOLLOW_IDENT_in_namespaceKeyword909); if (failed) return retval;
            if ( backtracking==0 ) {
            IDENT61_tree = (LinkedListTree)adaptor.create(IDENT61);
            adaptor.addChild(root_0, IDENT61_tree);
            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end namespaceKeyword

    public static class xmlKeyword_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start xmlKeyword
    // org/asdt/core/internal/antlr/as3.g3:247:1: xmlKeyword : {...}? IDENT ;
    public xmlKeyword_return xmlKeyword() throws RecognitionException {   
        xmlKeyword_return retval = new xmlKeyword_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token IDENT62=null;

        LinkedListTree IDENT62_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:248:4: ({...}? IDENT )
            // org/asdt/core/internal/antlr/as3.g3:248:4: {...}? IDENT
            {
            root_0 = (LinkedListTree)adaptor.nil();

            if ( !(input.LT(1).getText().equals("xml")) ) {
                if (backtracking>0) {failed=true; return retval;}
                throw new FailedPredicateException(input, "xmlKeyword", "input.LT(1).getText().equals(\"xml\")");
            }
            IDENT62=(Token)input.LT(1);
            match(input,IDENT,FOLLOW_IDENT_in_xmlKeyword922); if (failed) return retval;
            if ( backtracking==0 ) {
            IDENT62_tree = (LinkedListTree)adaptor.create(IDENT62);
            adaptor.addChild(root_0, IDENT62_tree);
            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end xmlKeyword

    public static class variableDefinition_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start variableDefinition
    // org/asdt/core/internal/antlr/as3.g3:251:1: variableDefinition[LinkedListTree annos, Tree mods] : decl= varOrConst variableDeclarator ( COMMA variableDeclarator )* -> ^( VAR_DEF $decl ( variableDeclarator )+ ) ;
    public variableDefinition_return variableDefinition(LinkedListTree annos, Tree mods) throws RecognitionException {   
        variableDefinition_return retval = new variableDefinition_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token COMMA64=null;
        varOrConst_return decl = null;

        variableDeclarator_return variableDeclarator63 = null;

        variableDeclarator_return variableDeclarator65 = null;

        List list_variableDeclarator=new ArrayList();
        List list_varOrConst=new ArrayList();
        List list_COMMA=new ArrayList();
        LinkedListTree COMMA64_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:252:4: (decl= varOrConst variableDeclarator ( COMMA variableDeclarator )* -> ^( VAR_DEF $decl ( variableDeclarator )+ ) )
            // org/asdt/core/internal/antlr/as3.g3:252:4: decl= varOrConst variableDeclarator ( COMMA variableDeclarator )*
            {
            pushFollow(FOLLOW_varOrConst_in_variableDefinition936);
            decl=varOrConst();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_varOrConst.add(decl.tree);
            pushFollow(FOLLOW_variableDeclarator_in_variableDefinition938);
            variableDeclarator63=variableDeclarator();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_variableDeclarator.add(variableDeclarator63.tree);
            // org/asdt/core/internal/antlr/as3.g3:253:3: ( COMMA variableDeclarator )*
            loop20:
            do {
                int alt20=2;
                int LA20_0 = input.LA(1);
                if ( (LA20_0==COMMA) ) {
                    alt20=1;
                }


                switch (alt20) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:253:4: COMMA variableDeclarator
            	    {
            	    COMMA64=(Token)input.LT(1);
            	    match(input,COMMA,FOLLOW_COMMA_in_variableDefinition943); if (failed) return retval;
            	    if ( backtracking==0 ) list_COMMA.add(COMMA64);

            	    pushFollow(FOLLOW_variableDeclarator_in_variableDefinition945);
            	    variableDeclarator65=variableDeclarator();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) list_variableDeclarator.add(variableDeclarator65.tree);

            	    }
            	    break;

            	default :
            	    break loop20;
                }
            } while (true);


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 254:3: -> ^( VAR_DEF $decl ( variableDeclarator )+ )
            {
                // org/asdt/core/internal/antlr/as3.g3:254:6: ^( VAR_DEF $decl ( variableDeclarator )+ )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(VAR_DEF, "VAR_DEF"), root_1);

                adaptor.addChild(root_1, annos);
                adaptor.addChild(root_1, mods);
                adaptor.addChild(root_1, decl.tree);
                // org/asdt/core/internal/antlr/as3.g3:254:39: ( variableDeclarator )+
                {
                int n_1 = list_variableDeclarator == null ? 0 : list_variableDeclarator.size();
                 


                if ( n_1==0 ) throw new RuntimeException("Must have more than one element for (...)+ loops");
                for (int i_1=0; i_1<n_1; i_1++) {
                    adaptor.addChild(root_1, list_variableDeclarator.get(i_1));

                }
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end variableDefinition

    public static class varOrConst_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start varOrConst
    // org/asdt/core/internal/antlr/as3.g3:257:1: varOrConst : (VAR|CONST);
    public varOrConst_return varOrConst() throws RecognitionException {   
        varOrConst_return retval = new varOrConst_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token set66=null;

        LinkedListTree set66_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:258:2: ( (VAR|CONST))
            // org/asdt/core/internal/antlr/as3.g3:258:4: (VAR|CONST)
            {
            root_0 = (LinkedListTree)adaptor.nil();

            set66=(Token)input.LT(1);
            if ( (input.LA(1)>=VAR && input.LA(1)<=CONST) ) {
                if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set66));
                input.consume();
                errorRecovery=false;failed=false;
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                MismatchedSetException mse =
                    new MismatchedSetException(null,input);
                recoverFromMismatchedSet(input,mse,FOLLOW_set_in_varOrConst976);    throw mse;
            }


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end varOrConst

    public static class variableDeclarator_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start variableDeclarator
    // org/asdt/core/internal/antlr/as3.g3:261:1: variableDeclarator : IDENT^ typeExpression ( variableInitializer )? ;
    public variableDeclarator_return variableDeclarator() throws RecognitionException {   
        variableDeclarator_return retval = new variableDeclarator_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token IDENT67=null;
        typeExpression_return typeExpression68 = null;

        variableInitializer_return variableInitializer69 = null;


        LinkedListTree IDENT67_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:262:4: ( IDENT^ typeExpression ( variableInitializer )? )
            // org/asdt/core/internal/antlr/as3.g3:262:4: IDENT^ typeExpression ( variableInitializer )?
            {
            root_0 = (LinkedListTree)adaptor.nil();

            IDENT67=(Token)input.LT(1);
            match(input,IDENT,FOLLOW_IDENT_in_variableDeclarator991); if (failed) return retval;
            if ( backtracking==0 ) {
            IDENT67_tree = (LinkedListTree)adaptor.create(IDENT67);
            root_0 = (LinkedListTree)adaptor.becomeRoot(IDENT67_tree, root_0);
            }
            pushFollow(FOLLOW_typeExpression_in_variableDeclarator994);
            typeExpression68=typeExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, typeExpression68.tree);
            // org/asdt/core/internal/antlr/as3.g3:262:26: ( variableInitializer )?
            int alt21=2;
            int LA21_0 = input.LA(1);
            if ( (LA21_0==ASSIGN) ) {
                alt21=1;
            }
            switch (alt21) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:262:26: variableInitializer
                    {
                    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_variableInitializer_in_variableDeclarator996);
                    variableInitializer69=variableInitializer();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_1, variableInitializer69.tree);

                    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    }
                    break;

            }


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end variableDeclarator

    public static class declaration_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start declaration
    // org/asdt/core/internal/antlr/as3.g3:264:1: declaration : VAR^ variableDeclarator ( COMMA! variableDeclarator )* ;
    public declaration_return declaration() throws RecognitionException {   
        declaration_return retval = new declaration_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token VAR70=null;
        Token COMMA72=null;
        variableDeclarator_return variableDeclarator71 = null;

        variableDeclarator_return variableDeclarator73 = null;


        LinkedListTree VAR70_tree=null;
        LinkedListTree COMMA72_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:265:4: ( VAR^ variableDeclarator ( COMMA! variableDeclarator )* )
            // org/asdt/core/internal/antlr/as3.g3:265:4: VAR^ variableDeclarator ( COMMA! variableDeclarator )*
            {
            root_0 = (LinkedListTree)adaptor.nil();

            VAR70=(Token)input.LT(1);
            match(input,VAR,FOLLOW_VAR_in_declaration1007); if (failed) return retval;
            if ( backtracking==0 ) {
            VAR70_tree = (LinkedListTree)adaptor.create(VAR70);
            root_0 = (LinkedListTree)adaptor.becomeRoot(VAR70_tree, root_0);
            }
            pushFollow(FOLLOW_variableDeclarator_in_declaration1010);
            variableDeclarator71=variableDeclarator();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, variableDeclarator71.tree);
            // org/asdt/core/internal/antlr/as3.g3:266:3: ( COMMA! variableDeclarator )*
            loop22:
            do {
                int alt22=2;
                int LA22_0 = input.LA(1);
                if ( (LA22_0==COMMA) ) {
                    alt22=1;
                }


                switch (alt22) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:266:4: COMMA! variableDeclarator
            	    {
            	    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

            	    COMMA72=(Token)input.LT(1);
            	    match(input,COMMA,FOLLOW_COMMA_in_declaration1015); if (failed) return retval;
            	    pushFollow(FOLLOW_variableDeclarator_in_declaration1018);
            	    variableDeclarator73=variableDeclarator();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_1, variableDeclarator73.tree);

            	    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

            	    }
            	    break;

            	default :
            	    break loop22;
                }
            } while (true);


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end declaration

    public static class variableInitializer_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start variableInitializer
    // org/asdt/core/internal/antlr/as3.g3:268:1: variableInitializer : ASSIGN^ expression ;
    public variableInitializer_return variableInitializer() throws RecognitionException {   
        variableInitializer_return retval = new variableInitializer_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token ASSIGN74=null;
        expression_return expression75 = null;


        LinkedListTree ASSIGN74_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:269:4: ( ASSIGN^ expression )
            // org/asdt/core/internal/antlr/as3.g3:269:4: ASSIGN^ expression
            {
            root_0 = (LinkedListTree)adaptor.nil();

            ASSIGN74=(Token)input.LT(1);
            match(input,ASSIGN,FOLLOW_ASSIGN_in_variableInitializer1030); if (failed) return retval;
            if ( backtracking==0 ) {
            ASSIGN74_tree = (LinkedListTree)adaptor.create(ASSIGN74);
            root_0 = (LinkedListTree)adaptor.becomeRoot(ASSIGN74_tree, root_0);
            }
            pushFollow(FOLLOW_expression_in_variableInitializer1033);
            expression75=expression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, expression75.tree);

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end variableInitializer

    public static class parameterDeclarationList_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start parameterDeclarationList
    // org/asdt/core/internal/antlr/as3.g3:273:1: parameterDeclarationList : LPAREN ( parameterDeclaration ( COMMA parameterDeclaration )* )? RPAREN -> ^( PARAMS ( parameterDeclaration )* ) ;
    public parameterDeclarationList_return parameterDeclarationList() throws RecognitionException {   
        parameterDeclarationList_return retval = new parameterDeclarationList_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token LPAREN76=null;
        Token COMMA78=null;
        Token RPAREN80=null;
        parameterDeclaration_return parameterDeclaration77 = null;

        parameterDeclaration_return parameterDeclaration79 = null;

        List list_parameterDeclaration=new ArrayList();
        List list_COMMA=new ArrayList();
        List list_RPAREN=new ArrayList();
        List list_LPAREN=new ArrayList();
        LinkedListTree LPAREN76_tree=null;
        LinkedListTree COMMA78_tree=null;
        LinkedListTree RPAREN80_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:274:4: ( LPAREN ( parameterDeclaration ( COMMA parameterDeclaration )* )? RPAREN -> ^( PARAMS ( parameterDeclaration )* ) )
            // org/asdt/core/internal/antlr/as3.g3:274:4: LPAREN ( parameterDeclaration ( COMMA parameterDeclaration )* )? RPAREN
            {
            LPAREN76=(Token)input.LT(1);
            match(input,LPAREN,FOLLOW_LPAREN_in_parameterDeclarationList1046); if (failed) return retval;
            if ( backtracking==0 ) list_LPAREN.add(LPAREN76);

            // org/asdt/core/internal/antlr/as3.g3:275:3: ( parameterDeclaration ( COMMA parameterDeclaration )* )?
            int alt24=2;
            int LA24_0 = input.LA(1);
            if ( (LA24_0==IDENT||LA24_0==CONST||LA24_0==REST) ) {
                alt24=1;
            }
            switch (alt24) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:275:5: parameterDeclaration ( COMMA parameterDeclaration )*
                    {
                    pushFollow(FOLLOW_parameterDeclaration_in_parameterDeclarationList1052);
                    parameterDeclaration77=parameterDeclaration();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) list_parameterDeclaration.add(parameterDeclaration77.tree);
                    // org/asdt/core/internal/antlr/as3.g3:276:4: ( COMMA parameterDeclaration )*
                    loop23:
                    do {
                        int alt23=2;
                        int LA23_0 = input.LA(1);
                        if ( (LA23_0==COMMA) ) {
                            alt23=1;
                        }


                        switch (alt23) {
                    	case 1 :
                    	    // org/asdt/core/internal/antlr/as3.g3:276:5: COMMA parameterDeclaration
                    	    {
                    	    COMMA78=(Token)input.LT(1);
                    	    match(input,COMMA,FOLLOW_COMMA_in_parameterDeclarationList1058); if (failed) return retval;
                    	    if ( backtracking==0 ) list_COMMA.add(COMMA78);

                    	    pushFollow(FOLLOW_parameterDeclaration_in_parameterDeclarationList1060);
                    	    parameterDeclaration79=parameterDeclaration();
                    	    _fsp--;
                    	    if (failed) return retval;
                    	    if ( backtracking==0 ) list_parameterDeclaration.add(parameterDeclaration79.tree);

                    	    }
                    	    break;

                    	default :
                    	    break loop23;
                        }
                    } while (true);


                    }
                    break;

            }

            RPAREN80=(Token)input.LT(1);
            match(input,RPAREN,FOLLOW_RPAREN_in_parameterDeclarationList1071); if (failed) return retval;
            if ( backtracking==0 ) list_RPAREN.add(RPAREN80);


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 279:3: -> ^( PARAMS ( parameterDeclaration )* )
            {
                // org/asdt/core/internal/antlr/as3.g3:279:6: ^( PARAMS ( parameterDeclaration )* )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(PARAMS, "PARAMS"), root_1);

                // org/asdt/core/internal/antlr/as3.g3:279:15: ( parameterDeclaration )*
                {
                int n_1 = list_parameterDeclaration == null ? 0 : list_parameterDeclaration.size();
                 


                for (int i_1=0; i_1<n_1; i_1++) {
                    adaptor.addChild(root_1, list_parameterDeclaration.get(i_1));

                }
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end parameterDeclarationList

    public static class parameterDeclaration_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start parameterDeclaration
    // org/asdt/core/internal/antlr/as3.g3:283:1: parameterDeclaration : ( basicParameterDeclaration | parameterRestDeclaration );
    public parameterDeclaration_return parameterDeclaration() throws RecognitionException {   
        parameterDeclaration_return retval = new parameterDeclaration_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        basicParameterDeclaration_return basicParameterDeclaration81 = null;

        parameterRestDeclaration_return parameterRestDeclaration82 = null;



        try {
            // org/asdt/core/internal/antlr/as3.g3:284:4: ( basicParameterDeclaration | parameterRestDeclaration )
            int alt25=2;
            int LA25_0 = input.LA(1);
            if ( (LA25_0==IDENT||LA25_0==CONST) ) {
                alt25=1;
            }
            else if ( (LA25_0==REST) ) {
                alt25=2;
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("283:1: parameterDeclaration : ( basicParameterDeclaration | parameterRestDeclaration );", 25, 0, input);

                throw nvae;
            }
            switch (alt25) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:284:4: basicParameterDeclaration
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_basicParameterDeclaration_in_parameterDeclaration1094);
                    basicParameterDeclaration81=basicParameterDeclaration();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, basicParameterDeclaration81.tree);

                    }
                    break;
                case 2 :
                    // org/asdt/core/internal/antlr/as3.g3:284:32: parameterRestDeclaration
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_parameterRestDeclaration_in_parameterDeclaration1098);
                    parameterRestDeclaration82=parameterRestDeclaration();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, parameterRestDeclaration82.tree);

                    }
                    break;

            }
        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end parameterDeclaration

    public static class basicParameterDeclaration_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start basicParameterDeclaration
    // org/asdt/core/internal/antlr/as3.g3:287:1: basicParameterDeclaration : ( 'const' )? IDENT typeExpression ( parameterDefault )? -> ^( PARAM ( 'const' )? IDENT typeExpression ( parameterDefault )? ) ;
    public basicParameterDeclaration_return basicParameterDeclaration() throws RecognitionException {   
        basicParameterDeclaration_return retval = new basicParameterDeclaration_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token string_literal83=null;
        Token IDENT84=null;
        typeExpression_return typeExpression85 = null;

        parameterDefault_return parameterDefault86 = null;

        List list_typeExpression=new ArrayList();
        List list_parameterDefault=new ArrayList();
        List list_CONST=new ArrayList();
        List list_IDENT=new ArrayList();
        LinkedListTree string_literal83_tree=null;
        LinkedListTree IDENT84_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:288:4: ( ( 'const' )? IDENT typeExpression ( parameterDefault )? -> ^( PARAM ( 'const' )? IDENT typeExpression ( parameterDefault )? ) )
            // org/asdt/core/internal/antlr/as3.g3:288:4: ( 'const' )? IDENT typeExpression ( parameterDefault )?
            {
            // org/asdt/core/internal/antlr/as3.g3:288:4: ( 'const' )?
            int alt26=2;
            int LA26_0 = input.LA(1);
            if ( (LA26_0==CONST) ) {
                alt26=1;
            }
            switch (alt26) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:288:4: 'const'
                    {
                    string_literal83=(Token)input.LT(1);
                    match(input,CONST,FOLLOW_CONST_in_basicParameterDeclaration1109); if (failed) return retval;
                    if ( backtracking==0 ) list_CONST.add(string_literal83);


                    }
                    break;

            }

            IDENT84=(Token)input.LT(1);
            match(input,IDENT,FOLLOW_IDENT_in_basicParameterDeclaration1112); if (failed) return retval;
            if ( backtracking==0 ) list_IDENT.add(IDENT84);

            pushFollow(FOLLOW_typeExpression_in_basicParameterDeclaration1114);
            typeExpression85=typeExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_typeExpression.add(typeExpression85.tree);
            // org/asdt/core/internal/antlr/as3.g3:288:34: ( parameterDefault )?
            int alt27=2;
            int LA27_0 = input.LA(1);
            if ( (LA27_0==ASSIGN) ) {
                alt27=1;
            }
            switch (alt27) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:288:34: parameterDefault
                    {
                    pushFollow(FOLLOW_parameterDefault_in_basicParameterDeclaration1116);
                    parameterDefault86=parameterDefault();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) list_parameterDefault.add(parameterDefault86.tree);

                    }
                    break;

            }


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 289:3: -> ^( PARAM ( 'const' )? IDENT typeExpression ( parameterDefault )? )
            {
                // org/asdt/core/internal/antlr/as3.g3:289:6: ^( PARAM ( 'const' )? IDENT typeExpression ( parameterDefault )? )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(PARAM, "PARAM"), root_1);

                // org/asdt/core/internal/antlr/as3.g3:289:14: ( 'const' )?
                {
                int n_1 = list_CONST == null ? 0 : list_CONST.size();
                 


                if ( n_1 > 1 ) throw new RuntimeException("CONST list has > 1 elements");
                if ( n_1==1 ) {
                    int i_1 = 0;
                    adaptor.addChild(root_1, (Token)list_CONST.get(i_1));

                    }
                }
                adaptor.addChild(root_1, (Token)list_IDENT.get(i_0));
                adaptor.addChild(root_1, list_typeExpression.get(i_0));
                // org/asdt/core/internal/antlr/as3.g3:289:44: ( parameterDefault )?
                {
                int n_1 = list_parameterDefault == null ? 0 : list_parameterDefault.size();
                 


                if ( n_1 > 1 ) throw new RuntimeException("parameterDefault list has > 1 elements");
                if ( n_1==1 ) {
                    int i_1 = 0;
                    adaptor.addChild(root_1, list_parameterDefault.get(i_1));

                    }
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end basicParameterDeclaration

    public static class parameterDefault_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start parameterDefault
    // org/asdt/core/internal/antlr/as3.g3:292:1: parameterDefault : ASSIGN^ assignmentExpression ;
    public parameterDefault_return parameterDefault() throws RecognitionException {   
        parameterDefault_return retval = new parameterDefault_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token ASSIGN87=null;
        assignmentExpression_return assignmentExpression88 = null;


        LinkedListTree ASSIGN87_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:294:4: ( ASSIGN^ assignmentExpression )
            // org/asdt/core/internal/antlr/as3.g3:294:4: ASSIGN^ assignmentExpression
            {
            root_0 = (LinkedListTree)adaptor.nil();

            ASSIGN87=(Token)input.LT(1);
            match(input,ASSIGN,FOLLOW_ASSIGN_in_parameterDefault1149); if (failed) return retval;
            if ( backtracking==0 ) {
            ASSIGN87_tree = (LinkedListTree)adaptor.create(ASSIGN87);
            root_0 = (LinkedListTree)adaptor.becomeRoot(ASSIGN87_tree, root_0);
            }
            pushFollow(FOLLOW_assignmentExpression_in_parameterDefault1152);
            assignmentExpression88=assignmentExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, assignmentExpression88.tree);

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end parameterDefault

    public static class parameterRestDeclaration_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start parameterRestDeclaration
    // org/asdt/core/internal/antlr/as3.g3:297:1: parameterRestDeclaration : REST ( 'const' )? IDENT -> ^( PARAM REST ( 'const' )? IDENT ) ;
    public parameterRestDeclaration_return parameterRestDeclaration() throws RecognitionException {   
        parameterRestDeclaration_return retval = new parameterRestDeclaration_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token REST89=null;
        Token string_literal90=null;
        Token IDENT91=null;
        List list_CONST=new ArrayList();
        List list_REST=new ArrayList();
        List list_IDENT=new ArrayList();
        LinkedListTree REST89_tree=null;
        LinkedListTree string_literal90_tree=null;
        LinkedListTree IDENT91_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:298:4: ( REST ( 'const' )? IDENT -> ^( PARAM REST ( 'const' )? IDENT ) )
            // org/asdt/core/internal/antlr/as3.g3:298:4: REST ( 'const' )? IDENT
            {
            REST89=(Token)input.LT(1);
            match(input,REST,FOLLOW_REST_in_parameterRestDeclaration1163); if (failed) return retval;
            if ( backtracking==0 ) list_REST.add(REST89);

            // org/asdt/core/internal/antlr/as3.g3:298:9: ( 'const' )?
            int alt28=2;
            int LA28_0 = input.LA(1);
            if ( (LA28_0==CONST) ) {
                alt28=1;
            }
            switch (alt28) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:298:9: 'const'
                    {
                    string_literal90=(Token)input.LT(1);
                    match(input,CONST,FOLLOW_CONST_in_parameterRestDeclaration1165); if (failed) return retval;
                    if ( backtracking==0 ) list_CONST.add(string_literal90);


                    }
                    break;

            }

            IDENT91=(Token)input.LT(1);
            match(input,IDENT,FOLLOW_IDENT_in_parameterRestDeclaration1168); if (failed) return retval;
            if ( backtracking==0 ) list_IDENT.add(IDENT91);


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 299:3: -> ^( PARAM REST ( 'const' )? IDENT )
            {
                // org/asdt/core/internal/antlr/as3.g3:299:6: ^( PARAM REST ( 'const' )? IDENT )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(PARAM, "PARAM"), root_1);

                adaptor.addChild(root_1, (Token)list_REST.get(i_0));
                // org/asdt/core/internal/antlr/as3.g3:299:19: ( 'const' )?
                {
                int n_1 = list_CONST == null ? 0 : list_CONST.size();
                 


                if ( n_1 > 1 ) throw new RuntimeException("CONST list has > 1 elements");
                if ( n_1==1 ) {
                    int i_1 = 0;
                    adaptor.addChild(root_1, (Token)list_CONST.get(i_1));

                    }
                }
                adaptor.addChild(root_1, (Token)list_IDENT.get(i_0));

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end parameterRestDeclaration

    public static class block_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start block
    // org/asdt/core/internal/antlr/as3.g3:301:1: block : LCURLY ( statement )* RCURLY -> ^( BLOCK ( statement )* ) ;
    public block_return block() throws RecognitionException {   
        block_return retval = new block_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token LCURLY92=null;
        Token RCURLY94=null;
        statement_return statement93 = null;

        List list_statement=new ArrayList();
        List list_RCURLY=new ArrayList();
        List list_LCURLY=new ArrayList();
        LinkedListTree LCURLY92_tree=null;
        LinkedListTree RCURLY94_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:302:4: ( LCURLY ( statement )* RCURLY -> ^( BLOCK ( statement )* ) )
            // org/asdt/core/internal/antlr/as3.g3:302:4: LCURLY ( statement )* RCURLY
            {
            LCURLY92=(Token)input.LT(1);
            match(input,LCURLY,FOLLOW_LCURLY_in_block1193); if (failed) return retval;
            if ( backtracking==0 ) list_LCURLY.add(LCURLY92);

            // org/asdt/core/internal/antlr/as3.g3:302:11: ( statement )*
            loop29:
            do {
                int alt29=2;
                int LA29_0 = input.LA(1);
                if ( (LA29_0==LCURLY||LA29_0==SEMI||LA29_0==IDENT||(LA29_0>=FUNCTION && LA29_0<=VAR)||LA29_0==LPAREN||(LA29_0>=WHILE && LA29_0<=IF)||LA29_0==SWITCH||(LA29_0>=DEFAULT && LA29_0<=FOR)||LA29_0==LBRACK||LA29_0==LT||(LA29_0>=PLUS && LA29_0<=MINUS)||(LA29_0>=INC && LA29_0<=BNOT)||(LA29_0>=STRING_LITERAL && LA29_0<=FLOAT_LITERAL)||(LA29_0>=144 && LA29_0<=146)||(LA29_0>=149 && LA29_0<=152)||(LA29_0>=162 && LA29_0<=166)) ) {
                    alt29=1;
                }


                switch (alt29) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:302:12: statement
            	    {
            	    pushFollow(FOLLOW_statement_in_block1196);
            	    statement93=statement();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) list_statement.add(statement93.tree);

            	    }
            	    break;

            	default :
            	    break loop29;
                }
            } while (true);

            RCURLY94=(Token)input.LT(1);
            match(input,RCURLY,FOLLOW_RCURLY_in_block1200); if (failed) return retval;
            if ( backtracking==0 ) list_RCURLY.add(RCURLY94);


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 303:3: -> ^( BLOCK ( statement )* )
            {
                // org/asdt/core/internal/antlr/as3.g3:303:6: ^( BLOCK ( statement )* )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(BLOCK, "BLOCK"), root_1);

                // org/asdt/core/internal/antlr/as3.g3:303:14: ( statement )*
                {
                int n_1 = list_statement == null ? 0 : list_statement.size();
                 


                for (int i_1=0; i_1<n_1; i_1++) {
                    adaptor.addChild(root_1, list_statement.get(i_1));

                }
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end block

    public static class condition_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start condition
    // org/asdt/core/internal/antlr/as3.g3:306:1: condition : LPAREN! expression RPAREN! ;
    public condition_return condition() throws RecognitionException {   
        condition_return retval = new condition_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token LPAREN95=null;
        Token RPAREN97=null;
        expression_return expression96 = null;


        LinkedListTree LPAREN95_tree=null;
        LinkedListTree RPAREN97_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:307:4: ( LPAREN! expression RPAREN! )
            // org/asdt/core/internal/antlr/as3.g3:307:4: LPAREN! expression RPAREN!
            {
            root_0 = (LinkedListTree)adaptor.nil();

            LPAREN95=(Token)input.LT(1);
            match(input,LPAREN,FOLLOW_LPAREN_in_condition1222); if (failed) return retval;
            pushFollow(FOLLOW_expression_in_condition1225);
            expression96=expression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, expression96.tree);
            RPAREN97=(Token)input.LT(1);
            match(input,RPAREN,FOLLOW_RPAREN_in_condition1227); if (failed) return retval;

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end condition

    public static class statement_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start statement
    // org/asdt/core/internal/antlr/as3.g3:310:1: statement : ({...}? ( block ) | declarationStatement | expressionStatement | ifStatement | forEachStatement | forStatement | WHILE condition statement | DO statement WHILE! condition | 'with' condition statement | switchStatement | breakStatement | continueStatement | returnStatement | throwStatement | tryStatement | defaultXMLNamespaceStatement | SEMI! );
    public statement_return statement() throws RecognitionException {   
        statement_return retval = new statement_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token WHILE104=null;
        Token DO107=null;
        Token WHILE109=null;
        Token string_literal111=null;
        Token SEMI121=null;
        block_return block98 = null;

        declarationStatement_return declarationStatement99 = null;

        expressionStatement_return expressionStatement100 = null;

        ifStatement_return ifStatement101 = null;

        forEachStatement_return forEachStatement102 = null;

        forStatement_return forStatement103 = null;

        condition_return condition105 = null;

        statement_return statement106 = null;

        statement_return statement108 = null;

        condition_return condition110 = null;

        condition_return condition112 = null;

        statement_return statement113 = null;

        switchStatement_return switchStatement114 = null;

        breakStatement_return breakStatement115 = null;

        continueStatement_return continueStatement116 = null;

        returnStatement_return returnStatement117 = null;

        throwStatement_return throwStatement118 = null;

        tryStatement_return tryStatement119 = null;

        defaultXMLNamespaceStatement_return defaultXMLNamespaceStatement120 = null;


        LinkedListTree WHILE104_tree=null;
        LinkedListTree DO107_tree=null;
        LinkedListTree WHILE109_tree=null;
        LinkedListTree string_literal111_tree=null;
        LinkedListTree SEMI121_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:311:4: ({...}? ( block ) | declarationStatement | expressionStatement | ifStatement | forEachStatement | forStatement | WHILE condition statement | DO statement WHILE! condition | 'with' condition statement | switchStatement | breakStatement | continueStatement | returnStatement | throwStatement | tryStatement | defaultXMLNamespaceStatement | SEMI! )
            int alt30=17;
            switch ( input.LA(1) ) {
            case LCURLY:
                switch ( input.LA(2) ) {
                case LCURLY:
                case SEMI:
                case FUNCTION:
                case VAR:
                case LPAREN:
                case WHILE:
                case DO:
                case IF:
                case SWITCH:
                case DEFAULT:
                case FOR:
                case LBRACK:
                case LT:
                case PLUS:
                case MINUS:
                case INC:
                case DEC:
                case LNOT:
                case BNOT:
                case STRING_LITERAL:
                case TRUE:
                case FALSE:
                case 144:
                case 145:
                case 146:
                case 149:
                case 150:
                case 151:
                case 152:
                case 162:
                case 163:
                case 164:
                case 165:
                case 166:
                    alt30=1;
                    break;
                case IDENT:
                    if ( (input.LA(1)==LCURLY) ) {
                        alt30=1;
                    }
                    else if ( (true) ) {
                        alt30=3;
                    }
                    else {
                        if (backtracking>0) {failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("310:1: statement : ({...}? ( block ) | declarationStatement | expressionStatement | ifStatement | forEachStatement | forStatement | WHILE condition statement | DO statement WHILE! condition | 'with' condition statement | switchStatement | breakStatement | continueStatement | returnStatement | throwStatement | tryStatement | defaultXMLNamespaceStatement | SEMI! );", 30, 48, input);

                        throw nvae;
                    }
                    break;
                case HEX_LITERAL:
                case DECIMAL_LITERAL:
                case OCTAL_LITERAL:
                case FLOAT_LITERAL:
                    if ( (input.LA(1)==LCURLY) ) {
                        alt30=1;
                    }
                    else if ( (true) ) {
                        alt30=3;
                    }
                    else {
                        if (backtracking>0) {failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("310:1: statement : ({...}? ( block ) | declarationStatement | expressionStatement | ifStatement | forEachStatement | forStatement | WHILE condition statement | DO statement WHILE! condition | 'with' condition statement | switchStatement | breakStatement | continueStatement | returnStatement | throwStatement | tryStatement | defaultXMLNamespaceStatement | SEMI! );", 30, 52, input);

                        throw nvae;
                    }
                    break;
                case RCURLY:
                    if ( (input.LA(1)==LCURLY) ) {
                        alt30=1;
                    }
                    else if ( (true) ) {
                        alt30=3;
                    }
                    else {
                        if (backtracking>0) {failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("310:1: statement : ({...}? ( block ) | declarationStatement | expressionStatement | ifStatement | forEachStatement | forStatement | WHILE condition statement | DO statement WHILE! condition | 'with' condition statement | switchStatement | breakStatement | continueStatement | returnStatement | throwStatement | tryStatement | defaultXMLNamespaceStatement | SEMI! );", 30, 73, input);

                        throw nvae;
                    }
                    break;
                default:
                    if (backtracking>0) {failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("310:1: statement : ({...}? ( block ) | declarationStatement | expressionStatement | ifStatement | forEachStatement | forStatement | WHILE condition statement | DO statement WHILE! condition | 'with' condition statement | switchStatement | breakStatement | continueStatement | returnStatement | throwStatement | tryStatement | defaultXMLNamespaceStatement | SEMI! );", 30, 1, input);

                    throw nvae;
                }

                break;
            case VAR:
                alt30=2;
                break;
            case IDENT:
            case FUNCTION:
            case LPAREN:
            case LBRACK:
            case LT:
            case PLUS:
            case MINUS:
            case INC:
            case DEC:
            case LNOT:
            case BNOT:
            case STRING_LITERAL:
            case TRUE:
            case FALSE:
            case HEX_LITERAL:
            case DECIMAL_LITERAL:
            case OCTAL_LITERAL:
            case FLOAT_LITERAL:
            case 152:
            case 162:
            case 163:
            case 164:
            case 165:
            case 166:
                alt30=3;
                break;
            case IF:
                alt30=4;
                break;
            case FOR:
                int LA30_25 = input.LA(2);
                if ( (LA30_25==EACH) ) {
                    alt30=5;
                }
                else if ( (LA30_25==LPAREN) ) {
                    alt30=6;
                }
                else {
                    if (backtracking>0) {failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("310:1: statement : ({...}? ( block ) | declarationStatement | expressionStatement | ifStatement | forEachStatement | forStatement | WHILE condition statement | DO statement WHILE! condition | 'with' condition statement | switchStatement | breakStatement | continueStatement | returnStatement | throwStatement | tryStatement | defaultXMLNamespaceStatement | SEMI! );", 30, 25, input);

                    throw nvae;
                }
                break;
            case WHILE:
                alt30=7;
                break;
            case DO:
                alt30=8;
                break;
            case 144:
                alt30=9;
                break;
            case SWITCH:
                alt30=10;
                break;
            case 151:
                alt30=11;
                break;
            case 150:
                alt30=12;
                break;
            case 149:
                alt30=13;
                break;
            case 145:
                alt30=14;
                break;
            case 146:
                alt30=15;
                break;
            case DEFAULT:
                alt30=16;
                break;
            case SEMI:
                alt30=17;
                break;
            default:
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("310:1: statement : ({...}? ( block ) | declarationStatement | expressionStatement | ifStatement | forEachStatement | forStatement | WHILE condition statement | DO statement WHILE! condition | 'with' condition statement | switchStatement | breakStatement | continueStatement | returnStatement | throwStatement | tryStatement | defaultXMLNamespaceStatement | SEMI! );", 30, 0, input);

                throw nvae;
            }

            switch (alt30) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:311:4: {...}? ( block )
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    if ( !(input.LA(1)==LCURLY) ) {
                        if (backtracking>0) {failed=true; return retval;}
                        throw new FailedPredicateException(input, "statement", "input.LA(1)==LCURLY");
                    }
                    // org/asdt/core/internal/antlr/as3.g3:311:26: ( block )
                    // org/asdt/core/internal/antlr/as3.g3:311:27: block
                    {
                    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_block_in_statement1241);
                    block98=block();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_1, block98.tree);

                    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    }


                    }
                    break;
                case 2 :
                    // org/asdt/core/internal/antlr/as3.g3:312:4: declarationStatement
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_declarationStatement_in_statement1247);
                    declarationStatement99=declarationStatement();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, declarationStatement99.tree);

                    }
                    break;
                case 3 :
                    // org/asdt/core/internal/antlr/as3.g3:313:4: expressionStatement
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_expressionStatement_in_statement1252);
                    expressionStatement100=expressionStatement();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, expressionStatement100.tree);

                    }
                    break;
                case 4 :
                    // org/asdt/core/internal/antlr/as3.g3:314:4: ifStatement
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_ifStatement_in_statement1257);
                    ifStatement101=ifStatement();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, ifStatement101.tree);

                    }
                    break;
                case 5 :
                    // org/asdt/core/internal/antlr/as3.g3:316:4: forEachStatement
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_forEachStatement_in_statement1264);
                    forEachStatement102=forEachStatement();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, forEachStatement102.tree);

                    }
                    break;
                case 6 :
                    // org/asdt/core/internal/antlr/as3.g3:317:4: forStatement
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_forStatement_in_statement1269);
                    forStatement103=forStatement();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, forStatement103.tree);

                    }
                    break;
                case 7 :
                    // org/asdt/core/internal/antlr/as3.g3:320:4: WHILE condition statement
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    WHILE104=(Token)input.LT(1);
                    match(input,WHILE,FOLLOW_WHILE_in_statement1277); if (failed) return retval;
                    if ( backtracking==0 ) {
                    WHILE104_tree = (LinkedListTree)adaptor.create(WHILE104);
                    adaptor.addChild(root_0, WHILE104_tree);
                    }
                    pushFollow(FOLLOW_condition_in_statement1279);
                    condition105=condition();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, condition105.tree);
                    pushFollow(FOLLOW_statement_in_statement1281);
                    statement106=statement();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, statement106.tree);

                    }
                    break;
                case 8 :
                    // org/asdt/core/internal/antlr/as3.g3:323:4: DO statement WHILE! condition
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    DO107=(Token)input.LT(1);
                    match(input,DO,FOLLOW_DO_in_statement1289); if (failed) return retval;
                    if ( backtracking==0 ) {
                    DO107_tree = (LinkedListTree)adaptor.create(DO107);
                    adaptor.addChild(root_0, DO107_tree);
                    }
                    pushFollow(FOLLOW_statement_in_statement1291);
                    statement108=statement();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, statement108.tree);
                    WHILE109=(Token)input.LT(1);
                    match(input,WHILE,FOLLOW_WHILE_in_statement1293); if (failed) return retval;
                    pushFollow(FOLLOW_condition_in_statement1296);
                    condition110=condition();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, condition110.tree);

                    }
                    break;
                case 9 :
                    // org/asdt/core/internal/antlr/as3.g3:326:4: 'with' condition statement
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    string_literal111=(Token)input.LT(1);
                    match(input,144,FOLLOW_144_in_statement1305); if (failed) return retval;
                    if ( backtracking==0 ) {
                    string_literal111_tree = (LinkedListTree)adaptor.create(string_literal111);
                    adaptor.addChild(root_0, string_literal111_tree);
                    }
                    pushFollow(FOLLOW_condition_in_statement1307);
                    condition112=condition();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, condition112.tree);
                    pushFollow(FOLLOW_statement_in_statement1309);
                    statement113=statement();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, statement113.tree);

                    }
                    break;
                case 10 :
                    // org/asdt/core/internal/antlr/as3.g3:329:4: switchStatement
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_switchStatement_in_statement1318);
                    switchStatement114=switchStatement();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, switchStatement114.tree);

                    }
                    break;
                case 11 :
                    // org/asdt/core/internal/antlr/as3.g3:332:4: breakStatement
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_breakStatement_in_statement1327);
                    breakStatement115=breakStatement();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, breakStatement115.tree);

                    }
                    break;
                case 12 :
                    // org/asdt/core/internal/antlr/as3.g3:335:4: continueStatement
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_continueStatement_in_statement1335);
                    continueStatement116=continueStatement();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, continueStatement116.tree);

                    }
                    break;
                case 13 :
                    // org/asdt/core/internal/antlr/as3.g3:338:4: returnStatement
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_returnStatement_in_statement1343);
                    returnStatement117=returnStatement();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, returnStatement117.tree);

                    }
                    break;
                case 14 :
                    // org/asdt/core/internal/antlr/as3.g3:341:4: throwStatement
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_throwStatement_in_statement1351);
                    throwStatement118=throwStatement();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, throwStatement118.tree);

                    }
                    break;
                case 15 :
                    // org/asdt/core/internal/antlr/as3.g3:344:4: tryStatement
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_tryStatement_in_statement1360);
                    tryStatement119=tryStatement();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, tryStatement119.tree);

                    }
                    break;
                case 16 :
                    // org/asdt/core/internal/antlr/as3.g3:347:4: defaultXMLNamespaceStatement
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_defaultXMLNamespaceStatement_in_statement1369);
                    defaultXMLNamespaceStatement120=defaultXMLNamespaceStatement();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, defaultXMLNamespaceStatement120.tree);

                    }
                    break;
                case 17 :
                    // org/asdt/core/internal/antlr/as3.g3:350:4: SEMI!
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    SEMI121=(Token)input.LT(1);
                    match(input,SEMI,FOLLOW_SEMI_in_statement1377); if (failed) return retval;

                    }
                    break;

            }
        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end statement

    public static class declarationStatement_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start declarationStatement
    // org/asdt/core/internal/antlr/as3.g3:353:1: declarationStatement : declaration ({...}? SEMI! )? ;
    public declarationStatement_return declarationStatement() throws RecognitionException {   
        declarationStatement_return retval = new declarationStatement_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token SEMI123=null;
        declaration_return declaration122 = null;


        LinkedListTree SEMI123_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:354:4: ( declaration ({...}? SEMI! )? )
            // org/asdt/core/internal/antlr/as3.g3:354:4: declaration ({...}? SEMI! )?
            {
            root_0 = (LinkedListTree)adaptor.nil();

            pushFollow(FOLLOW_declaration_in_declarationStatement1389);
            declaration122=declaration();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, declaration122.tree);
            // org/asdt/core/internal/antlr/as3.g3:354:16: ({...}? SEMI! )?
            int alt31=2;
            int LA31_0 = input.LA(1);
            if ( (LA31_0==SEMI) ) {
                if ( (input.LA(1)==SEMI) ) {
                    alt31=1;
                }
            }
            switch (alt31) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:354:17: {...}? SEMI!
                    {
                    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    if ( !(input.LA(1)==SEMI) ) {
                        if (backtracking>0) {failed=true; return retval;}
                        throw new FailedPredicateException(input, "declarationStatement", "input.LA(1)==SEMI");
                    }
                    SEMI123=(Token)input.LT(1);
                    match(input,SEMI,FOLLOW_SEMI_in_declarationStatement1393); if (failed) return retval;

                    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    }
                    break;

            }


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end declarationStatement

    public static class expressionStatement_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start expressionStatement
    // org/asdt/core/internal/antlr/as3.g3:357:1: expressionStatement : assignmentExpression ({...}? SEMI )? -> ^( EXPR_STMNT assignmentExpression ) ;
    public expressionStatement_return expressionStatement() throws RecognitionException {   
        expressionStatement_return retval = new expressionStatement_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token SEMI125=null;
        assignmentExpression_return assignmentExpression124 = null;

        List list_assignmentExpression=new ArrayList();
        List list_SEMI=new ArrayList();
        LinkedListTree SEMI125_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:358:4: ( assignmentExpression ({...}? SEMI )? -> ^( EXPR_STMNT assignmentExpression ) )
            // org/asdt/core/internal/antlr/as3.g3:358:4: assignmentExpression ({...}? SEMI )?
            {
            pushFollow(FOLLOW_assignmentExpression_in_expressionStatement1407);
            assignmentExpression124=assignmentExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_assignmentExpression.add(assignmentExpression124.tree);
            // org/asdt/core/internal/antlr/as3.g3:358:25: ({...}? SEMI )?
            int alt32=2;
            int LA32_0 = input.LA(1);
            if ( (LA32_0==SEMI) ) {
                if ( (input.LA(1)==SEMI) ) {
                    alt32=1;
                }
            }
            switch (alt32) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:358:26: {...}? SEMI
                    {
                    if ( !(input.LA(1)==SEMI) ) {
                        if (backtracking>0) {failed=true; return retval;}
                        throw new FailedPredicateException(input, "expressionStatement", "input.LA(1)==SEMI");
                    }
                    SEMI125=(Token)input.LT(1);
                    match(input,SEMI,FOLLOW_SEMI_in_expressionStatement1411); if (failed) return retval;
                    if ( backtracking==0 ) list_SEMI.add(SEMI125);


                    }
                    break;

            }


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 359:3: -> ^( EXPR_STMNT assignmentExpression )
            {
                // org/asdt/core/internal/antlr/as3.g3:359:6: ^( EXPR_STMNT assignmentExpression )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(EXPR_STMNT, "EXPR_STMNT"), root_1);

                adaptor.addChild(root_1, list_assignmentExpression.get(i_0));

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end expressionStatement

    public static class ifStatement_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start ifStatement
    // org/asdt/core/internal/antlr/as3.g3:362:1: ifStatement : IF^ condition statement ( ELSE statement )? ;
    public ifStatement_return ifStatement() throws RecognitionException {   
        ifStatement_return retval = new ifStatement_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token IF126=null;
        Token ELSE129=null;
        condition_return condition127 = null;

        statement_return statement128 = null;

        statement_return statement130 = null;


        LinkedListTree IF126_tree=null;
        LinkedListTree ELSE129_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:363:4: ( IF^ condition statement ( ELSE statement )? )
            // org/asdt/core/internal/antlr/as3.g3:363:4: IF^ condition statement ( ELSE statement )?
            {
            root_0 = (LinkedListTree)adaptor.nil();

            IF126=(Token)input.LT(1);
            match(input,IF,FOLLOW_IF_in_ifStatement1435); if (failed) return retval;
            if ( backtracking==0 ) {
            IF126_tree = (LinkedListTree)adaptor.create(IF126);
            root_0 = (LinkedListTree)adaptor.becomeRoot(IF126_tree, root_0);
            }
            pushFollow(FOLLOW_condition_in_ifStatement1438);
            condition127=condition();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, condition127.tree);
            pushFollow(FOLLOW_statement_in_ifStatement1440);
            statement128=statement();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, statement128.tree);
            // org/asdt/core/internal/antlr/as3.g3:364:3: ( ELSE statement )?
            int alt33=2;
            int LA33_0 = input.LA(1);
            if ( (LA33_0==ELSE) ) {
                alt33=1;
            }
            switch (alt33) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:364:4: ELSE statement
                    {
                    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    ELSE129=(Token)input.LT(1);
                    match(input,ELSE,FOLLOW_ELSE_in_ifStatement1445); if (failed) return retval;
                    if ( backtracking==0 ) {
                    ELSE129_tree = (LinkedListTree)adaptor.create(ELSE129);
                    adaptor.addChild(root_1, ELSE129_tree);
                    }
                    pushFollow(FOLLOW_statement_in_ifStatement1447);
                    statement130=statement();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_1, statement130.tree);

                    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    }
                    break;

            }


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end ifStatement

    public static class throwStatement_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start throwStatement
    // org/asdt/core/internal/antlr/as3.g3:367:1: throwStatement : 'throw'^ expression ({...}? SEMI! )? ;
    public throwStatement_return throwStatement() throws RecognitionException {   
        throwStatement_return retval = new throwStatement_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token string_literal131=null;
        Token SEMI133=null;
        expression_return expression132 = null;


        LinkedListTree string_literal131_tree=null;
        LinkedListTree SEMI133_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:368:4: ( 'throw'^ expression ({...}? SEMI! )? )
            // org/asdt/core/internal/antlr/as3.g3:368:4: 'throw'^ expression ({...}? SEMI! )?
            {
            root_0 = (LinkedListTree)adaptor.nil();

            string_literal131=(Token)input.LT(1);
            match(input,145,FOLLOW_145_in_throwStatement1460); if (failed) return retval;
            if ( backtracking==0 ) {
            string_literal131_tree = (LinkedListTree)adaptor.create(string_literal131);
            root_0 = (LinkedListTree)adaptor.becomeRoot(string_literal131_tree, root_0);
            }
            pushFollow(FOLLOW_expression_in_throwStatement1463);
            expression132=expression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, expression132.tree);
            // org/asdt/core/internal/antlr/as3.g3:368:24: ({...}? SEMI! )?
            int alt34=2;
            int LA34_0 = input.LA(1);
            if ( (LA34_0==SEMI) ) {
                if ( (input.LA(1)==SEMI) ) {
                    alt34=1;
                }
            }
            switch (alt34) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:368:25: {...}? SEMI!
                    {
                    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    if ( !(input.LA(1)==SEMI) ) {
                        if (backtracking>0) {failed=true; return retval;}
                        throw new FailedPredicateException(input, "throwStatement", "input.LA(1)==SEMI");
                    }
                    SEMI133=(Token)input.LT(1);
                    match(input,SEMI,FOLLOW_SEMI_in_throwStatement1467); if (failed) return retval;

                    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    }
                    break;

            }


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end throwStatement

    public static class tryStatement_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start tryStatement
    // org/asdt/core/internal/antlr/as3.g3:371:1: tryStatement : 'try' block ( 'catch' LPAREN! IDENT typeExpression RPAREN! block )? ( 'finally' block )? ;
    public tryStatement_return tryStatement() throws RecognitionException {   
        tryStatement_return retval = new tryStatement_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token string_literal134=null;
        Token string_literal136=null;
        Token LPAREN137=null;
        Token IDENT138=null;
        Token RPAREN140=null;
        Token string_literal142=null;
        block_return block135 = null;

        typeExpression_return typeExpression139 = null;

        block_return block141 = null;

        block_return block143 = null;


        LinkedListTree string_literal134_tree=null;
        LinkedListTree string_literal136_tree=null;
        LinkedListTree LPAREN137_tree=null;
        LinkedListTree IDENT138_tree=null;
        LinkedListTree RPAREN140_tree=null;
        LinkedListTree string_literal142_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:372:4: ( 'try' block ( 'catch' LPAREN! IDENT typeExpression RPAREN! block )? ( 'finally' block )? )
            // org/asdt/core/internal/antlr/as3.g3:372:4: 'try' block ( 'catch' LPAREN! IDENT typeExpression RPAREN! block )? ( 'finally' block )?
            {
            root_0 = (LinkedListTree)adaptor.nil();

            string_literal134=(Token)input.LT(1);
            match(input,146,FOLLOW_146_in_tryStatement1481); if (failed) return retval;
            if ( backtracking==0 ) {
            string_literal134_tree = (LinkedListTree)adaptor.create(string_literal134);
            adaptor.addChild(root_0, string_literal134_tree);
            }
            pushFollow(FOLLOW_block_in_tryStatement1485);
            block135=block();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, block135.tree);
            // org/asdt/core/internal/antlr/as3.g3:374:3: ( 'catch' LPAREN! IDENT typeExpression RPAREN! block )?
            int alt35=2;
            int LA35_0 = input.LA(1);
            if ( (LA35_0==147) ) {
                alt35=1;
            }
            switch (alt35) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:374:5: 'catch' LPAREN! IDENT typeExpression RPAREN! block
                    {
                    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    string_literal136=(Token)input.LT(1);
                    match(input,147,FOLLOW_147_in_tryStatement1491); if (failed) return retval;
                    if ( backtracking==0 ) {
                    string_literal136_tree = (LinkedListTree)adaptor.create(string_literal136);
                    adaptor.addChild(root_1, string_literal136_tree);
                    }
                    LPAREN137=(Token)input.LT(1);
                    match(input,LPAREN,FOLLOW_LPAREN_in_tryStatement1493); if (failed) return retval;
                    IDENT138=(Token)input.LT(1);
                    match(input,IDENT,FOLLOW_IDENT_in_tryStatement1496); if (failed) return retval;
                    if ( backtracking==0 ) {
                    IDENT138_tree = (LinkedListTree)adaptor.create(IDENT138);
                    adaptor.addChild(root_1, IDENT138_tree);
                    }
                    pushFollow(FOLLOW_typeExpression_in_tryStatement1498);
                    typeExpression139=typeExpression();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_1, typeExpression139.tree);
                    RPAREN140=(Token)input.LT(1);
                    match(input,RPAREN,FOLLOW_RPAREN_in_tryStatement1500); if (failed) return retval;
                    pushFollow(FOLLOW_block_in_tryStatement1506);
                    block141=block();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_1, block141.tree);

                    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    }
                    break;

            }

            // org/asdt/core/internal/antlr/as3.g3:377:3: ( 'finally' block )?
            int alt36=2;
            int LA36_0 = input.LA(1);
            if ( (LA36_0==148) ) {
                alt36=1;
            }
            switch (alt36) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:378:4: 'finally' block
                    {
                    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    string_literal142=(Token)input.LT(1);
                    match(input,148,FOLLOW_148_in_tryStatement1520); if (failed) return retval;
                    if ( backtracking==0 ) {
                    string_literal142_tree = (LinkedListTree)adaptor.create(string_literal142);
                    adaptor.addChild(root_1, string_literal142_tree);
                    }
                    pushFollow(FOLLOW_block_in_tryStatement1525);
                    block143=block();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_1, block143.tree);

                    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    }
                    break;

            }


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end tryStatement

    public static class returnStatement_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start returnStatement
    // org/asdt/core/internal/antlr/as3.g3:383:1: returnStatement : 'return'^ ( expression )? SEMI! ;
    public returnStatement_return returnStatement() throws RecognitionException {   
        returnStatement_return retval = new returnStatement_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token string_literal144=null;
        Token SEMI146=null;
        expression_return expression145 = null;


        LinkedListTree string_literal144_tree=null;
        LinkedListTree SEMI146_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:384:4: ( 'return'^ ( expression )? SEMI! )
            // org/asdt/core/internal/antlr/as3.g3:384:4: 'return'^ ( expression )? SEMI!
            {
            root_0 = (LinkedListTree)adaptor.nil();

            string_literal144=(Token)input.LT(1);
            match(input,149,FOLLOW_149_in_returnStatement1541); if (failed) return retval;
            if ( backtracking==0 ) {
            string_literal144_tree = (LinkedListTree)adaptor.create(string_literal144);
            root_0 = (LinkedListTree)adaptor.becomeRoot(string_literal144_tree, root_0);
            }
            // org/asdt/core/internal/antlr/as3.g3:384:14: ( expression )?
            int alt37=2;
            int LA37_0 = input.LA(1);
            if ( (LA37_0==LCURLY||LA37_0==IDENT||LA37_0==FUNCTION||LA37_0==LPAREN||LA37_0==LBRACK||LA37_0==LT||(LA37_0>=PLUS && LA37_0<=MINUS)||(LA37_0>=INC && LA37_0<=BNOT)||(LA37_0>=STRING_LITERAL && LA37_0<=FLOAT_LITERAL)||LA37_0==152||(LA37_0>=162 && LA37_0<=166)) ) {
                alt37=1;
            }
            switch (alt37) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:384:15: expression
                    {
                    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_expression_in_returnStatement1545);
                    expression145=expression();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_1, expression145.tree);

                    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    }
                    break;

            }

            SEMI146=(Token)input.LT(1);
            match(input,SEMI,FOLLOW_SEMI_in_returnStatement1549); if (failed) return retval;

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end returnStatement

    public static class continueStatement_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start continueStatement
    // org/asdt/core/internal/antlr/as3.g3:387:1: continueStatement : 'continue'^ ({...}? ( SEMI! ) )? ;
    public continueStatement_return continueStatement() throws RecognitionException {   
        continueStatement_return retval = new continueStatement_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token string_literal147=null;
        Token SEMI148=null;

        LinkedListTree string_literal147_tree=null;
        LinkedListTree SEMI148_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:388:4: ( 'continue'^ ({...}? ( SEMI! ) )? )
            // org/asdt/core/internal/antlr/as3.g3:388:4: 'continue'^ ({...}? ( SEMI! ) )?
            {
            root_0 = (LinkedListTree)adaptor.nil();

            string_literal147=(Token)input.LT(1);
            match(input,150,FOLLOW_150_in_continueStatement1563); if (failed) return retval;
            if ( backtracking==0 ) {
            string_literal147_tree = (LinkedListTree)adaptor.create(string_literal147);
            root_0 = (LinkedListTree)adaptor.becomeRoot(string_literal147_tree, root_0);
            }
            // org/asdt/core/internal/antlr/as3.g3:388:16: ({...}? ( SEMI! ) )?
            int alt38=2;
            int LA38_0 = input.LA(1);
            if ( (LA38_0==SEMI) ) {
                if ( (input.LA(1)==SEMI) ) {
                    alt38=1;
                }
            }
            switch (alt38) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:388:17: {...}? ( SEMI! )
                    {
                    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    if ( !(input.LA(1)==SEMI) ) {
                        if (backtracking>0) {failed=true; return retval;}
                        throw new FailedPredicateException(input, "continueStatement", "input.LA(1)==SEMI");
                    }
                    // org/asdt/core/internal/antlr/as3.g3:388:37: ( SEMI! )
                    // org/asdt/core/internal/antlr/as3.g3:388:38: SEMI!
                    {
                    LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

                    SEMI148=(Token)input.LT(1);
                    match(input,SEMI,FOLLOW_SEMI_in_continueStatement1569); if (failed) return retval;

                    if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

                    }


                    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    }
                    break;

            }


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end continueStatement

    public static class breakStatement_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start breakStatement
    // org/asdt/core/internal/antlr/as3.g3:391:1: breakStatement : 'break'^ ({...}? ( SEMI! ) )? ;
    public breakStatement_return breakStatement() throws RecognitionException {   
        breakStatement_return retval = new breakStatement_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token string_literal149=null;
        Token SEMI150=null;

        LinkedListTree string_literal149_tree=null;
        LinkedListTree SEMI150_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:392:4: ( 'break'^ ({...}? ( SEMI! ) )? )
            // org/asdt/core/internal/antlr/as3.g3:392:4: 'break'^ ({...}? ( SEMI! ) )?
            {
            root_0 = (LinkedListTree)adaptor.nil();

            string_literal149=(Token)input.LT(1);
            match(input,151,FOLLOW_151_in_breakStatement1584); if (failed) return retval;
            if ( backtracking==0 ) {
            string_literal149_tree = (LinkedListTree)adaptor.create(string_literal149);
            root_0 = (LinkedListTree)adaptor.becomeRoot(string_literal149_tree, root_0);
            }
            // org/asdt/core/internal/antlr/as3.g3:392:13: ({...}? ( SEMI! ) )?
            int alt39=2;
            int LA39_0 = input.LA(1);
            if ( (LA39_0==SEMI) ) {
                if ( (input.LA(1)==SEMI) ) {
                    alt39=1;
                }
            }
            switch (alt39) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:392:14: {...}? ( SEMI! )
                    {
                    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    if ( !(input.LA(1)==SEMI) ) {
                        if (backtracking>0) {failed=true; return retval;}
                        throw new FailedPredicateException(input, "breakStatement", "input.LA(1)==SEMI");
                    }
                    // org/asdt/core/internal/antlr/as3.g3:392:34: ( SEMI! )
                    // org/asdt/core/internal/antlr/as3.g3:392:35: SEMI!
                    {
                    LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

                    SEMI150=(Token)input.LT(1);
                    match(input,SEMI,FOLLOW_SEMI_in_breakStatement1590); if (failed) return retval;

                    if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

                    }


                    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    }
                    break;

            }


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end breakStatement

    public static class switchStatement_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start switchStatement
    // org/asdt/core/internal/antlr/as3.g3:395:1: switchStatement : SWITCH^ condition switchBlock ;
    public switchStatement_return switchStatement() throws RecognitionException {   
        switchStatement_return retval = new switchStatement_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token SWITCH151=null;
        condition_return condition152 = null;

        switchBlock_return switchBlock153 = null;


        LinkedListTree SWITCH151_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:396:4: ( SWITCH^ condition switchBlock )
            // org/asdt/core/internal/antlr/as3.g3:396:4: SWITCH^ condition switchBlock
            {
            root_0 = (LinkedListTree)adaptor.nil();

            SWITCH151=(Token)input.LT(1);
            match(input,SWITCH,FOLLOW_SWITCH_in_switchStatement1605); if (failed) return retval;
            if ( backtracking==0 ) {
            SWITCH151_tree = (LinkedListTree)adaptor.create(SWITCH151);
            root_0 = (LinkedListTree)adaptor.becomeRoot(SWITCH151_tree, root_0);
            }
            pushFollow(FOLLOW_condition_in_switchStatement1608);
            condition152=condition();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, condition152.tree);
            pushFollow(FOLLOW_switchBlock_in_switchStatement1612);
            switchBlock153=switchBlock();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, switchBlock153.tree);

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end switchStatement

    public static class switchBlock_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start switchBlock
    // org/asdt/core/internal/antlr/as3.g3:400:1: switchBlock : LCURLY ( caseStatement )* ( defaultStatement )? RCURLY -> ^( BLOCK ( caseStatement )* ( defaultStatement )? ) ;
    public switchBlock_return switchBlock() throws RecognitionException {   
        switchBlock_return retval = new switchBlock_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token LCURLY154=null;
        Token RCURLY157=null;
        caseStatement_return caseStatement155 = null;

        defaultStatement_return defaultStatement156 = null;

        List list_caseStatement=new ArrayList();
        List list_defaultStatement=new ArrayList();
        List list_RCURLY=new ArrayList();
        List list_LCURLY=new ArrayList();
        LinkedListTree LCURLY154_tree=null;
        LinkedListTree RCURLY157_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:401:4: ( LCURLY ( caseStatement )* ( defaultStatement )? RCURLY -> ^( BLOCK ( caseStatement )* ( defaultStatement )? ) )
            // org/asdt/core/internal/antlr/as3.g3:401:4: LCURLY ( caseStatement )* ( defaultStatement )? RCURLY
            {
            LCURLY154=(Token)input.LT(1);
            match(input,LCURLY,FOLLOW_LCURLY_in_switchBlock1623); if (failed) return retval;
            if ( backtracking==0 ) list_LCURLY.add(LCURLY154);

            // org/asdt/core/internal/antlr/as3.g3:402:3: ( caseStatement )*
            loop40:
            do {
                int alt40=2;
                int LA40_0 = input.LA(1);
                if ( (LA40_0==CASE) ) {
                    alt40=1;
                }


                switch (alt40) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:402:4: caseStatement
            	    {
            	    pushFollow(FOLLOW_caseStatement_in_switchBlock1628);
            	    caseStatement155=caseStatement();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) list_caseStatement.add(caseStatement155.tree);

            	    }
            	    break;

            	default :
            	    break loop40;
                }
            } while (true);

            // org/asdt/core/internal/antlr/as3.g3:403:3: ( defaultStatement )?
            int alt41=2;
            int LA41_0 = input.LA(1);
            if ( (LA41_0==DEFAULT) ) {
                alt41=1;
            }
            switch (alt41) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:403:4: defaultStatement
                    {
                    pushFollow(FOLLOW_defaultStatement_in_switchBlock1635);
                    defaultStatement156=defaultStatement();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) list_defaultStatement.add(defaultStatement156.tree);

                    }
                    break;

            }

            RCURLY157=(Token)input.LT(1);
            match(input,RCURLY,FOLLOW_RCURLY_in_switchBlock1641); if (failed) return retval;
            if ( backtracking==0 ) list_RCURLY.add(RCURLY157);


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 405:3: -> ^( BLOCK ( caseStatement )* ( defaultStatement )? )
            {
                // org/asdt/core/internal/antlr/as3.g3:405:6: ^( BLOCK ( caseStatement )* ( defaultStatement )? )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(BLOCK, "BLOCK"), root_1);

                // org/asdt/core/internal/antlr/as3.g3:405:14: ( caseStatement )*
                {
                int n_1 = list_caseStatement == null ? 0 : list_caseStatement.size();
                 


                for (int i_1=0; i_1<n_1; i_1++) {
                    adaptor.addChild(root_1, list_caseStatement.get(i_1));

                }
                }
                // org/asdt/core/internal/antlr/as3.g3:405:29: ( defaultStatement )?
                {
                int n_1 = list_defaultStatement == null ? 0 : list_defaultStatement.size();
                 


                if ( n_1 > 1 ) throw new RuntimeException("defaultStatement list has > 1 elements");
                if ( n_1==1 ) {
                    int i_1 = 0;
                    adaptor.addChild(root_1, list_defaultStatement.get(i_1));

                    }
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end switchBlock

    public static class caseStatement_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start caseStatement
    // org/asdt/core/internal/antlr/as3.g3:408:1: caseStatement : CASE^ expression COLON! switchStatementList ;
    public caseStatement_return caseStatement() throws RecognitionException {   
        caseStatement_return retval = new caseStatement_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token CASE158=null;
        Token COLON160=null;
        expression_return expression159 = null;

        switchStatementList_return switchStatementList161 = null;


        LinkedListTree CASE158_tree=null;
        LinkedListTree COLON160_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:409:4: ( CASE^ expression COLON! switchStatementList )
            // org/asdt/core/internal/antlr/as3.g3:409:4: CASE^ expression COLON! switchStatementList
            {
            root_0 = (LinkedListTree)adaptor.nil();

            CASE158=(Token)input.LT(1);
            match(input,CASE,FOLLOW_CASE_in_caseStatement1666); if (failed) return retval;
            if ( backtracking==0 ) {
            CASE158_tree = (LinkedListTree)adaptor.create(CASE158);
            root_0 = (LinkedListTree)adaptor.becomeRoot(CASE158_tree, root_0);
            }
            pushFollow(FOLLOW_expression_in_caseStatement1669);
            expression159=expression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, expression159.tree);
            COLON160=(Token)input.LT(1);
            match(input,COLON,FOLLOW_COLON_in_caseStatement1671); if (failed) return retval;
            pushFollow(FOLLOW_switchStatementList_in_caseStatement1674);
            switchStatementList161=switchStatementList();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, switchStatementList161.tree);

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end caseStatement

    public static class defaultStatement_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start defaultStatement
    // org/asdt/core/internal/antlr/as3.g3:412:1: defaultStatement : DEFAULT^ COLON! switchStatementList ;
    public defaultStatement_return defaultStatement() throws RecognitionException {   
        defaultStatement_return retval = new defaultStatement_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token DEFAULT162=null;
        Token COLON163=null;
        switchStatementList_return switchStatementList164 = null;


        LinkedListTree DEFAULT162_tree=null;
        LinkedListTree COLON163_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:413:4: ( DEFAULT^ COLON! switchStatementList )
            // org/asdt/core/internal/antlr/as3.g3:413:4: DEFAULT^ COLON! switchStatementList
            {
            root_0 = (LinkedListTree)adaptor.nil();

            DEFAULT162=(Token)input.LT(1);
            match(input,DEFAULT,FOLLOW_DEFAULT_in_defaultStatement1686); if (failed) return retval;
            if ( backtracking==0 ) {
            DEFAULT162_tree = (LinkedListTree)adaptor.create(DEFAULT162);
            root_0 = (LinkedListTree)adaptor.becomeRoot(DEFAULT162_tree, root_0);
            }
            COLON163=(Token)input.LT(1);
            match(input,COLON,FOLLOW_COLON_in_defaultStatement1689); if (failed) return retval;
            pushFollow(FOLLOW_switchStatementList_in_defaultStatement1692);
            switchStatementList164=switchStatementList();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, switchStatementList164.tree);

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end defaultStatement

    public static class switchStatementList_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start switchStatementList
    // org/asdt/core/internal/antlr/as3.g3:416:1: switchStatementList : ( statement )* -> ^( SWITCH_STATEMENT_LIST ( statement )* ) ;
    public switchStatementList_return switchStatementList() throws RecognitionException {   
        switchStatementList_return retval = new switchStatementList_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        statement_return statement165 = null;

        List list_statement=new ArrayList();

        try {
            // org/asdt/core/internal/antlr/as3.g3:417:4: ( ( statement )* -> ^( SWITCH_STATEMENT_LIST ( statement )* ) )
            // org/asdt/core/internal/antlr/as3.g3:417:4: ( statement )*
            {
            // org/asdt/core/internal/antlr/as3.g3:417:4: ( statement )*
            loop42:
            do {
                int alt42=2;
                int LA42_0 = input.LA(1);
                if ( (LA42_0==DEFAULT) ) {
                    int LA42_1 = input.LA(2);
                    if ( (LA42_1==IDENT) ) {
                        alt42=1;
                    }


                }
                else if ( (LA42_0==LCURLY||LA42_0==SEMI||LA42_0==IDENT||(LA42_0>=FUNCTION && LA42_0<=VAR)||LA42_0==LPAREN||(LA42_0>=WHILE && LA42_0<=IF)||LA42_0==SWITCH||LA42_0==FOR||LA42_0==LBRACK||LA42_0==LT||(LA42_0>=PLUS && LA42_0<=MINUS)||(LA42_0>=INC && LA42_0<=BNOT)||(LA42_0>=STRING_LITERAL && LA42_0<=FLOAT_LITERAL)||(LA42_0>=144 && LA42_0<=146)||(LA42_0>=149 && LA42_0<=152)||(LA42_0>=162 && LA42_0<=166)) ) {
                    alt42=1;
                }


                switch (alt42) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:417:4: statement
            	    {
            	    pushFollow(FOLLOW_statement_in_switchStatementList1703);
            	    statement165=statement();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) list_statement.add(statement165.tree);

            	    }
            	    break;

            	default :
            	    break loop42;
                }
            } while (true);


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 417:15: -> ^( SWITCH_STATEMENT_LIST ( statement )* )
            {
                // org/asdt/core/internal/antlr/as3.g3:417:18: ^( SWITCH_STATEMENT_LIST ( statement )* )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(SWITCH_STATEMENT_LIST, "SWITCH_STATEMENT_LIST"), root_1);

                // org/asdt/core/internal/antlr/as3.g3:417:42: ( statement )*
                {
                int n_1 = list_statement == null ? 0 : list_statement.size();
                 


                for (int i_1=0; i_1<n_1; i_1++) {
                    adaptor.addChild(root_1, list_statement.get(i_1));

                }
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end switchStatementList

    public static class forEachStatement_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start forEachStatement
    // org/asdt/core/internal/antlr/as3.g3:420:1: forEachStatement : FOR EACH forInClause statement -> ^( FOR_EACH forInClause statement ) ;
    public forEachStatement_return forEachStatement() throws RecognitionException {   
        forEachStatement_return retval = new forEachStatement_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token FOR166=null;
        Token EACH167=null;
        forInClause_return forInClause168 = null;

        statement_return statement169 = null;

        List list_forInClause=new ArrayList();
        List list_statement=new ArrayList();
        List list_FOR=new ArrayList();
        List list_EACH=new ArrayList();
        LinkedListTree FOR166_tree=null;
        LinkedListTree EACH167_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:421:4: ( FOR EACH forInClause statement -> ^( FOR_EACH forInClause statement ) )
            // org/asdt/core/internal/antlr/as3.g3:421:4: FOR EACH forInClause statement
            {
            FOR166=(Token)input.LT(1);
            match(input,FOR,FOLLOW_FOR_in_forEachStatement1724); if (failed) return retval;
            if ( backtracking==0 ) list_FOR.add(FOR166);

            EACH167=(Token)input.LT(1);
            match(input,EACH,FOLLOW_EACH_in_forEachStatement1726); if (failed) return retval;
            if ( backtracking==0 ) list_EACH.add(EACH167);

            pushFollow(FOLLOW_forInClause_in_forEachStatement1730);
            forInClause168=forInClause();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_forInClause.add(forInClause168.tree);
            pushFollow(FOLLOW_statement_in_forEachStatement1734);
            statement169=statement();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_statement.add(statement169.tree);

            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 424:3: -> ^( FOR_EACH forInClause statement )
            {
                // org/asdt/core/internal/antlr/as3.g3:424:6: ^( FOR_EACH forInClause statement )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(FOR_EACH, "FOR_EACH"), root_1);

                adaptor.addChild(root_1, list_forInClause.get(i_0));
                adaptor.addChild(root_1, list_statement.get(i_0));

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end forEachStatement

    public static class forStatement_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start forStatement
    // org/asdt/core/internal/antlr/as3.g3:426:1: forStatement : FOR^ ( ( LPAREN forInit SEMI )=> traditionalForClause | forInClause ) statement ;
    public forStatement_return forStatement() throws RecognitionException {   
        forStatement_return retval = new forStatement_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token FOR170=null;
        traditionalForClause_return traditionalForClause171 = null;

        forInClause_return forInClause172 = null;

        statement_return statement173 = null;


        LinkedListTree FOR170_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:427:4: ( FOR^ ( ( LPAREN forInit SEMI )=> traditionalForClause | forInClause ) statement )
            // org/asdt/core/internal/antlr/as3.g3:427:4: FOR^ ( ( LPAREN forInit SEMI )=> traditionalForClause | forInClause ) statement
            {
            root_0 = (LinkedListTree)adaptor.nil();

            FOR170=(Token)input.LT(1);
            match(input,FOR,FOLLOW_FOR_in_forStatement1756); if (failed) return retval;
            if ( backtracking==0 ) {
            FOR170_tree = (LinkedListTree)adaptor.create(FOR170);
            root_0 = (LinkedListTree)adaptor.becomeRoot(FOR170_tree, root_0);
            }
            // org/asdt/core/internal/antlr/as3.g3:428:3: ( ( LPAREN forInit SEMI )=> traditionalForClause | forInClause )
            int alt43=2;
            int LA43_0 = input.LA(1);
            if ( (LA43_0==LPAREN) ) {
                int LA43_1 = input.LA(2);
                if ( (LA43_1==VAR) ) {
                    if ( (synpred1()) ) {
                        alt43=1;
                    }
                    else if ( (true) ) {
                        alt43=2;
                    }
                    else {
                        if (backtracking>0) {failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("428:3: ( ( LPAREN forInit SEMI )=> traditionalForClause | forInClause )", 43, 2, input);

                        throw nvae;
                    }
                }
                else if ( (LA43_1==LCURLY||LA43_1==SEMI||LA43_1==IDENT||LA43_1==FUNCTION||LA43_1==LPAREN||LA43_1==LBRACK||LA43_1==LT||(LA43_1>=PLUS && LA43_1<=MINUS)||(LA43_1>=INC && LA43_1<=BNOT)||(LA43_1>=STRING_LITERAL && LA43_1<=FLOAT_LITERAL)||LA43_1==152||(LA43_1>=162 && LA43_1<=166)) ) {
                    alt43=1;
                }
                else {
                    if (backtracking>0) {failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("428:3: ( ( LPAREN forInit SEMI )=> traditionalForClause | forInClause )", 43, 1, input);

                    throw nvae;
                }
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("428:3: ( ( LPAREN forInit SEMI )=> traditionalForClause | forInClause )", 43, 0, input);

                throw nvae;
            }
            switch (alt43) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:428:5: ( LPAREN forInit SEMI )=> traditionalForClause
                    {
                    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_traditionalForClause_in_forStatement1771);
                    traditionalForClause171=traditionalForClause();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_1, traditionalForClause171.tree);

                    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    }
                    break;
                case 2 :
                    // org/asdt/core/internal/antlr/as3.g3:429:5: forInClause
                    {
                    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_forInClause_in_forStatement1777);
                    forInClause172=forInClause();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_1, forInClause172.tree);

                    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    }
                    break;

            }

            pushFollow(FOLLOW_statement_in_forStatement1785);
            statement173=statement();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, statement173.tree);

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end forStatement

    public static class traditionalForClause_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start traditionalForClause
    // org/asdt/core/internal/antlr/as3.g3:433:1: traditionalForClause : LPAREN! forInit SEMI! forCond SEMI! forIter RPAREN! ;
    public traditionalForClause_return traditionalForClause() throws RecognitionException {   
        traditionalForClause_return retval = new traditionalForClause_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token LPAREN174=null;
        Token SEMI176=null;
        Token SEMI178=null;
        Token RPAREN180=null;
        forInit_return forInit175 = null;

        forCond_return forCond177 = null;

        forIter_return forIter179 = null;


        LinkedListTree LPAREN174_tree=null;
        LinkedListTree SEMI176_tree=null;
        LinkedListTree SEMI178_tree=null;
        LinkedListTree RPAREN180_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:434:4: ( LPAREN! forInit SEMI! forCond SEMI! forIter RPAREN! )
            // org/asdt/core/internal/antlr/as3.g3:434:4: LPAREN! forInit SEMI! forCond SEMI! forIter RPAREN!
            {
            root_0 = (LinkedListTree)adaptor.nil();

            LPAREN174=(Token)input.LT(1);
            match(input,LPAREN,FOLLOW_LPAREN_in_traditionalForClause1801); if (failed) return retval;
            pushFollow(FOLLOW_forInit_in_traditionalForClause1806);
            forInit175=forInit();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, forInit175.tree);
            SEMI176=(Token)input.LT(1);
            match(input,SEMI,FOLLOW_SEMI_in_traditionalForClause1808); if (failed) return retval;
            pushFollow(FOLLOW_forCond_in_traditionalForClause1814);
            forCond177=forCond();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, forCond177.tree);
            SEMI178=(Token)input.LT(1);
            match(input,SEMI,FOLLOW_SEMI_in_traditionalForClause1816); if (failed) return retval;
            pushFollow(FOLLOW_forIter_in_traditionalForClause1822);
            forIter179=forIter();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, forIter179.tree);
            RPAREN180=(Token)input.LT(1);
            match(input,RPAREN,FOLLOW_RPAREN_in_traditionalForClause1829); if (failed) return retval;

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end traditionalForClause

    public static class forInClause_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start forInClause
    // org/asdt/core/internal/antlr/as3.g3:441:1: forInClause : LPAREN! declaration IN expression RPAREN! ;
    public forInClause_return forInClause() throws RecognitionException {   
        forInClause_return retval = new forInClause_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token LPAREN181=null;
        Token IN183=null;
        Token RPAREN185=null;
        declaration_return declaration182 = null;

        expression_return expression184 = null;


        LinkedListTree LPAREN181_tree=null;
        LinkedListTree IN183_tree=null;
        LinkedListTree RPAREN185_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:442:4: ( LPAREN! declaration IN expression RPAREN! )
            // org/asdt/core/internal/antlr/as3.g3:442:4: LPAREN! declaration IN expression RPAREN!
            {
            root_0 = (LinkedListTree)adaptor.nil();

            LPAREN181=(Token)input.LT(1);
            match(input,LPAREN,FOLLOW_LPAREN_in_forInClause1841); if (failed) return retval;
            pushFollow(FOLLOW_declaration_in_forInClause1846);
            declaration182=declaration();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, declaration182.tree);
            IN183=(Token)input.LT(1);
            match(input,IN,FOLLOW_IN_in_forInClause1848); if (failed) return retval;
            if ( backtracking==0 ) {
            IN183_tree = (LinkedListTree)adaptor.create(IN183);
            adaptor.addChild(root_0, IN183_tree);
            }
            pushFollow(FOLLOW_expression_in_forInClause1850);
            expression184=expression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, expression184.tree);
            RPAREN185=(Token)input.LT(1);
            match(input,RPAREN,FOLLOW_RPAREN_in_forInClause1854); if (failed) return retval;

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end forInClause

    public static class forInit_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start forInit
    // org/asdt/core/internal/antlr/as3.g3:447:1: forInit : ( ( declaration )=> declaration | expressionList )? -> ^( FOR_INIT $forInit) ;
    public forInit_return forInit() throws RecognitionException {   
        forInit_return retval = new forInit_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        declaration_return declaration186 = null;

        expressionList_return expressionList187 = null;

        List list_expressionList=new ArrayList();
        List list_declaration=new ArrayList();

        try {
            // org/asdt/core/internal/antlr/as3.g3:448:4: ( ( ( declaration )=> declaration | expressionList )? -> ^( FOR_INIT $forInit) )
            // org/asdt/core/internal/antlr/as3.g3:448:4: ( ( declaration )=> declaration | expressionList )?
            {
            // org/asdt/core/internal/antlr/as3.g3:448:4: ( ( declaration )=> declaration | expressionList )?
            int alt44=3;
            int LA44_0 = input.LA(1);
            if ( (LA44_0==VAR) ) {
                alt44=1;
            }
            else if ( (LA44_0==LCURLY||LA44_0==IDENT||LA44_0==FUNCTION||LA44_0==LPAREN||LA44_0==LBRACK||LA44_0==LT||(LA44_0>=PLUS && LA44_0<=MINUS)||(LA44_0>=INC && LA44_0<=BNOT)||(LA44_0>=STRING_LITERAL && LA44_0<=FLOAT_LITERAL)||LA44_0==152||(LA44_0>=162 && LA44_0<=166)) ) {
                alt44=2;
            }
            switch (alt44) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:448:5: ( declaration )=> declaration
                    {
                    pushFollow(FOLLOW_declaration_in_forInit1873);
                    declaration186=declaration();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) list_declaration.add(declaration186.tree);

                    }
                    break;
                case 2 :
                    // org/asdt/core/internal/antlr/as3.g3:448:35: expressionList
                    {
                    pushFollow(FOLLOW_expressionList_in_forInit1877);
                    expressionList187=expressionList();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) list_expressionList.add(expressionList187.tree);

                    }
                    break;

            }


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 449:3: -> ^( FOR_INIT $forInit)
            {
                // org/asdt/core/internal/antlr/as3.g3:449:6: ^( FOR_INIT $forInit)
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(FOR_INIT, "FOR_INIT"), root_1);

                adaptor.addChild(root_1, retval.tree);

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end forInit

    public static class forCond_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start forCond
    // org/asdt/core/internal/antlr/as3.g3:452:1: forCond : ( expression )? -> ^( FOR_CONDITION ( expression )? ) ;
    public forCond_return forCond() throws RecognitionException {   
        forCond_return retval = new forCond_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        expression_return expression188 = null;

        List list_expression=new ArrayList();

        try {
            // org/asdt/core/internal/antlr/as3.g3:453:4: ( ( expression )? -> ^( FOR_CONDITION ( expression )? ) )
            // org/asdt/core/internal/antlr/as3.g3:453:4: ( expression )?
            {
            // org/asdt/core/internal/antlr/as3.g3:453:4: ( expression )?
            int alt45=2;
            int LA45_0 = input.LA(1);
            if ( (LA45_0==LCURLY||LA45_0==IDENT||LA45_0==FUNCTION||LA45_0==LPAREN||LA45_0==LBRACK||LA45_0==LT||(LA45_0>=PLUS && LA45_0<=MINUS)||(LA45_0>=INC && LA45_0<=BNOT)||(LA45_0>=STRING_LITERAL && LA45_0<=FLOAT_LITERAL)||LA45_0==152||(LA45_0>=162 && LA45_0<=166)) ) {
                alt45=1;
            }
            switch (alt45) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:453:5: expression
                    {
                    pushFollow(FOLLOW_expression_in_forCond1903);
                    expression188=expression();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) list_expression.add(expression188.tree);

                    }
                    break;

            }


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 454:3: -> ^( FOR_CONDITION ( expression )? )
            {
                // org/asdt/core/internal/antlr/as3.g3:454:6: ^( FOR_CONDITION ( expression )? )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(FOR_CONDITION, "FOR_CONDITION"), root_1);

                // org/asdt/core/internal/antlr/as3.g3:454:22: ( expression )?
                {
                int n_1 = list_expression == null ? 0 : list_expression.size();
                 


                if ( n_1 > 1 ) throw new RuntimeException("expression list has > 1 elements");
                if ( n_1==1 ) {
                    int i_1 = 0;
                    adaptor.addChild(root_1, list_expression.get(i_1));

                    }
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end forCond

    public static class forIter_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start forIter
    // org/asdt/core/internal/antlr/as3.g3:457:1: forIter : ( expressionList )? -> ^( FOR_ITERATOR ( expressionList )? ) ;
    public forIter_return forIter() throws RecognitionException {   
        forIter_return retval = new forIter_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        expressionList_return expressionList189 = null;

        List list_expressionList=new ArrayList();

        try {
            // org/asdt/core/internal/antlr/as3.g3:458:4: ( ( expressionList )? -> ^( FOR_ITERATOR ( expressionList )? ) )
            // org/asdt/core/internal/antlr/as3.g3:458:4: ( expressionList )?
            {
            // org/asdt/core/internal/antlr/as3.g3:458:4: ( expressionList )?
            int alt46=2;
            int LA46_0 = input.LA(1);
            if ( (LA46_0==LCURLY||LA46_0==IDENT||LA46_0==FUNCTION||LA46_0==LPAREN||LA46_0==LBRACK||LA46_0==LT||(LA46_0>=PLUS && LA46_0<=MINUS)||(LA46_0>=INC && LA46_0<=BNOT)||(LA46_0>=STRING_LITERAL && LA46_0<=FLOAT_LITERAL)||LA46_0==152||(LA46_0>=162 && LA46_0<=166)) ) {
                alt46=1;
            }
            switch (alt46) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:458:5: expressionList
                    {
                    pushFollow(FOLLOW_expressionList_in_forIter1928);
                    expressionList189=expressionList();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) list_expressionList.add(expressionList189.tree);

                    }
                    break;

            }


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 459:3: -> ^( FOR_ITERATOR ( expressionList )? )
            {
                // org/asdt/core/internal/antlr/as3.g3:459:6: ^( FOR_ITERATOR ( expressionList )? )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(FOR_ITERATOR, "FOR_ITERATOR"), root_1);

                // org/asdt/core/internal/antlr/as3.g3:459:21: ( expressionList )?
                {
                int n_1 = list_expressionList == null ? 0 : list_expressionList.size();
                 


                if ( n_1 > 1 ) throw new RuntimeException("expressionList list has > 1 elements");
                if ( n_1==1 ) {
                    int i_1 = 0;
                    adaptor.addChild(root_1, list_expressionList.get(i_1));

                    }
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end forIter

    public static class defaultXMLNamespaceStatement_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start defaultXMLNamespaceStatement
    // org/asdt/core/internal/antlr/as3.g3:463:1: defaultXMLNamespaceStatement : DEFAULT xmlKeyword namespaceKeyword ASSIGN expression SEMI -> ^( DEFAULT_XML_NAMESPACE expression ) ;
    public defaultXMLNamespaceStatement_return defaultXMLNamespaceStatement() throws RecognitionException {   
        defaultXMLNamespaceStatement_return retval = new defaultXMLNamespaceStatement_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token DEFAULT190=null;
        Token ASSIGN193=null;
        Token SEMI195=null;
        xmlKeyword_return xmlKeyword191 = null;

        namespaceKeyword_return namespaceKeyword192 = null;

        expression_return expression194 = null;

        List list_xmlKeyword=new ArrayList();
        List list_namespaceKeyword=new ArrayList();
        List list_expression=new ArrayList();
        List list_SEMI=new ArrayList();
        List list_DEFAULT=new ArrayList();
        List list_ASSIGN=new ArrayList();
        LinkedListTree DEFAULT190_tree=null;
        LinkedListTree ASSIGN193_tree=null;
        LinkedListTree SEMI195_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:464:4: ( DEFAULT xmlKeyword namespaceKeyword ASSIGN expression SEMI -> ^( DEFAULT_XML_NAMESPACE expression ) )
            // org/asdt/core/internal/antlr/as3.g3:464:4: DEFAULT xmlKeyword namespaceKeyword ASSIGN expression SEMI
            {
            DEFAULT190=(Token)input.LT(1);
            match(input,DEFAULT,FOLLOW_DEFAULT_in_defaultXMLNamespaceStatement1953); if (failed) return retval;
            if ( backtracking==0 ) list_DEFAULT.add(DEFAULT190);

            pushFollow(FOLLOW_xmlKeyword_in_defaultXMLNamespaceStatement1955);
            xmlKeyword191=xmlKeyword();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_xmlKeyword.add(xmlKeyword191.tree);
            pushFollow(FOLLOW_namespaceKeyword_in_defaultXMLNamespaceStatement1957);
            namespaceKeyword192=namespaceKeyword();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_namespaceKeyword.add(namespaceKeyword192.tree);
            ASSIGN193=(Token)input.LT(1);
            match(input,ASSIGN,FOLLOW_ASSIGN_in_defaultXMLNamespaceStatement1959); if (failed) return retval;
            if ( backtracking==0 ) list_ASSIGN.add(ASSIGN193);

            pushFollow(FOLLOW_expression_in_defaultXMLNamespaceStatement1961);
            expression194=expression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_expression.add(expression194.tree);
            SEMI195=(Token)input.LT(1);
            match(input,SEMI,FOLLOW_SEMI_in_defaultXMLNamespaceStatement1963); if (failed) return retval;
            if ( backtracking==0 ) list_SEMI.add(SEMI195);


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 465:3: -> ^( DEFAULT_XML_NAMESPACE expression )
            {
                // org/asdt/core/internal/antlr/as3.g3:465:6: ^( DEFAULT_XML_NAMESPACE expression )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(DEFAULT_XML_NAMESPACE, "DEFAULT_XML_NAMESPACE"), root_1);

                adaptor.addChild(root_1, list_expression.get(i_0));

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end defaultXMLNamespaceStatement

    public static class typeExpression_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start typeExpression
    // org/asdt/core/internal/antlr/as3.g3:469:1: typeExpression : (c= COLON ( identifier | 'void' | STAR ) -> ^( TYPE_SPEC[$c] ( identifier )? ( 'void' )? ( STAR )? ) )? ;
    public typeExpression_return typeExpression() throws RecognitionException {   
        typeExpression_return retval = new typeExpression_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token c=null;
        Token string_literal197=null;
        Token STAR198=null;
        identifier_return identifier196 = null;

        List list_identifier=new ArrayList();
        List list_COLON=new ArrayList();
        List list_152=new ArrayList();
        List list_STAR=new ArrayList();
        LinkedListTree c_tree=null;
        LinkedListTree string_literal197_tree=null;
        LinkedListTree STAR198_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:470:4: ( (c= COLON ( identifier | 'void' | STAR ) -> ^( TYPE_SPEC[$c] ( identifier )? ( 'void' )? ( STAR )? ) )? )
            // org/asdt/core/internal/antlr/as3.g3:470:4: (c= COLON ( identifier | 'void' | STAR ) -> ^( TYPE_SPEC[$c] ( identifier )? ( 'void' )? ( STAR )? ) )?
            {
            // org/asdt/core/internal/antlr/as3.g3:470:4: (c= COLON ( identifier | 'void' | STAR ) -> ^( TYPE_SPEC[$c] ( identifier )? ( 'void' )? ( STAR )? ) )?
            int alt48=2;
            int LA48_0 = input.LA(1);
            if ( (LA48_0==COLON) ) {
                alt48=1;
            }
            switch (alt48) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:470:6: c= COLON ( identifier | 'void' | STAR )
                    {
                    c=(Token)input.LT(1);
                    match(input,COLON,FOLLOW_COLON_in_typeExpression1989); if (failed) return retval;
                    if ( backtracking==0 ) list_COLON.add(c);

                    // org/asdt/core/internal/antlr/as3.g3:472:4: ( identifier | 'void' | STAR )
                    int alt47=3;
                    switch ( input.LA(1) ) {
                    case IDENT:
                        alt47=1;
                        break;
                    case 152:
                        alt47=2;
                        break;
                    case STAR:
                        alt47=3;
                        break;
                    default:
                        if (backtracking>0) {failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("472:4: ( identifier | 'void' | STAR )", 47, 0, input);

                        throw nvae;
                    }

                    switch (alt47) {
                        case 1 :
                            // org/asdt/core/internal/antlr/as3.g3:472:5: identifier
                            {
                            pushFollow(FOLLOW_identifier_in_typeExpression1999);
                            identifier196=identifier();
                            _fsp--;
                            if (failed) return retval;
                            if ( backtracking==0 ) list_identifier.add(identifier196.tree);

                            }
                            break;
                        case 2 :
                            // org/asdt/core/internal/antlr/as3.g3:472:18: 'void'
                            {
                            string_literal197=(Token)input.LT(1);
                            match(input,152,FOLLOW_152_in_typeExpression2003); if (failed) return retval;
                            if ( backtracking==0 ) list_152.add(string_literal197);


                            }
                            break;
                        case 3 :
                            // org/asdt/core/internal/antlr/as3.g3:472:27: STAR
                            {
                            STAR198=(Token)input.LT(1);
                            match(input,STAR,FOLLOW_STAR_in_typeExpression2007); if (failed) return retval;
                            if ( backtracking==0 ) list_STAR.add(STAR198);


                            }
                            break;

                    }


                    // AST REWRITE
                    if ( backtracking==0 ) {
                    int i_0 = 0;
                    retval.tree = root_0;
                    root_0 = (LinkedListTree)adaptor.nil();
                    // 473:4: -> ^( TYPE_SPEC[$c] ( identifier )? ( 'void' )? ( STAR )? )
                    {
                        // org/asdt/core/internal/antlr/as3.g3:473:7: ^( TYPE_SPEC[$c] ( identifier )? ( 'void' )? ( STAR )? )
                        {
                        LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                        root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(TYPE_SPEC, c), root_1);

                        // org/asdt/core/internal/antlr/as3.g3:473:23: ( identifier )?
                        {
                        int n_1 = list_identifier == null ? 0 : list_identifier.size();
                         


                        if ( n_1 > 1 ) throw new RuntimeException("identifier list has > 1 elements");
                        if ( n_1==1 ) {
                            int i_1 = 0;
                            adaptor.addChild(root_1, list_identifier.get(i_1));

                            }
                        }
                        // org/asdt/core/internal/antlr/as3.g3:473:35: ( 'void' )?
                        {
                        int n_1 = list_152 == null ? 0 : list_152.size();
                         


                        if ( n_1 > 1 ) throw new RuntimeException("152 list has > 1 elements");
                        if ( n_1==1 ) {
                            int i_1 = 0;
                            adaptor.addChild(root_1, (Token)list_152.get(i_1));

                            }
                        }
                        // org/asdt/core/internal/antlr/as3.g3:473:43: ( STAR )?
                        {
                        int n_1 = list_STAR == null ? 0 : list_STAR.size();
                         


                        if ( n_1 > 1 ) throw new RuntimeException("STAR list has > 1 elements");
                        if ( n_1==1 ) {
                            int i_1 = 0;
                            adaptor.addChild(root_1, (Token)list_STAR.get(i_1));

                            }
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    }

                    }
                    break;

            }


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end typeExpression

    public static class identifier_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start identifier
    // org/asdt/core/internal/antlr/as3.g3:477:1: identifier : identPart ( options {greedy=true; } : DOT identPart )* -> ^( IDENTIFIER ( identPart )+ ) ;
    public identifier_return identifier() throws RecognitionException {   
        identifier_return retval = new identifier_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token DOT200=null;
        identPart_return identPart199 = null;

        identPart_return identPart201 = null;

        List list_identPart=new ArrayList();
        List list_DOT=new ArrayList();
        LinkedListTree DOT200_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:478:4: ( identPart ( options {greedy=true; } : DOT identPart )* -> ^( IDENTIFIER ( identPart )+ ) )
            // org/asdt/core/internal/antlr/as3.g3:478:4: identPart ( options {greedy=true; } : DOT identPart )*
            {
            pushFollow(FOLLOW_identPart_in_identifier2045);
            identPart199=identPart();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_identPart.add(identPart199.tree);
            // org/asdt/core/internal/antlr/as3.g3:479:3: ( options {greedy=true; } : DOT identPart )*
            loop49:
            do {
                int alt49=2;
                int LA49_0 = input.LA(1);
                if ( (LA49_0==DOT) ) {
                    alt49=1;
                }


                switch (alt49) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:480:6: DOT identPart
            	    {
            	    DOT200=(Token)input.LT(1);
            	    match(input,DOT,FOLLOW_DOT_in_identifier2063); if (failed) return retval;
            	    if ( backtracking==0 ) list_DOT.add(DOT200);

            	    pushFollow(FOLLOW_identPart_in_identifier2065);
            	    identPart201=identPart();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) list_identPart.add(identPart201.tree);

            	    }
            	    break;

            	default :
            	    break loop49;
                }
            } while (true);


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 482:3: -> ^( IDENTIFIER ( identPart )+ )
            {
                // org/asdt/core/internal/antlr/as3.g3:482:6: ^( IDENTIFIER ( identPart )+ )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(IDENTIFIER, "IDENTIFIER"), root_1);

                // org/asdt/core/internal/antlr/as3.g3:482:19: ( identPart )+
                {
                int n_1 = list_identPart == null ? 0 : list_identPart.size();
                 


                if ( n_1==0 ) throw new RuntimeException("Must have more than one element for (...)+ loops");
                for (int i_1=0; i_1<n_1; i_1++) {
                    adaptor.addChild(root_1, list_identPart.get(i_1));

                }
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end identifier

    public static class identPart_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start identPart
    // org/asdt/core/internal/antlr/as3.g3:485:1: identPart : IDENT ( DBL_COLON^^ IDENT )? ;
    public identPart_return identPart() throws RecognitionException {   
        identPart_return retval = new identPart_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token IDENT202=null;
        Token DBL_COLON203=null;
        Token IDENT204=null;

        LinkedListTree IDENT202_tree=null;
        LinkedListTree DBL_COLON203_tree=null;
        LinkedListTree IDENT204_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:486:4: ( IDENT ( DBL_COLON^^ IDENT )? )
            // org/asdt/core/internal/antlr/as3.g3:486:4: IDENT ( DBL_COLON^^ IDENT )?
            {
            root_0 = (LinkedListTree)adaptor.nil();

            IDENT202=(Token)input.LT(1);
            match(input,IDENT,FOLLOW_IDENT_in_identPart2092); if (failed) return retval;
            if ( backtracking==0 ) {
            IDENT202_tree = (LinkedListTree)adaptor.create(IDENT202);
            adaptor.addChild(root_0, IDENT202_tree);
            }
            // org/asdt/core/internal/antlr/as3.g3:486:10: ( DBL_COLON^^ IDENT )?
            int alt50=2;
            int LA50_0 = input.LA(1);
            if ( (LA50_0==DBL_COLON) ) {
                alt50=1;
            }
            switch (alt50) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:486:11: DBL_COLON^^ IDENT
                    {
                    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    DBL_COLON203=(Token)input.LT(1);
                    match(input,DBL_COLON,FOLLOW_DBL_COLON_in_identPart2095); if (failed) return retval;
                    if ( backtracking==0 ) {
                    DBL_COLON203_tree = (LinkedListTree)adaptor.create(DBL_COLON203);
                    root_0 = (LinkedListTree)adaptor.becomeRoot(DBL_COLON203_tree, root_0);
                    }
                    IDENT204=(Token)input.LT(1);
                    match(input,IDENT,FOLLOW_IDENT_in_identPart2098); if (failed) return retval;
                    if ( backtracking==0 ) {
                    IDENT204_tree = (LinkedListTree)adaptor.create(IDENT204);
                    adaptor.addChild(root_1, IDENT204_tree);
                    }

                    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    }
                    break;

            }


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end identPart

    public static class identifierStar_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start identifierStar
    // org/asdt/core/internal/antlr/as3.g3:489:1: identifierStar : IDENT ( options {greedy=true; } : DOT IDENT )* ( DOT STAR )? -> ^( IDENTIFIER ( IDENT )+ ( STAR )? ) ;
    public identifierStar_return identifierStar() throws RecognitionException {   
        identifierStar_return retval = new identifierStar_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token IDENT205=null;
        Token DOT206=null;
        Token IDENT207=null;
        Token DOT208=null;
        Token STAR209=null;
        List list_IDENT=new ArrayList();
        List list_STAR=new ArrayList();
        List list_DOT=new ArrayList();
        LinkedListTree IDENT205_tree=null;
        LinkedListTree DOT206_tree=null;
        LinkedListTree IDENT207_tree=null;
        LinkedListTree DOT208_tree=null;
        LinkedListTree STAR209_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:490:4: ( IDENT ( options {greedy=true; } : DOT IDENT )* ( DOT STAR )? -> ^( IDENTIFIER ( IDENT )+ ( STAR )? ) )
            // org/asdt/core/internal/antlr/as3.g3:490:4: IDENT ( options {greedy=true; } : DOT IDENT )* ( DOT STAR )?
            {
            IDENT205=(Token)input.LT(1);
            match(input,IDENT,FOLLOW_IDENT_in_identifierStar2111); if (failed) return retval;
            if ( backtracking==0 ) list_IDENT.add(IDENT205);

            // org/asdt/core/internal/antlr/as3.g3:491:3: ( options {greedy=true; } : DOT IDENT )*
            loop51:
            do {
                int alt51=2;
                int LA51_0 = input.LA(1);
                if ( (LA51_0==DOT) ) {
                    int LA51_1 = input.LA(2);
                    if ( (LA51_1==IDENT) ) {
                        alt51=1;
                    }


                }


                switch (alt51) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:492:5: DOT IDENT
            	    {
            	    DOT206=(Token)input.LT(1);
            	    match(input,DOT,FOLLOW_DOT_in_identifierStar2128); if (failed) return retval;
            	    if ( backtracking==0 ) list_DOT.add(DOT206);

            	    IDENT207=(Token)input.LT(1);
            	    match(input,IDENT,FOLLOW_IDENT_in_identifierStar2130); if (failed) return retval;
            	    if ( backtracking==0 ) list_IDENT.add(IDENT207);


            	    }
            	    break;

            	default :
            	    break loop51;
                }
            } while (true);

            // org/asdt/core/internal/antlr/as3.g3:494:3: ( DOT STAR )?
            int alt52=2;
            int LA52_0 = input.LA(1);
            if ( (LA52_0==DOT) ) {
                alt52=1;
            }
            switch (alt52) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:494:5: DOT STAR
                    {
                    DOT208=(Token)input.LT(1);
                    match(input,DOT,FOLLOW_DOT_in_identifierStar2142); if (failed) return retval;
                    if ( backtracking==0 ) list_DOT.add(DOT208);

                    STAR209=(Token)input.LT(1);
                    match(input,STAR,FOLLOW_STAR_in_identifierStar2144); if (failed) return retval;
                    if ( backtracking==0 ) list_STAR.add(STAR209);


                    }
                    break;

            }


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 496:3: -> ^( IDENTIFIER ( IDENT )+ ( STAR )? )
            {
                // org/asdt/core/internal/antlr/as3.g3:496:6: ^( IDENTIFIER ( IDENT )+ ( STAR )? )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(IDENTIFIER, "IDENTIFIER"), root_1);

                // org/asdt/core/internal/antlr/as3.g3:496:19: ( IDENT )+
                {
                int n_1 = list_IDENT == null ? 0 : list_IDENT.size();
                 


                if ( n_1==0 ) throw new RuntimeException("Must have more than one element for (...)+ loops");
                for (int i_1=0; i_1<n_1; i_1++) {
                    adaptor.addChild(root_1, (Token)list_IDENT.get(i_1));

                }
                }
                // org/asdt/core/internal/antlr/as3.g3:496:26: ( STAR )?
                {
                int n_1 = list_STAR == null ? 0 : list_STAR.size();
                 


                if ( n_1 > 1 ) throw new RuntimeException("STAR list has > 1 elements");
                if ( n_1==1 ) {
                    int i_1 = 0;
                    adaptor.addChild(root_1, (Token)list_STAR.get(i_1));

                    }
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end identifierStar

    public static class annotations_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start annotations
    // org/asdt/core/internal/antlr/as3.g3:499:1: annotations : ( annotation )* -> ^( ANNOTATIONS ( annotation )* ) ;
    public annotations_return annotations() throws RecognitionException {   
        annotations_return retval = new annotations_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        annotation_return annotation210 = null;

        List list_annotation=new ArrayList();

        try {
            // org/asdt/core/internal/antlr/as3.g3:500:4: ( ( annotation )* -> ^( ANNOTATIONS ( annotation )* ) )
            // org/asdt/core/internal/antlr/as3.g3:500:4: ( annotation )*
            {
            // org/asdt/core/internal/antlr/as3.g3:500:4: ( annotation )*
            loop53:
            do {
                int alt53=2;
                int LA53_0 = input.LA(1);
                if ( (LA53_0==LBRACK) ) {
                    alt53=1;
                }


                switch (alt53) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:500:4: annotation
            	    {
            	    pushFollow(FOLLOW_annotation_in_annotations2174);
            	    annotation210=annotation();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) list_annotation.add(annotation210.tree);

            	    }
            	    break;

            	default :
            	    break loop53;
                }
            } while (true);


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 501:3: -> ^( ANNOTATIONS ( annotation )* )
            {
                // org/asdt/core/internal/antlr/as3.g3:501:6: ^( ANNOTATIONS ( annotation )* )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(ANNOTATIONS, "ANNOTATIONS"), root_1);

                // org/asdt/core/internal/antlr/as3.g3:501:20: ( annotation )*
                {
                int n_1 = list_annotation == null ? 0 : list_annotation.size();
                 


                for (int i_1=0; i_1<n_1; i_1++) {
                    adaptor.addChild(root_1, list_annotation.get(i_1));

                }
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end annotations

    public static class annotation_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start annotation
    // org/asdt/core/internal/antlr/as3.g3:504:1: annotation : LBRACK IDENT ( annotationParamList )? RBRACK -> ^( ANNOTATION IDENT ( annotationParamList )? ) ;
    public annotation_return annotation() throws RecognitionException {   
        annotation_return retval = new annotation_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token LBRACK211=null;
        Token IDENT212=null;
        Token RBRACK214=null;
        annotationParamList_return annotationParamList213 = null;

        List list_annotationParamList=new ArrayList();
        List list_RBRACK=new ArrayList();
        List list_IDENT=new ArrayList();
        List list_LBRACK=new ArrayList();
        LinkedListTree LBRACK211_tree=null;
        LinkedListTree IDENT212_tree=null;
        LinkedListTree RBRACK214_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:505:4: ( LBRACK IDENT ( annotationParamList )? RBRACK -> ^( ANNOTATION IDENT ( annotationParamList )? ) )
            // org/asdt/core/internal/antlr/as3.g3:505:4: LBRACK IDENT ( annotationParamList )? RBRACK
            {
            LBRACK211=(Token)input.LT(1);
            match(input,LBRACK,FOLLOW_LBRACK_in_annotation2197); if (failed) return retval;
            if ( backtracking==0 ) list_LBRACK.add(LBRACK211);

            IDENT212=(Token)input.LT(1);
            match(input,IDENT,FOLLOW_IDENT_in_annotation2201); if (failed) return retval;
            if ( backtracking==0 ) list_IDENT.add(IDENT212);

            // org/asdt/core/internal/antlr/as3.g3:507:3: ( annotationParamList )?
            int alt54=2;
            int LA54_0 = input.LA(1);
            if ( (LA54_0==LPAREN) ) {
                alt54=1;
            }
            switch (alt54) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:507:3: annotationParamList
                    {
                    pushFollow(FOLLOW_annotationParamList_in_annotation2205);
                    annotationParamList213=annotationParamList();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) list_annotationParamList.add(annotationParamList213.tree);

                    }
                    break;

            }

            RBRACK214=(Token)input.LT(1);
            match(input,RBRACK,FOLLOW_RBRACK_in_annotation2210); if (failed) return retval;
            if ( backtracking==0 ) list_RBRACK.add(RBRACK214);


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 509:3: -> ^( ANNOTATION IDENT ( annotationParamList )? )
            {
                // org/asdt/core/internal/antlr/as3.g3:509:6: ^( ANNOTATION IDENT ( annotationParamList )? )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(ANNOTATION, "ANNOTATION"), root_1);

                adaptor.addChild(root_1, (Token)list_IDENT.get(i_0));
                // org/asdt/core/internal/antlr/as3.g3:509:25: ( annotationParamList )?
                {
                int n_1 = list_annotationParamList == null ? 0 : list_annotationParamList.size();
                 


                if ( n_1 > 1 ) throw new RuntimeException("annotationParamList list has > 1 elements");
                if ( n_1==1 ) {
                    int i_1 = 0;
                    adaptor.addChild(root_1, list_annotationParamList.get(i_1));

                    }
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end annotation

    public static class annotationParamList_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start annotationParamList
    // org/asdt/core/internal/antlr/as3.g3:512:1: annotationParamList : LPAREN ( annotationParam ( COMMA annotationParam )* )? RPAREN -> ^( ANNOTATION_PARAMS ( annotationParam )* ) ;
    public annotationParamList_return annotationParamList() throws RecognitionException {   
        annotationParamList_return retval = new annotationParamList_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token LPAREN215=null;
        Token COMMA217=null;
        Token RPAREN219=null;
        annotationParam_return annotationParam216 = null;

        annotationParam_return annotationParam218 = null;

        List list_annotationParam=new ArrayList();
        List list_COMMA=new ArrayList();
        List list_RPAREN=new ArrayList();
        List list_LPAREN=new ArrayList();
        LinkedListTree LPAREN215_tree=null;
        LinkedListTree COMMA217_tree=null;
        LinkedListTree RPAREN219_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:514:3: ( LPAREN ( annotationParam ( COMMA annotationParam )* )? RPAREN -> ^( ANNOTATION_PARAMS ( annotationParam )* ) )
            // org/asdt/core/internal/antlr/as3.g3:514:3: LPAREN ( annotationParam ( COMMA annotationParam )* )? RPAREN
            {
            LPAREN215=(Token)input.LT(1);
            match(input,LPAREN,FOLLOW_LPAREN_in_annotationParamList2236); if (failed) return retval;
            if ( backtracking==0 ) list_LPAREN.add(LPAREN215);

            // org/asdt/core/internal/antlr/as3.g3:515:3: ( annotationParam ( COMMA annotationParam )* )?
            int alt56=2;
            int LA56_0 = input.LA(1);
            if ( (LA56_0==IDENT||LA56_0==LT||(LA56_0>=STRING_LITERAL && LA56_0<=FLOAT_LITERAL)) ) {
                alt56=1;
            }
            switch (alt56) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:515:5: annotationParam ( COMMA annotationParam )*
                    {
                    pushFollow(FOLLOW_annotationParam_in_annotationParamList2242);
                    annotationParam216=annotationParam();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) list_annotationParam.add(annotationParam216.tree);
                    // org/asdt/core/internal/antlr/as3.g3:516:4: ( COMMA annotationParam )*
                    loop55:
                    do {
                        int alt55=2;
                        int LA55_0 = input.LA(1);
                        if ( (LA55_0==COMMA) ) {
                            alt55=1;
                        }


                        switch (alt55) {
                    	case 1 :
                    	    // org/asdt/core/internal/antlr/as3.g3:516:5: COMMA annotationParam
                    	    {
                    	    COMMA217=(Token)input.LT(1);
                    	    match(input,COMMA,FOLLOW_COMMA_in_annotationParamList2248); if (failed) return retval;
                    	    if ( backtracking==0 ) list_COMMA.add(COMMA217);

                    	    pushFollow(FOLLOW_annotationParam_in_annotationParamList2250);
                    	    annotationParam218=annotationParam();
                    	    _fsp--;
                    	    if (failed) return retval;
                    	    if ( backtracking==0 ) list_annotationParam.add(annotationParam218.tree);

                    	    }
                    	    break;

                    	default :
                    	    break loop55;
                        }
                    } while (true);


                    }
                    break;

            }

            RPAREN219=(Token)input.LT(1);
            match(input,RPAREN,FOLLOW_RPAREN_in_annotationParamList2261); if (failed) return retval;
            if ( backtracking==0 ) list_RPAREN.add(RPAREN219);


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 519:3: -> ^( ANNOTATION_PARAMS ( annotationParam )* )
            {
                // org/asdt/core/internal/antlr/as3.g3:519:6: ^( ANNOTATION_PARAMS ( annotationParam )* )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(ANNOTATION_PARAMS, "ANNOTATION_PARAMS"), root_1);

                // org/asdt/core/internal/antlr/as3.g3:519:26: ( annotationParam )*
                {
                int n_1 = list_annotationParam == null ? 0 : list_annotationParam.size();
                 


                for (int i_1=0; i_1<n_1; i_1++) {
                    adaptor.addChild(root_1, list_annotationParam.get(i_1));

                }
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end annotationParamList

    public static class annotationParam_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start annotationParam
    // org/asdt/core/internal/antlr/as3.g3:533:1: annotationParam : ( IDENT ASSIGN constant -> ^( ASSIGN IDENT constant ) | constant -> constant | IDENT -> IDENT );
    public annotationParam_return annotationParam() throws RecognitionException {   
        annotationParam_return retval = new annotationParam_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token IDENT220=null;
        Token ASSIGN221=null;
        Token IDENT224=null;
        constant_return constant222 = null;

        constant_return constant223 = null;

        List list_constant=new ArrayList();
        List list_IDENT=new ArrayList();
        List list_ASSIGN=new ArrayList();
        LinkedListTree IDENT220_tree=null;
        LinkedListTree ASSIGN221_tree=null;
        LinkedListTree IDENT224_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:535:3: ( IDENT ASSIGN constant -> ^( ASSIGN IDENT constant ) | constant -> constant | IDENT -> IDENT )
            int alt57=3;
            int LA57_0 = input.LA(1);
            if ( (LA57_0==IDENT) ) {
                int LA57_1 = input.LA(2);
                if ( (LA57_1==ASSIGN) ) {
                    alt57=1;
                }
                else if ( (LA57_1==COMMA||LA57_1==RPAREN) ) {
                    alt57=3;
                }
                else {
                    if (backtracking>0) {failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("533:1: annotationParam : ( IDENT ASSIGN constant -> ^( ASSIGN IDENT constant ) | constant -> constant | IDENT -> IDENT );", 57, 1, input);

                    throw nvae;
                }
            }
            else if ( (LA57_0==LT||(LA57_0>=STRING_LITERAL && LA57_0<=FLOAT_LITERAL)) ) {
                alt57=2;
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("533:1: annotationParam : ( IDENT ASSIGN constant -> ^( ASSIGN IDENT constant ) | constant -> constant | IDENT -> IDENT );", 57, 0, input);

                throw nvae;
            }
            switch (alt57) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:535:3: IDENT ASSIGN constant
                    {
                    IDENT220=(Token)input.LT(1);
                    match(input,IDENT,FOLLOW_IDENT_in_annotationParam2288); if (failed) return retval;
                    if ( backtracking==0 ) list_IDENT.add(IDENT220);

                    ASSIGN221=(Token)input.LT(1);
                    match(input,ASSIGN,FOLLOW_ASSIGN_in_annotationParam2290); if (failed) return retval;
                    if ( backtracking==0 ) list_ASSIGN.add(ASSIGN221);

                    pushFollow(FOLLOW_constant_in_annotationParam2292);
                    constant222=constant();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) list_constant.add(constant222.tree);

                    // AST REWRITE
                    if ( backtracking==0 ) {
                    int i_0 = 0;
                    retval.tree = root_0;
                    root_0 = (LinkedListTree)adaptor.nil();
                    // 535:25: -> ^( ASSIGN IDENT constant )
                    {
                        // org/asdt/core/internal/antlr/as3.g3:535:28: ^( ASSIGN IDENT constant )
                        {
                        LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                        root_1 = (LinkedListTree)adaptor.becomeRoot((Token)list_ASSIGN.get(i_0), root_1);

                        adaptor.addChild(root_1, (Token)list_IDENT.get(i_0));
                        adaptor.addChild(root_1, list_constant.get(i_0));

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    }

                    }
                    break;
                case 2 :
                    // org/asdt/core/internal/antlr/as3.g3:536:4: constant
                    {
                    pushFollow(FOLLOW_constant_in_annotationParam2307);
                    constant223=constant();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) list_constant.add(constant223.tree);

                    // AST REWRITE
                    if ( backtracking==0 ) {
                    int i_0 = 0;
                    retval.tree = root_0;
                    root_0 = (LinkedListTree)adaptor.nil();
                    // 536:13: -> constant
                    {
                        adaptor.addChild(root_0, list_constant.get(i_0));

                    }

                    }

                    }
                    break;
                case 3 :
                    // org/asdt/core/internal/antlr/as3.g3:537:4: IDENT
                    {
                    IDENT224=(Token)input.LT(1);
                    match(input,IDENT,FOLLOW_IDENT_in_annotationParam2316); if (failed) return retval;
                    if ( backtracking==0 ) list_IDENT.add(IDENT224);


                    // AST REWRITE
                    if ( backtracking==0 ) {
                    int i_0 = 0;
                    retval.tree = root_0;
                    root_0 = (LinkedListTree)adaptor.nil();
                    // 537:10: -> IDENT
                    {
                        adaptor.addChild(root_0, (Token)list_IDENT.get(i_0));

                    }

                    }

                    }
                    break;

            }
        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end annotationParam

    public static class modifiers_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start modifiers
    // org/asdt/core/internal/antlr/as3.g3:540:1: modifiers : ( modifier )* -> ^( MODIFIERS ( modifier )* ) ;
    public modifiers_return modifiers() throws RecognitionException {   
        modifiers_return retval = new modifiers_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        modifier_return modifier225 = null;

        List list_modifier=new ArrayList();

        try {
            // org/asdt/core/internal/antlr/as3.g3:541:4: ( ( modifier )* -> ^( MODIFIERS ( modifier )* ) )
            // org/asdt/core/internal/antlr/as3.g3:541:4: ( modifier )*
            {
            // org/asdt/core/internal/antlr/as3.g3:541:4: ( modifier )*
            loop58:
            do {
                int alt58=2;
                int LA58_0 = input.LA(1);
                if ( ((LA58_0>=PUBLIC && LA58_0<=STATIC)||(LA58_0>=153 && LA58_0<=159)) ) {
                    alt58=1;
                }


                switch (alt58) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:541:4: modifier
            	    {
            	    pushFollow(FOLLOW_modifier_in_modifiers2331);
            	    modifier225=modifier();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) list_modifier.add(modifier225.tree);

            	    }
            	    break;

            	default :
            	    break loop58;
                }
            } while (true);


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 542:3: -> ^( MODIFIERS ( modifier )* )
            {
                // org/asdt/core/internal/antlr/as3.g3:542:6: ^( MODIFIERS ( modifier )* )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(MODIFIERS, "MODIFIERS"), root_1);

                // org/asdt/core/internal/antlr/as3.g3:542:18: ( modifier )*
                {
                int n_1 = list_modifier == null ? 0 : list_modifier.size();
                 


                for (int i_1=0; i_1<n_1; i_1++) {
                    adaptor.addChild(root_1, list_modifier.get(i_1));

                }
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end modifiers

    public static class modifier_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start modifier
    // org/asdt/core/internal/antlr/as3.g3:544:1: modifier : (PUBLIC|PRIVATE|'protected'|'internal'|STATIC|'final'|'enumerable'|'explicit'|'override'|'dynamic');
    public modifier_return modifier() throws RecognitionException {   
        modifier_return retval = new modifier_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token set226=null;

        LinkedListTree set226_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:545:2: ( (PUBLIC|PRIVATE|'protected'|'internal'|STATIC|'final'|'enumerable'|'explicit'|'override'|'dynamic'))
            // org/asdt/core/internal/antlr/as3.g3:545:4: (PUBLIC|PRIVATE|'protected'|'internal'|STATIC|'final'|'enumerable'|'explicit'|'override'|'dynamic')
            {
            root_0 = (LinkedListTree)adaptor.nil();

            set226=(Token)input.LT(1);
            if ( (input.LA(1)>=PUBLIC && input.LA(1)<=STATIC)||(input.LA(1)>=153 && input.LA(1)<=159) ) {
                if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set226));
                input.consume();
                errorRecovery=false;failed=false;
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                MismatchedSetException mse =
                    new MismatchedSetException(null,input);
                recoverFromMismatchedSet(input,mse,FOLLOW_set_in_modifier2353);    throw mse;
            }


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end modifier

    public static class arguments_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start arguments
    // org/asdt/core/internal/antlr/as3.g3:556:1: arguments : LPAREN ( expressionList | ) RPAREN -> ^( ELIST $arguments) ;
    public arguments_return arguments() throws RecognitionException {   
        arguments_return retval = new arguments_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token LPAREN227=null;
        Token RPAREN229=null;
        expressionList_return expressionList228 = null;

        List list_expressionList=new ArrayList();
        List list_RPAREN=new ArrayList();
        List list_LPAREN=new ArrayList();
        LinkedListTree LPAREN227_tree=null;
        LinkedListTree RPAREN229_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:557:4: ( LPAREN ( expressionList | ) RPAREN -> ^( ELIST $arguments) )
            // org/asdt/core/internal/antlr/as3.g3:557:4: LPAREN ( expressionList | ) RPAREN
            {
            LPAREN227=(Token)input.LT(1);
            match(input,LPAREN,FOLLOW_LPAREN_in_arguments2408); if (failed) return retval;
            if ( backtracking==0 ) list_LPAREN.add(LPAREN227);

            // org/asdt/core/internal/antlr/as3.g3:558:3: ( expressionList | )
            int alt59=2;
            int LA59_0 = input.LA(1);
            if ( (LA59_0==LCURLY||LA59_0==IDENT||LA59_0==FUNCTION||LA59_0==LPAREN||LA59_0==LBRACK||LA59_0==LT||(LA59_0>=PLUS && LA59_0<=MINUS)||(LA59_0>=INC && LA59_0<=BNOT)||(LA59_0>=STRING_LITERAL && LA59_0<=FLOAT_LITERAL)||LA59_0==152||(LA59_0>=162 && LA59_0<=166)) ) {
                alt59=1;
            }
            else if ( (LA59_0==RPAREN) ) {
                alt59=2;
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("558:3: ( expressionList | )", 59, 0, input);

                throw nvae;
            }
            switch (alt59) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:558:5: expressionList
                    {
                    pushFollow(FOLLOW_expressionList_in_arguments2414);
                    expressionList228=expressionList();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) list_expressionList.add(expressionList228.tree);

                    }
                    break;
                case 2 :
                    // org/asdt/core/internal/antlr/as3.g3:560:3: 
                    {
                    }
                    break;

            }

            RPAREN229=(Token)input.LT(1);
            match(input,RPAREN,FOLLOW_RPAREN_in_arguments2428); if (failed) return retval;
            if ( backtracking==0 ) list_RPAREN.add(RPAREN229);


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 562:3: -> ^( ELIST $arguments)
            {
                // org/asdt/core/internal/antlr/as3.g3:562:6: ^( ELIST $arguments)
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(ELIST, "ELIST"), root_1);

                adaptor.addChild(root_1, retval.tree);

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end arguments

    public static class arrayLiteral_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start arrayLiteral
    // org/asdt/core/internal/antlr/as3.g3:565:1: arrayLiteral : LBRACK ( elementList )? RBRACK -> ^( ARRAY_LITERAL ( elementList )? ) ;
    public arrayLiteral_return arrayLiteral() throws RecognitionException {   
        arrayLiteral_return retval = new arrayLiteral_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token LBRACK230=null;
        Token RBRACK232=null;
        elementList_return elementList231 = null;

        List list_elementList=new ArrayList();
        List list_RBRACK=new ArrayList();
        List list_LBRACK=new ArrayList();
        LinkedListTree LBRACK230_tree=null;
        LinkedListTree RBRACK232_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:566:4: ( LBRACK ( elementList )? RBRACK -> ^( ARRAY_LITERAL ( elementList )? ) )
            // org/asdt/core/internal/antlr/as3.g3:566:4: LBRACK ( elementList )? RBRACK
            {
            LBRACK230=(Token)input.LT(1);
            match(input,LBRACK,FOLLOW_LBRACK_in_arrayLiteral2450); if (failed) return retval;
            if ( backtracking==0 ) list_LBRACK.add(LBRACK230);

            // org/asdt/core/internal/antlr/as3.g3:566:11: ( elementList )?
            int alt60=2;
            int LA60_0 = input.LA(1);
            if ( (LA60_0==LCURLY||LA60_0==IDENT||LA60_0==COMMA||LA60_0==FUNCTION||LA60_0==LPAREN||LA60_0==LBRACK||LA60_0==LT||(LA60_0>=PLUS && LA60_0<=MINUS)||(LA60_0>=INC && LA60_0<=BNOT)||(LA60_0>=STRING_LITERAL && LA60_0<=FLOAT_LITERAL)||LA60_0==152||(LA60_0>=162 && LA60_0<=166)) ) {
                alt60=1;
            }
            switch (alt60) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:566:11: elementList
                    {
                    pushFollow(FOLLOW_elementList_in_arrayLiteral2452);
                    elementList231=elementList();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) list_elementList.add(elementList231.tree);

                    }
                    break;

            }

            RBRACK232=(Token)input.LT(1);
            match(input,RBRACK,FOLLOW_RBRACK_in_arrayLiteral2455); if (failed) return retval;
            if ( backtracking==0 ) list_RBRACK.add(RBRACK232);


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 567:3: -> ^( ARRAY_LITERAL ( elementList )? )
            {
                // org/asdt/core/internal/antlr/as3.g3:567:6: ^( ARRAY_LITERAL ( elementList )? )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(ARRAY_LITERAL, "ARRAY_LITERAL"), root_1);

                // org/asdt/core/internal/antlr/as3.g3:567:22: ( elementList )?
                {
                int n_1 = list_elementList == null ? 0 : list_elementList.size();
                 


                if ( n_1 > 1 ) throw new RuntimeException("elementList list has > 1 elements");
                if ( n_1==1 ) {
                    int i_1 = 0;
                    adaptor.addChild(root_1, list_elementList.get(i_1));

                    }
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end arrayLiteral

    public static class elementList_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start elementList
    // org/asdt/core/internal/antlr/as3.g3:570:1: elementList : ( COMMA! | nonemptyElementList );
    public elementList_return elementList() throws RecognitionException {   
        elementList_return retval = new elementList_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token COMMA233=null;
        nonemptyElementList_return nonemptyElementList234 = null;


        LinkedListTree COMMA233_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:571:4: ( COMMA! | nonemptyElementList )
            int alt61=2;
            int LA61_0 = input.LA(1);
            if ( (LA61_0==COMMA) ) {
                alt61=1;
            }
            else if ( (LA61_0==LCURLY||LA61_0==IDENT||LA61_0==FUNCTION||LA61_0==LPAREN||LA61_0==LBRACK||LA61_0==LT||(LA61_0>=PLUS && LA61_0<=MINUS)||(LA61_0>=INC && LA61_0<=BNOT)||(LA61_0>=STRING_LITERAL && LA61_0<=FLOAT_LITERAL)||LA61_0==152||(LA61_0>=162 && LA61_0<=166)) ) {
                alt61=2;
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("570:1: elementList : ( COMMA! | nonemptyElementList );", 61, 0, input);

                throw nvae;
            }
            switch (alt61) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:571:4: COMMA!
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    COMMA233=(Token)input.LT(1);
                    match(input,COMMA,FOLLOW_COMMA_in_elementList2479); if (failed) return retval;

                    }
                    break;
                case 2 :
                    // org/asdt/core/internal/antlr/as3.g3:572:4: nonemptyElementList
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_nonemptyElementList_in_elementList2485);
                    nonemptyElementList234=nonemptyElementList();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, nonemptyElementList234.tree);

                    }
                    break;

            }
        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end elementList

    public static class nonemptyElementList_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start nonemptyElementList
    // org/asdt/core/internal/antlr/as3.g3:574:1: nonemptyElementList : assignmentExpression ( COMMA! assignmentExpression )* ;
    public nonemptyElementList_return nonemptyElementList() throws RecognitionException {   
        nonemptyElementList_return retval = new nonemptyElementList_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token COMMA236=null;
        assignmentExpression_return assignmentExpression235 = null;

        assignmentExpression_return assignmentExpression237 = null;


        LinkedListTree COMMA236_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:575:4: ( assignmentExpression ( COMMA! assignmentExpression )* )
            // org/asdt/core/internal/antlr/as3.g3:575:4: assignmentExpression ( COMMA! assignmentExpression )*
            {
            root_0 = (LinkedListTree)adaptor.nil();

            pushFollow(FOLLOW_assignmentExpression_in_nonemptyElementList2495);
            assignmentExpression235=assignmentExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, assignmentExpression235.tree);
            // org/asdt/core/internal/antlr/as3.g3:575:25: ( COMMA! assignmentExpression )*
            loop62:
            do {
                int alt62=2;
                int LA62_0 = input.LA(1);
                if ( (LA62_0==COMMA) ) {
                    alt62=1;
                }


                switch (alt62) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:575:26: COMMA! assignmentExpression
            	    {
            	    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

            	    COMMA236=(Token)input.LT(1);
            	    match(input,COMMA,FOLLOW_COMMA_in_nonemptyElementList2498); if (failed) return retval;
            	    pushFollow(FOLLOW_assignmentExpression_in_nonemptyElementList2501);
            	    assignmentExpression237=assignmentExpression();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_1, assignmentExpression237.tree);

            	    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

            	    }
            	    break;

            	default :
            	    break loop62;
                }
            } while (true);


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end nonemptyElementList

    public static class element_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start element
    // org/asdt/core/internal/antlr/as3.g3:578:1: element : assignmentExpression -> ^( ELEMENT assignmentExpression ) ;
    public element_return element() throws RecognitionException {   
        element_return retval = new element_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        assignmentExpression_return assignmentExpression238 = null;

        List list_assignmentExpression=new ArrayList();

        try {
            // org/asdt/core/internal/antlr/as3.g3:579:4: ( assignmentExpression -> ^( ELEMENT assignmentExpression ) )
            // org/asdt/core/internal/antlr/as3.g3:579:4: assignmentExpression
            {
            pushFollow(FOLLOW_assignmentExpression_in_element2514);
            assignmentExpression238=assignmentExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_assignmentExpression.add(assignmentExpression238.tree);

            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 580:3: -> ^( ELEMENT assignmentExpression )
            {
                // org/asdt/core/internal/antlr/as3.g3:580:6: ^( ELEMENT assignmentExpression )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(ELEMENT, "ELEMENT"), root_1);

                adaptor.addChild(root_1, list_assignmentExpression.get(i_0));

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end element

    public static class objectLiteral_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start objectLiteral
    // org/asdt/core/internal/antlr/as3.g3:584:1: objectLiteral : LCURLY ( fieldList )? RCURLY -> ^( OBJECT_LITERAL ( fieldList )? ) ;
    public objectLiteral_return objectLiteral() throws RecognitionException {   
        objectLiteral_return retval = new objectLiteral_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token LCURLY239=null;
        Token RCURLY241=null;
        fieldList_return fieldList240 = null;

        List list_fieldList=new ArrayList();
        List list_RCURLY=new ArrayList();
        List list_LCURLY=new ArrayList();
        LinkedListTree LCURLY239_tree=null;
        LinkedListTree RCURLY241_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:585:4: ( LCURLY ( fieldList )? RCURLY -> ^( OBJECT_LITERAL ( fieldList )? ) )
            // org/asdt/core/internal/antlr/as3.g3:585:4: LCURLY ( fieldList )? RCURLY
            {
            LCURLY239=(Token)input.LT(1);
            match(input,LCURLY,FOLLOW_LCURLY_in_objectLiteral2536); if (failed) return retval;
            if ( backtracking==0 ) list_LCURLY.add(LCURLY239);

            // org/asdt/core/internal/antlr/as3.g3:585:11: ( fieldList )?
            int alt63=2;
            int LA63_0 = input.LA(1);
            if ( (LA63_0==IDENT||(LA63_0>=HEX_LITERAL && LA63_0<=FLOAT_LITERAL)) ) {
                alt63=1;
            }
            switch (alt63) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:585:11: fieldList
                    {
                    pushFollow(FOLLOW_fieldList_in_objectLiteral2538);
                    fieldList240=fieldList();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) list_fieldList.add(fieldList240.tree);

                    }
                    break;

            }

            RCURLY241=(Token)input.LT(1);
            match(input,RCURLY,FOLLOW_RCURLY_in_objectLiteral2541); if (failed) return retval;
            if ( backtracking==0 ) list_RCURLY.add(RCURLY241);


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 586:3: -> ^( OBJECT_LITERAL ( fieldList )? )
            {
                // org/asdt/core/internal/antlr/as3.g3:586:6: ^( OBJECT_LITERAL ( fieldList )? )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(OBJECT_LITERAL, "OBJECT_LITERAL"), root_1);

                // org/asdt/core/internal/antlr/as3.g3:586:23: ( fieldList )?
                {
                int n_1 = list_fieldList == null ? 0 : list_fieldList.size();
                 


                if ( n_1 > 1 ) throw new RuntimeException("fieldList list has > 1 elements");
                if ( n_1==1 ) {
                    int i_1 = 0;
                    adaptor.addChild(root_1, list_fieldList.get(i_1));

                    }
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end objectLiteral

    public static class fieldList_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start fieldList
    // org/asdt/core/internal/antlr/as3.g3:589:1: fieldList : literalField ( COMMA! ( literalField )? )* ;
    public fieldList_return fieldList() throws RecognitionException {   
        fieldList_return retval = new fieldList_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token COMMA243=null;
        literalField_return literalField242 = null;

        literalField_return literalField244 = null;


        LinkedListTree COMMA243_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:590:4: ( literalField ( COMMA! ( literalField )? )* )
            // org/asdt/core/internal/antlr/as3.g3:590:4: literalField ( COMMA! ( literalField )? )*
            {
            root_0 = (LinkedListTree)adaptor.nil();

            pushFollow(FOLLOW_literalField_in_fieldList2564);
            literalField242=literalField();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, literalField242.tree);
            // org/asdt/core/internal/antlr/as3.g3:590:17: ( COMMA! ( literalField )? )*
            loop65:
            do {
                int alt65=2;
                int LA65_0 = input.LA(1);
                if ( (LA65_0==COMMA) ) {
                    alt65=1;
                }


                switch (alt65) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:590:18: COMMA! ( literalField )?
            	    {
            	    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

            	    COMMA243=(Token)input.LT(1);
            	    match(input,COMMA,FOLLOW_COMMA_in_fieldList2567); if (failed) return retval;
            	    // org/asdt/core/internal/antlr/as3.g3:590:25: ( literalField )?
            	    int alt64=2;
            	    int LA64_0 = input.LA(1);
            	    if ( (LA64_0==IDENT||(LA64_0>=HEX_LITERAL && LA64_0<=FLOAT_LITERAL)) ) {
            	        alt64=1;
            	    }
            	    switch (alt64) {
            	        case 1 :
            	            // org/asdt/core/internal/antlr/as3.g3:590:25: literalField
            	            {
            	            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

            	            pushFollow(FOLLOW_literalField_in_fieldList2570);
            	            literalField244=literalField();
            	            _fsp--;
            	            if (failed) return retval;
            	            if ( backtracking==0 ) adaptor.addChild(root_2, literalField244.tree);

            	            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

            	            }
            	            break;

            	    }


            	    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

            	    }
            	    break;

            	default :
            	    break loop65;
                }
            } while (true);


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end fieldList

    public static class literalField_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start literalField
    // org/asdt/core/internal/antlr/as3.g3:593:1: literalField : fieldName COLON element -> ^( OBJECT_FIELD fieldName element ) ;
    public literalField_return literalField() throws RecognitionException {   
        literalField_return retval = new literalField_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token COLON246=null;
        fieldName_return fieldName245 = null;

        element_return element247 = null;

        List list_element=new ArrayList();
        List list_fieldName=new ArrayList();
        List list_COLON=new ArrayList();
        LinkedListTree COLON246_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:594:5: ( fieldName COLON element -> ^( OBJECT_FIELD fieldName element ) )
            // org/asdt/core/internal/antlr/as3.g3:594:5: fieldName COLON element
            {
            pushFollow(FOLLOW_fieldName_in_literalField2587);
            fieldName245=fieldName();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_fieldName.add(fieldName245.tree);
            COLON246=(Token)input.LT(1);
            match(input,COLON,FOLLOW_COLON_in_literalField2589); if (failed) return retval;
            if ( backtracking==0 ) list_COLON.add(COLON246);

            pushFollow(FOLLOW_element_in_literalField2591);
            element247=element();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_element.add(element247.tree);

            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 595:3: -> ^( OBJECT_FIELD fieldName element )
            {
                // org/asdt/core/internal/antlr/as3.g3:595:6: ^( OBJECT_FIELD fieldName element )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(OBJECT_FIELD, "OBJECT_FIELD"), root_1);

                adaptor.addChild(root_1, list_fieldName.get(i_0));
                adaptor.addChild(root_1, list_element.get(i_0));

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end literalField

    public static class fieldName_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start fieldName
    // org/asdt/core/internal/antlr/as3.g3:598:1: fieldName : ( IDENT | number );
    public fieldName_return fieldName() throws RecognitionException {   
        fieldName_return retval = new fieldName_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token IDENT248=null;
        number_return number249 = null;


        LinkedListTree IDENT248_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:599:4: ( IDENT | number )
            int alt66=2;
            int LA66_0 = input.LA(1);
            if ( (LA66_0==IDENT) ) {
                alt66=1;
            }
            else if ( ((LA66_0>=HEX_LITERAL && LA66_0<=FLOAT_LITERAL)) ) {
                alt66=2;
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("598:1: fieldName : ( IDENT | number );", 66, 0, input);

                throw nvae;
            }
            switch (alt66) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:599:4: IDENT
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    IDENT248=(Token)input.LT(1);
                    match(input,IDENT,FOLLOW_IDENT_in_fieldName2615); if (failed) return retval;
                    if ( backtracking==0 ) {
                    IDENT248_tree = (LinkedListTree)adaptor.create(IDENT248);
                    adaptor.addChild(root_0, IDENT248_tree);
                    }

                    }
                    break;
                case 2 :
                    // org/asdt/core/internal/antlr/as3.g3:600:4: number
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_number_in_fieldName2620);
                    number249=number();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, number249.tree);

                    }
                    break;

            }
        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end fieldName

    public static class expression_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start expression
    // org/asdt/core/internal/antlr/as3.g3:604:1: expression : assignmentExpression -> ^( EXPR assignmentExpression ) ;
    public expression_return expression() throws RecognitionException {   
        expression_return retval = new expression_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        assignmentExpression_return assignmentExpression250 = null;

        List list_assignmentExpression=new ArrayList();

        try {
            // org/asdt/core/internal/antlr/as3.g3:605:4: ( assignmentExpression -> ^( EXPR assignmentExpression ) )
            // org/asdt/core/internal/antlr/as3.g3:605:4: assignmentExpression
            {
            pushFollow(FOLLOW_assignmentExpression_in_expression2632);
            assignmentExpression250=assignmentExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_assignmentExpression.add(assignmentExpression250.tree);

            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 606:3: -> ^( EXPR assignmentExpression )
            {
                // org/asdt/core/internal/antlr/as3.g3:606:6: ^( EXPR assignmentExpression )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(EXPR, "EXPR"), root_1);

                adaptor.addChild(root_1, list_assignmentExpression.get(i_0));

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end expression

    public static class expressionList_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start expressionList
    // org/asdt/core/internal/antlr/as3.g3:610:1: expressionList : expression ( COMMA expression )* -> ^( ELIST ( expression )+ ) ;
    public expressionList_return expressionList() throws RecognitionException {   
        expressionList_return retval = new expressionList_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token COMMA252=null;
        expression_return expression251 = null;

        expression_return expression253 = null;

        List list_expression=new ArrayList();
        List list_COMMA=new ArrayList();
        LinkedListTree COMMA252_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:611:4: ( expression ( COMMA expression )* -> ^( ELIST ( expression )+ ) )
            // org/asdt/core/internal/antlr/as3.g3:611:4: expression ( COMMA expression )*
            {
            pushFollow(FOLLOW_expression_in_expressionList2654);
            expression251=expression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_expression.add(expression251.tree);
            // org/asdt/core/internal/antlr/as3.g3:611:15: ( COMMA expression )*
            loop67:
            do {
                int alt67=2;
                int LA67_0 = input.LA(1);
                if ( (LA67_0==COMMA) ) {
                    alt67=1;
                }


                switch (alt67) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:611:16: COMMA expression
            	    {
            	    COMMA252=(Token)input.LT(1);
            	    match(input,COMMA,FOLLOW_COMMA_in_expressionList2657); if (failed) return retval;
            	    if ( backtracking==0 ) list_COMMA.add(COMMA252);

            	    pushFollow(FOLLOW_expression_in_expressionList2659);
            	    expression253=expression();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) list_expression.add(expression253.tree);

            	    }
            	    break;

            	default :
            	    break loop67;
                }
            } while (true);


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 612:3: -> ^( ELIST ( expression )+ )
            {
                // org/asdt/core/internal/antlr/as3.g3:612:6: ^( ELIST ( expression )+ )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(ELIST, "ELIST"), root_1);

                // org/asdt/core/internal/antlr/as3.g3:612:14: ( expression )+
                {
                int n_1 = list_expression == null ? 0 : list_expression.size();
                 


                if ( n_1==0 ) throw new RuntimeException("Must have more than one element for (...)+ loops");
                for (int i_1=0; i_1<n_1; i_1++) {
                    adaptor.addChild(root_1, list_expression.get(i_1));

                }
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end expressionList

    public static class assignmentExpression_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start assignmentExpression
    // org/asdt/core/internal/antlr/as3.g3:616:1: assignmentExpression : conditionalExpression ( ( (ASSIGN|STAR_ASSIGN|DIV_ASSIGN|MOD_ASSIGN|PLUS_ASSIGN|MINUS_ASSIGN|SL_ASSIGN|SR_ASSIGN|BSR_ASSIGN|BAND_ASSIGN|BXOR_ASSIGN|BOR_ASSIGN|LAND_ASSIGN|LOR_ASSIGN)~ ASSIGN )=> ( ASSIGN^^ | STAR_ASSIGN^^ | DIV_ASSIGN^^ | MOD_ASSIGN^^ | PLUS_ASSIGN^^ | MINUS_ASSIGN^^ | SL_ASSIGN^^ | SR_ASSIGN^^ | BSR_ASSIGN^^ | BAND_ASSIGN^^ | BXOR_ASSIGN^^ | BOR_ASSIGN^^ | LAND_ASSIGN^^ | LOR_ASSIGN^^ ) assignmentExpression )? ;
    public assignmentExpression_return assignmentExpression() throws RecognitionException {   
        assignmentExpression_return retval = new assignmentExpression_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token ASSIGN255=null;
        Token STAR_ASSIGN256=null;
        Token DIV_ASSIGN257=null;
        Token MOD_ASSIGN258=null;
        Token PLUS_ASSIGN259=null;
        Token MINUS_ASSIGN260=null;
        Token SL_ASSIGN261=null;
        Token SR_ASSIGN262=null;
        Token BSR_ASSIGN263=null;
        Token BAND_ASSIGN264=null;
        Token BXOR_ASSIGN265=null;
        Token BOR_ASSIGN266=null;
        Token LAND_ASSIGN267=null;
        Token LOR_ASSIGN268=null;
        conditionalExpression_return conditionalExpression254 = null;

        assignmentExpression_return assignmentExpression269 = null;


        LinkedListTree ASSIGN255_tree=null;
        LinkedListTree STAR_ASSIGN256_tree=null;
        LinkedListTree DIV_ASSIGN257_tree=null;
        LinkedListTree MOD_ASSIGN258_tree=null;
        LinkedListTree PLUS_ASSIGN259_tree=null;
        LinkedListTree MINUS_ASSIGN260_tree=null;
        LinkedListTree SL_ASSIGN261_tree=null;
        LinkedListTree SR_ASSIGN262_tree=null;
        LinkedListTree BSR_ASSIGN263_tree=null;
        LinkedListTree BAND_ASSIGN264_tree=null;
        LinkedListTree BXOR_ASSIGN265_tree=null;
        LinkedListTree BOR_ASSIGN266_tree=null;
        LinkedListTree LAND_ASSIGN267_tree=null;
        LinkedListTree LOR_ASSIGN268_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:617:4: ( conditionalExpression ( ( (ASSIGN|STAR_ASSIGN|DIV_ASSIGN|MOD_ASSIGN|PLUS_ASSIGN|MINUS_ASSIGN|SL_ASSIGN|SR_ASSIGN|BSR_ASSIGN|BAND_ASSIGN|BXOR_ASSIGN|BOR_ASSIGN|LAND_ASSIGN|LOR_ASSIGN)~ ASSIGN )=> ( ASSIGN^^ | STAR_ASSIGN^^ | DIV_ASSIGN^^ | MOD_ASSIGN^^ | PLUS_ASSIGN^^ | MINUS_ASSIGN^^ | SL_ASSIGN^^ | SR_ASSIGN^^ | BSR_ASSIGN^^ | BAND_ASSIGN^^ | BXOR_ASSIGN^^ | BOR_ASSIGN^^ | LAND_ASSIGN^^ | LOR_ASSIGN^^ ) assignmentExpression )? )
            // org/asdt/core/internal/antlr/as3.g3:617:4: conditionalExpression ( ( (ASSIGN|STAR_ASSIGN|DIV_ASSIGN|MOD_ASSIGN|PLUS_ASSIGN|MINUS_ASSIGN|SL_ASSIGN|SR_ASSIGN|BSR_ASSIGN|BAND_ASSIGN|BXOR_ASSIGN|BOR_ASSIGN|LAND_ASSIGN|LOR_ASSIGN)~ ASSIGN )=> ( ASSIGN^^ | STAR_ASSIGN^^ | DIV_ASSIGN^^ | MOD_ASSIGN^^ | PLUS_ASSIGN^^ | MINUS_ASSIGN^^ | SL_ASSIGN^^ | SR_ASSIGN^^ | BSR_ASSIGN^^ | BAND_ASSIGN^^ | BXOR_ASSIGN^^ | BOR_ASSIGN^^ | LAND_ASSIGN^^ | LOR_ASSIGN^^ ) assignmentExpression )?
            {
            root_0 = (LinkedListTree)adaptor.nil();

            pushFollow(FOLLOW_conditionalExpression_in_assignmentExpression2684);
            conditionalExpression254=conditionalExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, conditionalExpression254.tree);
            // org/asdt/core/internal/antlr/as3.g3:618:2: ( ( (ASSIGN|STAR_ASSIGN|DIV_ASSIGN|MOD_ASSIGN|PLUS_ASSIGN|MINUS_ASSIGN|SL_ASSIGN|SR_ASSIGN|BSR_ASSIGN|BAND_ASSIGN|BXOR_ASSIGN|BOR_ASSIGN|LAND_ASSIGN|LOR_ASSIGN)~ ASSIGN )=> ( ASSIGN^^ | STAR_ASSIGN^^ | DIV_ASSIGN^^ | MOD_ASSIGN^^ | PLUS_ASSIGN^^ | MINUS_ASSIGN^^ | SL_ASSIGN^^ | SR_ASSIGN^^ | BSR_ASSIGN^^ | BAND_ASSIGN^^ | BXOR_ASSIGN^^ | BOR_ASSIGN^^ | LAND_ASSIGN^^ | LOR_ASSIGN^^ ) assignmentExpression )?
            int alt69=2;
            switch ( input.LA(1) ) {
                case ASSIGN:
                    if ( (synpred3()) ) {
                        alt69=1;
                    }
                    break;
                case STAR_ASSIGN:
                    if ( (synpred3()) ) {
                        alt69=1;
                    }
                    break;
                case DIV_ASSIGN:
                    if ( (synpred3()) ) {
                        alt69=1;
                    }
                    break;
                case MOD_ASSIGN:
                    if ( (synpred3()) ) {
                        alt69=1;
                    }
                    break;
                case PLUS_ASSIGN:
                    if ( (synpred3()) ) {
                        alt69=1;
                    }
                    break;
                case MINUS_ASSIGN:
                    if ( (synpred3()) ) {
                        alt69=1;
                    }
                    break;
                case SL_ASSIGN:
                    if ( (synpred3()) ) {
                        alt69=1;
                    }
                    break;
                case SR_ASSIGN:
                    if ( (synpred3()) ) {
                        alt69=1;
                    }
                    break;
                case BSR_ASSIGN:
                    if ( (synpred3()) ) {
                        alt69=1;
                    }
                    break;
                case BAND_ASSIGN:
                    if ( (synpred3()) ) {
                        alt69=1;
                    }
                    break;
                case BXOR_ASSIGN:
                    if ( (synpred3()) ) {
                        alt69=1;
                    }
                    break;
                case BOR_ASSIGN:
                    if ( (synpred3()) ) {
                        alt69=1;
                    }
                    break;
                case LAND_ASSIGN:
                    if ( (synpred3()) ) {
                        alt69=1;
                    }
                    break;
                case LOR_ASSIGN:
                    if ( (synpred3()) ) {
                        alt69=1;
                    }
                    break;
            }

            switch (alt69) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:618:4: ( (ASSIGN|STAR_ASSIGN|DIV_ASSIGN|MOD_ASSIGN|PLUS_ASSIGN|MINUS_ASSIGN|SL_ASSIGN|SR_ASSIGN|BSR_ASSIGN|BAND_ASSIGN|BXOR_ASSIGN|BOR_ASSIGN|LAND_ASSIGN|LOR_ASSIGN)~ ASSIGN )=> ( ASSIGN^^ | STAR_ASSIGN^^ | DIV_ASSIGN^^ | MOD_ASSIGN^^ | PLUS_ASSIGN^^ | MINUS_ASSIGN^^ | SL_ASSIGN^^ | SR_ASSIGN^^ | BSR_ASSIGN^^ | BAND_ASSIGN^^ | BXOR_ASSIGN^^ | BOR_ASSIGN^^ | LAND_ASSIGN^^ | LOR_ASSIGN^^ ) assignmentExpression
                    {
                    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    // org/asdt/core/internal/antlr/as3.g3:634:4: ( ASSIGN^^ | STAR_ASSIGN^^ | DIV_ASSIGN^^ | MOD_ASSIGN^^ | PLUS_ASSIGN^^ | MINUS_ASSIGN^^ | SL_ASSIGN^^ | SR_ASSIGN^^ | BSR_ASSIGN^^ | BAND_ASSIGN^^ | BXOR_ASSIGN^^ | BOR_ASSIGN^^ | LAND_ASSIGN^^ | LOR_ASSIGN^^ )
                    int alt68=14;
                    switch ( input.LA(1) ) {
                    case ASSIGN:
                        alt68=1;
                        break;
                    case STAR_ASSIGN:
                        alt68=2;
                        break;
                    case DIV_ASSIGN:
                        alt68=3;
                        break;
                    case MOD_ASSIGN:
                        alt68=4;
                        break;
                    case PLUS_ASSIGN:
                        alt68=5;
                        break;
                    case MINUS_ASSIGN:
                        alt68=6;
                        break;
                    case SL_ASSIGN:
                        alt68=7;
                        break;
                    case SR_ASSIGN:
                        alt68=8;
                        break;
                    case BSR_ASSIGN:
                        alt68=9;
                        break;
                    case BAND_ASSIGN:
                        alt68=10;
                        break;
                    case BXOR_ASSIGN:
                        alt68=11;
                        break;
                    case BOR_ASSIGN:
                        alt68=12;
                        break;
                    case LAND_ASSIGN:
                        alt68=13;
                        break;
                    case LOR_ASSIGN:
                        alt68=14;
                        break;
                    default:
                        if (backtracking>0) {failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("634:4: ( ASSIGN^^ | STAR_ASSIGN^^ | DIV_ASSIGN^^ | MOD_ASSIGN^^ | PLUS_ASSIGN^^ | MINUS_ASSIGN^^ | SL_ASSIGN^^ | SR_ASSIGN^^ | BSR_ASSIGN^^ | BAND_ASSIGN^^ | BXOR_ASSIGN^^ | BOR_ASSIGN^^ | LAND_ASSIGN^^ | LOR_ASSIGN^^ )", 68, 0, input);

                        throw nvae;
                    }

                    switch (alt68) {
                        case 1 :
                            // org/asdt/core/internal/antlr/as3.g3:634:6: ASSIGN^^
                            {
                            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

                            ASSIGN255=(Token)input.LT(1);
                            match(input,ASSIGN,FOLLOW_ASSIGN_in_assignmentExpression2805); if (failed) return retval;
                            if ( backtracking==0 ) {
                            ASSIGN255_tree = (LinkedListTree)adaptor.create(ASSIGN255);
                            root_0 = (LinkedListTree)adaptor.becomeRoot(ASSIGN255_tree, root_0);
                            }

                            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

                            }
                            break;
                        case 2 :
                            // org/asdt/core/internal/antlr/as3.g3:635:7: STAR_ASSIGN^^
                            {
                            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

                            STAR_ASSIGN256=(Token)input.LT(1);
                            match(input,STAR_ASSIGN,FOLLOW_STAR_ASSIGN_in_assignmentExpression2814); if (failed) return retval;
                            if ( backtracking==0 ) {
                            STAR_ASSIGN256_tree = (LinkedListTree)adaptor.create(STAR_ASSIGN256);
                            root_0 = (LinkedListTree)adaptor.becomeRoot(STAR_ASSIGN256_tree, root_0);
                            }

                            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

                            }
                            break;
                        case 3 :
                            // org/asdt/core/internal/antlr/as3.g3:636:6: DIV_ASSIGN^^
                            {
                            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

                            DIV_ASSIGN257=(Token)input.LT(1);
                            match(input,DIV_ASSIGN,FOLLOW_DIV_ASSIGN_in_assignmentExpression2822); if (failed) return retval;
                            if ( backtracking==0 ) {
                            DIV_ASSIGN257_tree = (LinkedListTree)adaptor.create(DIV_ASSIGN257);
                            root_0 = (LinkedListTree)adaptor.becomeRoot(DIV_ASSIGN257_tree, root_0);
                            }

                            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

                            }
                            break;
                        case 4 :
                            // org/asdt/core/internal/antlr/as3.g3:637:6: MOD_ASSIGN^^
                            {
                            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

                            MOD_ASSIGN258=(Token)input.LT(1);
                            match(input,MOD_ASSIGN,FOLLOW_MOD_ASSIGN_in_assignmentExpression2830); if (failed) return retval;
                            if ( backtracking==0 ) {
                            MOD_ASSIGN258_tree = (LinkedListTree)adaptor.create(MOD_ASSIGN258);
                            root_0 = (LinkedListTree)adaptor.becomeRoot(MOD_ASSIGN258_tree, root_0);
                            }

                            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

                            }
                            break;
                        case 5 :
                            // org/asdt/core/internal/antlr/as3.g3:638:6: PLUS_ASSIGN^^
                            {
                            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

                            PLUS_ASSIGN259=(Token)input.LT(1);
                            match(input,PLUS_ASSIGN,FOLLOW_PLUS_ASSIGN_in_assignmentExpression2838); if (failed) return retval;
                            if ( backtracking==0 ) {
                            PLUS_ASSIGN259_tree = (LinkedListTree)adaptor.create(PLUS_ASSIGN259);
                            root_0 = (LinkedListTree)adaptor.becomeRoot(PLUS_ASSIGN259_tree, root_0);
                            }

                            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

                            }
                            break;
                        case 6 :
                            // org/asdt/core/internal/antlr/as3.g3:639:6: MINUS_ASSIGN^^
                            {
                            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

                            MINUS_ASSIGN260=(Token)input.LT(1);
                            match(input,MINUS_ASSIGN,FOLLOW_MINUS_ASSIGN_in_assignmentExpression2846); if (failed) return retval;
                            if ( backtracking==0 ) {
                            MINUS_ASSIGN260_tree = (LinkedListTree)adaptor.create(MINUS_ASSIGN260);
                            root_0 = (LinkedListTree)adaptor.becomeRoot(MINUS_ASSIGN260_tree, root_0);
                            }

                            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

                            }
                            break;
                        case 7 :
                            // org/asdt/core/internal/antlr/as3.g3:640:6: SL_ASSIGN^^
                            {
                            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

                            SL_ASSIGN261=(Token)input.LT(1);
                            match(input,SL_ASSIGN,FOLLOW_SL_ASSIGN_in_assignmentExpression2854); if (failed) return retval;
                            if ( backtracking==0 ) {
                            SL_ASSIGN261_tree = (LinkedListTree)adaptor.create(SL_ASSIGN261);
                            root_0 = (LinkedListTree)adaptor.becomeRoot(SL_ASSIGN261_tree, root_0);
                            }

                            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

                            }
                            break;
                        case 8 :
                            // org/asdt/core/internal/antlr/as3.g3:641:6: SR_ASSIGN^^
                            {
                            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

                            SR_ASSIGN262=(Token)input.LT(1);
                            match(input,SR_ASSIGN,FOLLOW_SR_ASSIGN_in_assignmentExpression2862); if (failed) return retval;
                            if ( backtracking==0 ) {
                            SR_ASSIGN262_tree = (LinkedListTree)adaptor.create(SR_ASSIGN262);
                            root_0 = (LinkedListTree)adaptor.becomeRoot(SR_ASSIGN262_tree, root_0);
                            }

                            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

                            }
                            break;
                        case 9 :
                            // org/asdt/core/internal/antlr/as3.g3:642:6: BSR_ASSIGN^^
                            {
                            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

                            BSR_ASSIGN263=(Token)input.LT(1);
                            match(input,BSR_ASSIGN,FOLLOW_BSR_ASSIGN_in_assignmentExpression2870); if (failed) return retval;
                            if ( backtracking==0 ) {
                            BSR_ASSIGN263_tree = (LinkedListTree)adaptor.create(BSR_ASSIGN263);
                            root_0 = (LinkedListTree)adaptor.becomeRoot(BSR_ASSIGN263_tree, root_0);
                            }

                            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

                            }
                            break;
                        case 10 :
                            // org/asdt/core/internal/antlr/as3.g3:643:6: BAND_ASSIGN^^
                            {
                            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

                            BAND_ASSIGN264=(Token)input.LT(1);
                            match(input,BAND_ASSIGN,FOLLOW_BAND_ASSIGN_in_assignmentExpression2878); if (failed) return retval;
                            if ( backtracking==0 ) {
                            BAND_ASSIGN264_tree = (LinkedListTree)adaptor.create(BAND_ASSIGN264);
                            root_0 = (LinkedListTree)adaptor.becomeRoot(BAND_ASSIGN264_tree, root_0);
                            }

                            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

                            }
                            break;
                        case 11 :
                            // org/asdt/core/internal/antlr/as3.g3:644:6: BXOR_ASSIGN^^
                            {
                            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

                            BXOR_ASSIGN265=(Token)input.LT(1);
                            match(input,BXOR_ASSIGN,FOLLOW_BXOR_ASSIGN_in_assignmentExpression2886); if (failed) return retval;
                            if ( backtracking==0 ) {
                            BXOR_ASSIGN265_tree = (LinkedListTree)adaptor.create(BXOR_ASSIGN265);
                            root_0 = (LinkedListTree)adaptor.becomeRoot(BXOR_ASSIGN265_tree, root_0);
                            }

                            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

                            }
                            break;
                        case 12 :
                            // org/asdt/core/internal/antlr/as3.g3:645:6: BOR_ASSIGN^^
                            {
                            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

                            BOR_ASSIGN266=(Token)input.LT(1);
                            match(input,BOR_ASSIGN,FOLLOW_BOR_ASSIGN_in_assignmentExpression2894); if (failed) return retval;
                            if ( backtracking==0 ) {
                            BOR_ASSIGN266_tree = (LinkedListTree)adaptor.create(BOR_ASSIGN266);
                            root_0 = (LinkedListTree)adaptor.becomeRoot(BOR_ASSIGN266_tree, root_0);
                            }

                            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

                            }
                            break;
                        case 13 :
                            // org/asdt/core/internal/antlr/as3.g3:646:6: LAND_ASSIGN^^
                            {
                            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

                            LAND_ASSIGN267=(Token)input.LT(1);
                            match(input,LAND_ASSIGN,FOLLOW_LAND_ASSIGN_in_assignmentExpression2902); if (failed) return retval;
                            if ( backtracking==0 ) {
                            LAND_ASSIGN267_tree = (LinkedListTree)adaptor.create(LAND_ASSIGN267);
                            root_0 = (LinkedListTree)adaptor.becomeRoot(LAND_ASSIGN267_tree, root_0);
                            }

                            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

                            }
                            break;
                        case 14 :
                            // org/asdt/core/internal/antlr/as3.g3:647:6: LOR_ASSIGN^^
                            {
                            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

                            LOR_ASSIGN268=(Token)input.LT(1);
                            match(input,LOR_ASSIGN,FOLLOW_LOR_ASSIGN_in_assignmentExpression2910); if (failed) return retval;
                            if ( backtracking==0 ) {
                            LOR_ASSIGN268_tree = (LinkedListTree)adaptor.create(LOR_ASSIGN268);
                            root_0 = (LinkedListTree)adaptor.becomeRoot(LOR_ASSIGN268_tree, root_0);
                            }

                            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

                            }
                            break;

                    }

                    pushFollow(FOLLOW_assignmentExpression_in_assignmentExpression2920);
                    assignmentExpression269=assignmentExpression();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_1, assignmentExpression269.tree);

                    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    }
                    break;

            }


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end assignmentExpression

    public static class conditionalExpression_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start conditionalExpression
    // org/asdt/core/internal/antlr/as3.g3:653:1: conditionalExpression : logicalOrExpression ( QUESTION^^ conditionalSubExpression )? ;
    public conditionalExpression_return conditionalExpression() throws RecognitionException {   
        conditionalExpression_return retval = new conditionalExpression_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token QUESTION271=null;
        logicalOrExpression_return logicalOrExpression270 = null;

        conditionalSubExpression_return conditionalSubExpression272 = null;


        LinkedListTree QUESTION271_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:654:4: ( logicalOrExpression ( QUESTION^^ conditionalSubExpression )? )
            // org/asdt/core/internal/antlr/as3.g3:654:4: logicalOrExpression ( QUESTION^^ conditionalSubExpression )?
            {
            root_0 = (LinkedListTree)adaptor.nil();

            pushFollow(FOLLOW_logicalOrExpression_in_conditionalExpression2935);
            logicalOrExpression270=logicalOrExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, logicalOrExpression270.tree);
            // org/asdt/core/internal/antlr/as3.g3:655:3: ( QUESTION^^ conditionalSubExpression )?
            int alt70=2;
            int LA70_0 = input.LA(1);
            if ( (LA70_0==QUESTION) ) {
                alt70=1;
            }
            switch (alt70) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:656:4: QUESTION^^ conditionalSubExpression
                    {
                    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                    QUESTION271=(Token)input.LT(1);
                    match(input,QUESTION,FOLLOW_QUESTION_in_conditionalExpression2945); if (failed) return retval;
                    if ( backtracking==0 ) {
                    QUESTION271_tree = (LinkedListTree)adaptor.create(QUESTION271);
                    root_0 = (LinkedListTree)adaptor.becomeRoot(QUESTION271_tree, root_0);
                    }
                    pushFollow(FOLLOW_conditionalSubExpression_in_conditionalExpression2951);
                    conditionalSubExpression272=conditionalSubExpression();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_1, conditionalSubExpression272.tree);

                    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                    }
                    break;

            }


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end conditionalExpression

    public static class conditionalSubExpression_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start conditionalSubExpression
    // org/asdt/core/internal/antlr/as3.g3:660:1: conditionalSubExpression : assignmentExpression COLON^^ assignmentExpression ;
    public conditionalSubExpression_return conditionalSubExpression() throws RecognitionException {   
        conditionalSubExpression_return retval = new conditionalSubExpression_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token COLON274=null;
        assignmentExpression_return assignmentExpression273 = null;

        assignmentExpression_return assignmentExpression275 = null;


        LinkedListTree COLON274_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:661:4: ( assignmentExpression COLON^^ assignmentExpression )
            // org/asdt/core/internal/antlr/as3.g3:661:4: assignmentExpression COLON^^ assignmentExpression
            {
            root_0 = (LinkedListTree)adaptor.nil();

            pushFollow(FOLLOW_assignmentExpression_in_conditionalSubExpression2966);
            assignmentExpression273=assignmentExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, assignmentExpression273.tree);
            COLON274=(Token)input.LT(1);
            match(input,COLON,FOLLOW_COLON_in_conditionalSubExpression2968); if (failed) return retval;
            if ( backtracking==0 ) {
            COLON274_tree = (LinkedListTree)adaptor.create(COLON274);
            root_0 = (LinkedListTree)adaptor.becomeRoot(COLON274_tree, root_0);
            }
            pushFollow(FOLLOW_assignmentExpression_in_conditionalSubExpression2971);
            assignmentExpression275=assignmentExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, assignmentExpression275.tree);

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end conditionalSubExpression

    public static class logicalOrExpression_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start logicalOrExpression
    // org/asdt/core/internal/antlr/as3.g3:664:1: logicalOrExpression : logicalAndExpression ( LOR^^ logicalAndExpression )* ;
    public logicalOrExpression_return logicalOrExpression() throws RecognitionException {   
        logicalOrExpression_return retval = new logicalOrExpression_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token LOR277=null;
        logicalAndExpression_return logicalAndExpression276 = null;

        logicalAndExpression_return logicalAndExpression278 = null;


        LinkedListTree LOR277_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:665:4: ( logicalAndExpression ( LOR^^ logicalAndExpression )* )
            // org/asdt/core/internal/antlr/as3.g3:665:4: logicalAndExpression ( LOR^^ logicalAndExpression )*
            {
            root_0 = (LinkedListTree)adaptor.nil();

            pushFollow(FOLLOW_logicalAndExpression_in_logicalOrExpression2982);
            logicalAndExpression276=logicalAndExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, logicalAndExpression276.tree);
            // org/asdt/core/internal/antlr/as3.g3:665:25: ( LOR^^ logicalAndExpression )*
            loop71:
            do {
                int alt71=2;
                int LA71_0 = input.LA(1);
                if ( (LA71_0==LOR) ) {
                    alt71=1;
                }


                switch (alt71) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:665:26: LOR^^ logicalAndExpression
            	    {
            	    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

            	    LOR277=(Token)input.LT(1);
            	    match(input,LOR,FOLLOW_LOR_in_logicalOrExpression2985); if (failed) return retval;
            	    if ( backtracking==0 ) {
            	    LOR277_tree = (LinkedListTree)adaptor.create(LOR277);
            	    root_0 = (LinkedListTree)adaptor.becomeRoot(LOR277_tree, root_0);
            	    }
            	    pushFollow(FOLLOW_logicalAndExpression_in_logicalOrExpression2988);
            	    logicalAndExpression278=logicalAndExpression();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_1, logicalAndExpression278.tree);

            	    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

            	    }
            	    break;

            	default :
            	    break loop71;
                }
            } while (true);


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end logicalOrExpression

    public static class logicalAndExpression_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start logicalAndExpression
    // org/asdt/core/internal/antlr/as3.g3:668:1: logicalAndExpression : bitwiseOrExpression ( LAND^^ bitwiseOrExpression )* ;
    public logicalAndExpression_return logicalAndExpression() throws RecognitionException {   
        logicalAndExpression_return retval = new logicalAndExpression_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token LAND280=null;
        bitwiseOrExpression_return bitwiseOrExpression279 = null;

        bitwiseOrExpression_return bitwiseOrExpression281 = null;


        LinkedListTree LAND280_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:669:4: ( bitwiseOrExpression ( LAND^^ bitwiseOrExpression )* )
            // org/asdt/core/internal/antlr/as3.g3:669:4: bitwiseOrExpression ( LAND^^ bitwiseOrExpression )*
            {
            root_0 = (LinkedListTree)adaptor.nil();

            pushFollow(FOLLOW_bitwiseOrExpression_in_logicalAndExpression3001);
            bitwiseOrExpression279=bitwiseOrExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, bitwiseOrExpression279.tree);
            // org/asdt/core/internal/antlr/as3.g3:669:24: ( LAND^^ bitwiseOrExpression )*
            loop72:
            do {
                int alt72=2;
                int LA72_0 = input.LA(1);
                if ( (LA72_0==LAND) ) {
                    alt72=1;
                }


                switch (alt72) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:669:25: LAND^^ bitwiseOrExpression
            	    {
            	    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

            	    LAND280=(Token)input.LT(1);
            	    match(input,LAND,FOLLOW_LAND_in_logicalAndExpression3004); if (failed) return retval;
            	    if ( backtracking==0 ) {
            	    LAND280_tree = (LinkedListTree)adaptor.create(LAND280);
            	    root_0 = (LinkedListTree)adaptor.becomeRoot(LAND280_tree, root_0);
            	    }
            	    pushFollow(FOLLOW_bitwiseOrExpression_in_logicalAndExpression3007);
            	    bitwiseOrExpression281=bitwiseOrExpression();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_1, bitwiseOrExpression281.tree);

            	    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

            	    }
            	    break;

            	default :
            	    break loop72;
                }
            } while (true);


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end logicalAndExpression

    public static class bitwiseOrExpression_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start bitwiseOrExpression
    // org/asdt/core/internal/antlr/as3.g3:672:1: bitwiseOrExpression : bitwiseXorExpression ( BOR^^ bitwiseXorExpression )* ;
    public bitwiseOrExpression_return bitwiseOrExpression() throws RecognitionException {   
        bitwiseOrExpression_return retval = new bitwiseOrExpression_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token BOR283=null;
        bitwiseXorExpression_return bitwiseXorExpression282 = null;

        bitwiseXorExpression_return bitwiseXorExpression284 = null;


        LinkedListTree BOR283_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:673:4: ( bitwiseXorExpression ( BOR^^ bitwiseXorExpression )* )
            // org/asdt/core/internal/antlr/as3.g3:673:4: bitwiseXorExpression ( BOR^^ bitwiseXorExpression )*
            {
            root_0 = (LinkedListTree)adaptor.nil();

            pushFollow(FOLLOW_bitwiseXorExpression_in_bitwiseOrExpression3020);
            bitwiseXorExpression282=bitwiseXorExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, bitwiseXorExpression282.tree);
            // org/asdt/core/internal/antlr/as3.g3:673:25: ( BOR^^ bitwiseXorExpression )*
            loop73:
            do {
                int alt73=2;
                int LA73_0 = input.LA(1);
                if ( (LA73_0==BOR) ) {
                    alt73=1;
                }


                switch (alt73) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:673:26: BOR^^ bitwiseXorExpression
            	    {
            	    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

            	    BOR283=(Token)input.LT(1);
            	    match(input,BOR,FOLLOW_BOR_in_bitwiseOrExpression3023); if (failed) return retval;
            	    if ( backtracking==0 ) {
            	    BOR283_tree = (LinkedListTree)adaptor.create(BOR283);
            	    root_0 = (LinkedListTree)adaptor.becomeRoot(BOR283_tree, root_0);
            	    }
            	    pushFollow(FOLLOW_bitwiseXorExpression_in_bitwiseOrExpression3026);
            	    bitwiseXorExpression284=bitwiseXorExpression();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_1, bitwiseXorExpression284.tree);

            	    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

            	    }
            	    break;

            	default :
            	    break loop73;
                }
            } while (true);


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end bitwiseOrExpression

    public static class bitwiseXorExpression_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start bitwiseXorExpression
    // org/asdt/core/internal/antlr/as3.g3:676:1: bitwiseXorExpression : bitwiseAndExpression ( BXOR^^ bitwiseAndExpression )* ;
    public bitwiseXorExpression_return bitwiseXorExpression() throws RecognitionException {   
        bitwiseXorExpression_return retval = new bitwiseXorExpression_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token BXOR286=null;
        bitwiseAndExpression_return bitwiseAndExpression285 = null;

        bitwiseAndExpression_return bitwiseAndExpression287 = null;


        LinkedListTree BXOR286_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:677:4: ( bitwiseAndExpression ( BXOR^^ bitwiseAndExpression )* )
            // org/asdt/core/internal/antlr/as3.g3:677:4: bitwiseAndExpression ( BXOR^^ bitwiseAndExpression )*
            {
            root_0 = (LinkedListTree)adaptor.nil();

            pushFollow(FOLLOW_bitwiseAndExpression_in_bitwiseXorExpression3040);
            bitwiseAndExpression285=bitwiseAndExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, bitwiseAndExpression285.tree);
            // org/asdt/core/internal/antlr/as3.g3:677:25: ( BXOR^^ bitwiseAndExpression )*
            loop74:
            do {
                int alt74=2;
                int LA74_0 = input.LA(1);
                if ( (LA74_0==BXOR) ) {
                    alt74=1;
                }


                switch (alt74) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:677:26: BXOR^^ bitwiseAndExpression
            	    {
            	    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

            	    BXOR286=(Token)input.LT(1);
            	    match(input,BXOR,FOLLOW_BXOR_in_bitwiseXorExpression3043); if (failed) return retval;
            	    if ( backtracking==0 ) {
            	    BXOR286_tree = (LinkedListTree)adaptor.create(BXOR286);
            	    root_0 = (LinkedListTree)adaptor.becomeRoot(BXOR286_tree, root_0);
            	    }
            	    pushFollow(FOLLOW_bitwiseAndExpression_in_bitwiseXorExpression3046);
            	    bitwiseAndExpression287=bitwiseAndExpression();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_1, bitwiseAndExpression287.tree);

            	    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

            	    }
            	    break;

            	default :
            	    break loop74;
                }
            } while (true);


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end bitwiseXorExpression

    public static class bitwiseAndExpression_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start bitwiseAndExpression
    // org/asdt/core/internal/antlr/as3.g3:680:1: bitwiseAndExpression : equalityExpression ( BAND^^ equalityExpression )* ;
    public bitwiseAndExpression_return bitwiseAndExpression() throws RecognitionException {   
        bitwiseAndExpression_return retval = new bitwiseAndExpression_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token BAND289=null;
        equalityExpression_return equalityExpression288 = null;

        equalityExpression_return equalityExpression290 = null;


        LinkedListTree BAND289_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:681:4: ( equalityExpression ( BAND^^ equalityExpression )* )
            // org/asdt/core/internal/antlr/as3.g3:681:4: equalityExpression ( BAND^^ equalityExpression )*
            {
            root_0 = (LinkedListTree)adaptor.nil();

            pushFollow(FOLLOW_equalityExpression_in_bitwiseAndExpression3059);
            equalityExpression288=equalityExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, equalityExpression288.tree);
            // org/asdt/core/internal/antlr/as3.g3:681:23: ( BAND^^ equalityExpression )*
            loop75:
            do {
                int alt75=2;
                int LA75_0 = input.LA(1);
                if ( (LA75_0==BAND) ) {
                    alt75=1;
                }


                switch (alt75) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:681:24: BAND^^ equalityExpression
            	    {
            	    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

            	    BAND289=(Token)input.LT(1);
            	    match(input,BAND,FOLLOW_BAND_in_bitwiseAndExpression3062); if (failed) return retval;
            	    if ( backtracking==0 ) {
            	    BAND289_tree = (LinkedListTree)adaptor.create(BAND289);
            	    root_0 = (LinkedListTree)adaptor.becomeRoot(BAND289_tree, root_0);
            	    }
            	    pushFollow(FOLLOW_equalityExpression_in_bitwiseAndExpression3065);
            	    equalityExpression290=equalityExpression();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_1, equalityExpression290.tree);

            	    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

            	    }
            	    break;

            	default :
            	    break loop75;
                }
            } while (true);


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end bitwiseAndExpression

    public static class equalityExpression_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start equalityExpression
    // org/asdt/core/internal/antlr/as3.g3:684:1: equalityExpression : relationalExpression ( ( STRICT_EQUAL^^ | STRICT_NOT_EQUAL^^ | NOT_EQUAL^^ | EQUAL^^ ) relationalExpression )* ;
    public equalityExpression_return equalityExpression() throws RecognitionException {   
        equalityExpression_return retval = new equalityExpression_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token STRICT_EQUAL292=null;
        Token STRICT_NOT_EQUAL293=null;
        Token NOT_EQUAL294=null;
        Token EQUAL295=null;
        relationalExpression_return relationalExpression291 = null;

        relationalExpression_return relationalExpression296 = null;


        LinkedListTree STRICT_EQUAL292_tree=null;
        LinkedListTree STRICT_NOT_EQUAL293_tree=null;
        LinkedListTree NOT_EQUAL294_tree=null;
        LinkedListTree EQUAL295_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:685:4: ( relationalExpression ( ( STRICT_EQUAL^^ | STRICT_NOT_EQUAL^^ | NOT_EQUAL^^ | EQUAL^^ ) relationalExpression )* )
            // org/asdt/core/internal/antlr/as3.g3:685:4: relationalExpression ( ( STRICT_EQUAL^^ | STRICT_NOT_EQUAL^^ | NOT_EQUAL^^ | EQUAL^^ ) relationalExpression )*
            {
            root_0 = (LinkedListTree)adaptor.nil();

            pushFollow(FOLLOW_relationalExpression_in_equalityExpression3078);
            relationalExpression291=relationalExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, relationalExpression291.tree);
            // org/asdt/core/internal/antlr/as3.g3:686:2: ( ( STRICT_EQUAL^^ | STRICT_NOT_EQUAL^^ | NOT_EQUAL^^ | EQUAL^^ ) relationalExpression )*
            loop77:
            do {
                int alt77=2;
                int LA77_0 = input.LA(1);
                if ( ((LA77_0>=STRICT_EQUAL && LA77_0<=EQUAL)) ) {
                    alt77=1;
                }


                switch (alt77) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:686:4: ( STRICT_EQUAL^^ | STRICT_NOT_EQUAL^^ | NOT_EQUAL^^ | EQUAL^^ ) relationalExpression
            	    {
            	    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

            	    // org/asdt/core/internal/antlr/as3.g3:686:4: ( STRICT_EQUAL^^ | STRICT_NOT_EQUAL^^ | NOT_EQUAL^^ | EQUAL^^ )
            	    int alt76=4;
            	    switch ( input.LA(1) ) {
            	    case STRICT_EQUAL:
            	        alt76=1;
            	        break;
            	    case STRICT_NOT_EQUAL:
            	        alt76=2;
            	        break;
            	    case NOT_EQUAL:
            	        alt76=3;
            	        break;
            	    case EQUAL:
            	        alt76=4;
            	        break;
            	    default:
            	        if (backtracking>0) {failed=true; return retval;}
            	        NoViableAltException nvae =
            	            new NoViableAltException("686:4: ( STRICT_EQUAL^^ | STRICT_NOT_EQUAL^^ | NOT_EQUAL^^ | EQUAL^^ )", 76, 0, input);

            	        throw nvae;
            	    }

            	    switch (alt76) {
            	        case 1 :
            	            // org/asdt/core/internal/antlr/as3.g3:686:6: STRICT_EQUAL^^
            	            {
            	            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

            	            STRICT_EQUAL292=(Token)input.LT(1);
            	            match(input,STRICT_EQUAL,FOLLOW_STRICT_EQUAL_in_equalityExpression3086); if (failed) return retval;
            	            if ( backtracking==0 ) {
            	            STRICT_EQUAL292_tree = (LinkedListTree)adaptor.create(STRICT_EQUAL292);
            	            root_0 = (LinkedListTree)adaptor.becomeRoot(STRICT_EQUAL292_tree, root_0);
            	            }

            	            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

            	            }
            	            break;
            	        case 2 :
            	            // org/asdt/core/internal/antlr/as3.g3:686:23: STRICT_NOT_EQUAL^^
            	            {
            	            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

            	            STRICT_NOT_EQUAL293=(Token)input.LT(1);
            	            match(input,STRICT_NOT_EQUAL,FOLLOW_STRICT_NOT_EQUAL_in_equalityExpression3091); if (failed) return retval;
            	            if ( backtracking==0 ) {
            	            STRICT_NOT_EQUAL293_tree = (LinkedListTree)adaptor.create(STRICT_NOT_EQUAL293);
            	            root_0 = (LinkedListTree)adaptor.becomeRoot(STRICT_NOT_EQUAL293_tree, root_0);
            	            }

            	            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

            	            }
            	            break;
            	        case 3 :
            	            // org/asdt/core/internal/antlr/as3.g3:686:44: NOT_EQUAL^^
            	            {
            	            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

            	            NOT_EQUAL294=(Token)input.LT(1);
            	            match(input,NOT_EQUAL,FOLLOW_NOT_EQUAL_in_equalityExpression3096); if (failed) return retval;
            	            if ( backtracking==0 ) {
            	            NOT_EQUAL294_tree = (LinkedListTree)adaptor.create(NOT_EQUAL294);
            	            root_0 = (LinkedListTree)adaptor.becomeRoot(NOT_EQUAL294_tree, root_0);
            	            }

            	            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

            	            }
            	            break;
            	        case 4 :
            	            // org/asdt/core/internal/antlr/as3.g3:686:58: EQUAL^^
            	            {
            	            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

            	            EQUAL295=(Token)input.LT(1);
            	            match(input,EQUAL,FOLLOW_EQUAL_in_equalityExpression3101); if (failed) return retval;
            	            if ( backtracking==0 ) {
            	            EQUAL295_tree = (LinkedListTree)adaptor.create(EQUAL295);
            	            root_0 = (LinkedListTree)adaptor.becomeRoot(EQUAL295_tree, root_0);
            	            }

            	            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

            	            }
            	            break;

            	    }

            	    pushFollow(FOLLOW_relationalExpression_in_equalityExpression3108);
            	    relationalExpression296=relationalExpression();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_1, relationalExpression296.tree);

            	    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

            	    }
            	    break;

            	default :
            	    break loop77;
                }
            } while (true);


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end equalityExpression

    public static class relationalExpression_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start relationalExpression
    // org/asdt/core/internal/antlr/as3.g3:692:1: relationalExpression : shiftExpression ( ( LT^^ | GT^^ | LE^^ | GE^^ | 'is'^^ | 'as'^^ ) shiftExpression )* ;
    public relationalExpression_return relationalExpression() throws RecognitionException {   
        relationalExpression_return retval = new relationalExpression_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token LT298=null;
        Token GT299=null;
        Token LE300=null;
        Token GE301=null;
        Token string_literal302=null;
        Token string_literal303=null;
        shiftExpression_return shiftExpression297 = null;

        shiftExpression_return shiftExpression304 = null;


        LinkedListTree LT298_tree=null;
        LinkedListTree GT299_tree=null;
        LinkedListTree LE300_tree=null;
        LinkedListTree GE301_tree=null;
        LinkedListTree string_literal302_tree=null;
        LinkedListTree string_literal303_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:693:4: ( shiftExpression ( ( LT^^ | GT^^ | LE^^ | GE^^ | 'is'^^ | 'as'^^ ) shiftExpression )* )
            // org/asdt/core/internal/antlr/as3.g3:693:4: shiftExpression ( ( LT^^ | GT^^ | LE^^ | GE^^ | 'is'^^ | 'as'^^ ) shiftExpression )*
            {
            root_0 = (LinkedListTree)adaptor.nil();

            pushFollow(FOLLOW_shiftExpression_in_relationalExpression3125);
            shiftExpression297=shiftExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, shiftExpression297.tree);
            // org/asdt/core/internal/antlr/as3.g3:693:20: ( ( LT^^ | GT^^ | LE^^ | GE^^ | 'is'^^ | 'as'^^ ) shiftExpression )*
            loop79:
            do {
                int alt79=2;
                int LA79_0 = input.LA(1);
                if ( (LA79_0==LT) ) {
                    switch ( input.LA(2) ) {
                    case LBRACK:
                        alt79=1;
                        break;
                    case INC:
                        alt79=1;
                        break;
                    case DEC:
                        alt79=1;
                        break;
                    case PLUS:
                        alt79=1;
                        break;
                    case MINUS:
                        alt79=1;
                        break;
                    case LT:
                        alt79=1;
                        break;
                    case LCURLY:
                        alt79=1;
                        break;
                    case 162:
                        alt79=1;
                        break;
                    case 152:
                        alt79=1;
                        break;
                    case 163:
                        alt79=1;
                        break;
                    case LNOT:
                        alt79=1;
                        break;
                    case BNOT:
                        alt79=1;
                        break;
                    case IDENT:
                        alt79=1;
                        break;
                    case 164:
                        alt79=1;
                        break;
                    case 165:
                        alt79=1;
                        break;
                    case HEX_LITERAL:
                    case DECIMAL_LITERAL:
                    case OCTAL_LITERAL:
                    case FLOAT_LITERAL:
                        alt79=1;
                        break;
                    case STRING_LITERAL:
                        alt79=1;
                        break;
                    case TRUE:
                        alt79=1;
                        break;
                    case FALSE:
                        alt79=1;
                        break;
                    case FUNCTION:
                        alt79=1;
                        break;
                    case 166:
                        alt79=1;
                        break;
                    case LPAREN:
                        alt79=1;
                        break;

                    }

                }
                else if ( ((LA79_0>=GT && LA79_0<=GE)||(LA79_0>=160 && LA79_0<=161)) ) {
                    alt79=1;
                }


                switch (alt79) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:693:21: ( LT^^ | GT^^ | LE^^ | GE^^ | 'is'^^ | 'as'^^ ) shiftExpression
            	    {
            	    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

            	    // org/asdt/core/internal/antlr/as3.g3:693:21: ( LT^^ | GT^^ | LE^^ | GE^^ | 'is'^^ | 'as'^^ )
            	    int alt78=6;
            	    switch ( input.LA(1) ) {
            	    case LT:
            	        alt78=1;
            	        break;
            	    case GT:
            	        alt78=2;
            	        break;
            	    case LE:
            	        alt78=3;
            	        break;
            	    case GE:
            	        alt78=4;
            	        break;
            	    case 160:
            	        alt78=5;
            	        break;
            	    case 161:
            	        alt78=6;
            	        break;
            	    default:
            	        if (backtracking>0) {failed=true; return retval;}
            	        NoViableAltException nvae =
            	            new NoViableAltException("693:21: ( LT^^ | GT^^ | LE^^ | GE^^ | 'is'^^ | 'as'^^ )", 78, 0, input);

            	        throw nvae;
            	    }

            	    switch (alt78) {
            	        case 1 :
            	            // org/asdt/core/internal/antlr/as3.g3:693:22: LT^^
            	            {
            	            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

            	            LT298=(Token)input.LT(1);
            	            match(input,LT,FOLLOW_LT_in_relationalExpression3129); if (failed) return retval;
            	            if ( backtracking==0 ) {
            	            LT298_tree = (LinkedListTree)adaptor.create(LT298);
            	            root_0 = (LinkedListTree)adaptor.becomeRoot(LT298_tree, root_0);
            	            }

            	            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

            	            }
            	            break;
            	        case 2 :
            	            // org/asdt/core/internal/antlr/as3.g3:693:29: GT^^
            	            {
            	            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

            	            GT299=(Token)input.LT(1);
            	            match(input,GT,FOLLOW_GT_in_relationalExpression3134); if (failed) return retval;
            	            if ( backtracking==0 ) {
            	            GT299_tree = (LinkedListTree)adaptor.create(GT299);
            	            root_0 = (LinkedListTree)adaptor.becomeRoot(GT299_tree, root_0);
            	            }

            	            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

            	            }
            	            break;
            	        case 3 :
            	            // org/asdt/core/internal/antlr/as3.g3:693:36: LE^^
            	            {
            	            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

            	            LE300=(Token)input.LT(1);
            	            match(input,LE,FOLLOW_LE_in_relationalExpression3139); if (failed) return retval;
            	            if ( backtracking==0 ) {
            	            LE300_tree = (LinkedListTree)adaptor.create(LE300);
            	            root_0 = (LinkedListTree)adaptor.becomeRoot(LE300_tree, root_0);
            	            }

            	            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

            	            }
            	            break;
            	        case 4 :
            	            // org/asdt/core/internal/antlr/as3.g3:693:43: GE^^
            	            {
            	            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

            	            GE301=(Token)input.LT(1);
            	            match(input,GE,FOLLOW_GE_in_relationalExpression3144); if (failed) return retval;
            	            if ( backtracking==0 ) {
            	            GE301_tree = (LinkedListTree)adaptor.create(GE301);
            	            root_0 = (LinkedListTree)adaptor.becomeRoot(GE301_tree, root_0);
            	            }

            	            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

            	            }
            	            break;
            	        case 5 :
            	            // org/asdt/core/internal/antlr/as3.g3:693:50: 'is'^^
            	            {
            	            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

            	            string_literal302=(Token)input.LT(1);
            	            match(input,160,FOLLOW_160_in_relationalExpression3149); if (failed) return retval;
            	            if ( backtracking==0 ) {
            	            string_literal302_tree = (LinkedListTree)adaptor.create(string_literal302);
            	            root_0 = (LinkedListTree)adaptor.becomeRoot(string_literal302_tree, root_0);
            	            }

            	            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

            	            }
            	            break;
            	        case 6 :
            	            // org/asdt/core/internal/antlr/as3.g3:693:59: 'as'^^
            	            {
            	            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

            	            string_literal303=(Token)input.LT(1);
            	            match(input,161,FOLLOW_161_in_relationalExpression3154); if (failed) return retval;
            	            if ( backtracking==0 ) {
            	            string_literal303_tree = (LinkedListTree)adaptor.create(string_literal303);
            	            root_0 = (LinkedListTree)adaptor.becomeRoot(string_literal303_tree, root_0);
            	            }

            	            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

            	            }
            	            break;

            	    }

            	    pushFollow(FOLLOW_shiftExpression_in_relationalExpression3158);
            	    shiftExpression304=shiftExpression();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_1, shiftExpression304.tree);

            	    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

            	    }
            	    break;

            	default :
            	    break loop79;
                }
            } while (true);


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end relationalExpression

    public static class shiftExpression_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start shiftExpression
    // org/asdt/core/internal/antlr/as3.g3:697:1: shiftExpression : additiveExpression ( ( SL^^ | SR^^ | BSR^^ ) additiveExpression )* ;
    public shiftExpression_return shiftExpression() throws RecognitionException {   
        shiftExpression_return retval = new shiftExpression_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token SL306=null;
        Token SR307=null;
        Token BSR308=null;
        additiveExpression_return additiveExpression305 = null;

        additiveExpression_return additiveExpression309 = null;


        LinkedListTree SL306_tree=null;
        LinkedListTree SR307_tree=null;
        LinkedListTree BSR308_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:698:4: ( additiveExpression ( ( SL^^ | SR^^ | BSR^^ ) additiveExpression )* )
            // org/asdt/core/internal/antlr/as3.g3:698:4: additiveExpression ( ( SL^^ | SR^^ | BSR^^ ) additiveExpression )*
            {
            root_0 = (LinkedListTree)adaptor.nil();

            pushFollow(FOLLOW_additiveExpression_in_shiftExpression3174);
            additiveExpression305=additiveExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, additiveExpression305.tree);
            // org/asdt/core/internal/antlr/as3.g3:698:23: ( ( SL^^ | SR^^ | BSR^^ ) additiveExpression )*
            loop81:
            do {
                int alt81=2;
                int LA81_0 = input.LA(1);
                if ( ((LA81_0>=SL && LA81_0<=BSR)) ) {
                    alt81=1;
                }


                switch (alt81) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:698:24: ( SL^^ | SR^^ | BSR^^ ) additiveExpression
            	    {
            	    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

            	    // org/asdt/core/internal/antlr/as3.g3:698:24: ( SL^^ | SR^^ | BSR^^ )
            	    int alt80=3;
            	    switch ( input.LA(1) ) {
            	    case SL:
            	        alt80=1;
            	        break;
            	    case SR:
            	        alt80=2;
            	        break;
            	    case BSR:
            	        alt80=3;
            	        break;
            	    default:
            	        if (backtracking>0) {failed=true; return retval;}
            	        NoViableAltException nvae =
            	            new NoViableAltException("698:24: ( SL^^ | SR^^ | BSR^^ )", 80, 0, input);

            	        throw nvae;
            	    }

            	    switch (alt80) {
            	        case 1 :
            	            // org/asdt/core/internal/antlr/as3.g3:698:25: SL^^
            	            {
            	            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

            	            SL306=(Token)input.LT(1);
            	            match(input,SL,FOLLOW_SL_in_shiftExpression3178); if (failed) return retval;
            	            if ( backtracking==0 ) {
            	            SL306_tree = (LinkedListTree)adaptor.create(SL306);
            	            root_0 = (LinkedListTree)adaptor.becomeRoot(SL306_tree, root_0);
            	            }

            	            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

            	            }
            	            break;
            	        case 2 :
            	            // org/asdt/core/internal/antlr/as3.g3:698:32: SR^^
            	            {
            	            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

            	            SR307=(Token)input.LT(1);
            	            match(input,SR,FOLLOW_SR_in_shiftExpression3183); if (failed) return retval;
            	            if ( backtracking==0 ) {
            	            SR307_tree = (LinkedListTree)adaptor.create(SR307);
            	            root_0 = (LinkedListTree)adaptor.becomeRoot(SR307_tree, root_0);
            	            }

            	            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

            	            }
            	            break;
            	        case 3 :
            	            // org/asdt/core/internal/antlr/as3.g3:698:39: BSR^^
            	            {
            	            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

            	            BSR308=(Token)input.LT(1);
            	            match(input,BSR,FOLLOW_BSR_in_shiftExpression3188); if (failed) return retval;
            	            if ( backtracking==0 ) {
            	            BSR308_tree = (LinkedListTree)adaptor.create(BSR308);
            	            root_0 = (LinkedListTree)adaptor.becomeRoot(BSR308_tree, root_0);
            	            }

            	            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

            	            }
            	            break;

            	    }

            	    pushFollow(FOLLOW_additiveExpression_in_shiftExpression3192);
            	    additiveExpression309=additiveExpression();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_1, additiveExpression309.tree);

            	    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

            	    }
            	    break;

            	default :
            	    break loop81;
                }
            } while (true);


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end shiftExpression

    public static class additiveExpression_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start additiveExpression
    // org/asdt/core/internal/antlr/as3.g3:702:1: additiveExpression : multiplicativeExpression ( ( PLUS^^ | MINUS^^ ) multiplicativeExpression )* ;
    public additiveExpression_return additiveExpression() throws RecognitionException {   
        additiveExpression_return retval = new additiveExpression_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token PLUS311=null;
        Token MINUS312=null;
        multiplicativeExpression_return multiplicativeExpression310 = null;

        multiplicativeExpression_return multiplicativeExpression313 = null;


        LinkedListTree PLUS311_tree=null;
        LinkedListTree MINUS312_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:703:4: ( multiplicativeExpression ( ( PLUS^^ | MINUS^^ ) multiplicativeExpression )* )
            // org/asdt/core/internal/antlr/as3.g3:703:4: multiplicativeExpression ( ( PLUS^^ | MINUS^^ ) multiplicativeExpression )*
            {
            root_0 = (LinkedListTree)adaptor.nil();

            pushFollow(FOLLOW_multiplicativeExpression_in_additiveExpression3208);
            multiplicativeExpression310=multiplicativeExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, multiplicativeExpression310.tree);
            // org/asdt/core/internal/antlr/as3.g3:703:29: ( ( PLUS^^ | MINUS^^ ) multiplicativeExpression )*
            loop83:
            do {
                int alt83=2;
                int LA83_0 = input.LA(1);
                if ( (LA83_0==MINUS) ) {
                    switch ( input.LA(2) ) {
                    case INC:
                        alt83=1;
                        break;
                    case DEC:
                        alt83=1;
                        break;
                    case MINUS:
                        alt83=1;
                        break;
                    case PLUS:
                        alt83=1;
                        break;
                    case 162:
                        alt83=1;
                        break;
                    case 152:
                        alt83=1;
                        break;
                    case 163:
                        alt83=1;
                        break;
                    case LNOT:
                        alt83=1;
                        break;
                    case BNOT:
                        alt83=1;
                        break;
                    case IDENT:
                        alt83=1;
                        break;
                    case 164:
                        alt83=1;
                        break;
                    case 165:
                        alt83=1;
                        break;
                    case LT:
                        alt83=1;
                        break;
                    case HEX_LITERAL:
                    case DECIMAL_LITERAL:
                    case OCTAL_LITERAL:
                    case FLOAT_LITERAL:
                        alt83=1;
                        break;
                    case STRING_LITERAL:
                        alt83=1;
                        break;
                    case TRUE:
                        alt83=1;
                        break;
                    case FALSE:
                        alt83=1;
                        break;
                    case LBRACK:
                        alt83=1;
                        break;
                    case LCURLY:
                        alt83=1;
                        break;
                    case FUNCTION:
                        alt83=1;
                        break;
                    case 166:
                        alt83=1;
                        break;
                    case LPAREN:
                        alt83=1;
                        break;

                    }

                }
                else if ( (LA83_0==PLUS) ) {
                    switch ( input.LA(2) ) {
                    case INC:
                        alt83=1;
                        break;
                    case DEC:
                        alt83=1;
                        break;
                    case MINUS:
                        alt83=1;
                        break;
                    case PLUS:
                        alt83=1;
                        break;
                    case 162:
                        alt83=1;
                        break;
                    case 152:
                        alt83=1;
                        break;
                    case 163:
                        alt83=1;
                        break;
                    case LNOT:
                        alt83=1;
                        break;
                    case BNOT:
                        alt83=1;
                        break;
                    case IDENT:
                        alt83=1;
                        break;
                    case 164:
                        alt83=1;
                        break;
                    case 165:
                        alt83=1;
                        break;
                    case LT:
                        alt83=1;
                        break;
                    case HEX_LITERAL:
                    case DECIMAL_LITERAL:
                    case OCTAL_LITERAL:
                    case FLOAT_LITERAL:
                        alt83=1;
                        break;
                    case STRING_LITERAL:
                        alt83=1;
                        break;
                    case TRUE:
                        alt83=1;
                        break;
                    case FALSE:
                        alt83=1;
                        break;
                    case LBRACK:
                        alt83=1;
                        break;
                    case LCURLY:
                        alt83=1;
                        break;
                    case FUNCTION:
                        alt83=1;
                        break;
                    case 166:
                        alt83=1;
                        break;
                    case LPAREN:
                        alt83=1;
                        break;

                    }

                }


                switch (alt83) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:703:30: ( PLUS^^ | MINUS^^ ) multiplicativeExpression
            	    {
            	    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

            	    // org/asdt/core/internal/antlr/as3.g3:703:30: ( PLUS^^ | MINUS^^ )
            	    int alt82=2;
            	    int LA82_0 = input.LA(1);
            	    if ( (LA82_0==PLUS) ) {
            	        alt82=1;
            	    }
            	    else if ( (LA82_0==MINUS) ) {
            	        alt82=2;
            	    }
            	    else {
            	        if (backtracking>0) {failed=true; return retval;}
            	        NoViableAltException nvae =
            	            new NoViableAltException("703:30: ( PLUS^^ | MINUS^^ )", 82, 0, input);

            	        throw nvae;
            	    }
            	    switch (alt82) {
            	        case 1 :
            	            // org/asdt/core/internal/antlr/as3.g3:703:31: PLUS^^
            	            {
            	            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

            	            PLUS311=(Token)input.LT(1);
            	            match(input,PLUS,FOLLOW_PLUS_in_additiveExpression3212); if (failed) return retval;
            	            if ( backtracking==0 ) {
            	            PLUS311_tree = (LinkedListTree)adaptor.create(PLUS311);
            	            root_0 = (LinkedListTree)adaptor.becomeRoot(PLUS311_tree, root_0);
            	            }

            	            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

            	            }
            	            break;
            	        case 2 :
            	            // org/asdt/core/internal/antlr/as3.g3:703:40: MINUS^^
            	            {
            	            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

            	            MINUS312=(Token)input.LT(1);
            	            match(input,MINUS,FOLLOW_MINUS_in_additiveExpression3217); if (failed) return retval;
            	            if ( backtracking==0 ) {
            	            MINUS312_tree = (LinkedListTree)adaptor.create(MINUS312);
            	            root_0 = (LinkedListTree)adaptor.becomeRoot(MINUS312_tree, root_0);
            	            }

            	            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

            	            }
            	            break;

            	    }

            	    pushFollow(FOLLOW_multiplicativeExpression_in_additiveExpression3221);
            	    multiplicativeExpression313=multiplicativeExpression();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_1, multiplicativeExpression313.tree);

            	    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

            	    }
            	    break;

            	default :
            	    break loop83;
                }
            } while (true);


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end additiveExpression

    public static class multiplicativeExpression_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start multiplicativeExpression
    // org/asdt/core/internal/antlr/as3.g3:707:1: multiplicativeExpression : unaryExpression ( ( STAR^^ | DIV^^ | MOD^^ ) unaryExpression )* ;
    public multiplicativeExpression_return multiplicativeExpression() throws RecognitionException {   
        multiplicativeExpression_return retval = new multiplicativeExpression_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token STAR315=null;
        Token DIV316=null;
        Token MOD317=null;
        unaryExpression_return unaryExpression314 = null;

        unaryExpression_return unaryExpression318 = null;


        LinkedListTree STAR315_tree=null;
        LinkedListTree DIV316_tree=null;
        LinkedListTree MOD317_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:708:4: ( unaryExpression ( ( STAR^^ | DIV^^ | MOD^^ ) unaryExpression )* )
            // org/asdt/core/internal/antlr/as3.g3:708:4: unaryExpression ( ( STAR^^ | DIV^^ | MOD^^ ) unaryExpression )*
            {
            root_0 = (LinkedListTree)adaptor.nil();

            pushFollow(FOLLOW_unaryExpression_in_multiplicativeExpression3235);
            unaryExpression314=unaryExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, unaryExpression314.tree);
            // org/asdt/core/internal/antlr/as3.g3:708:20: ( ( STAR^^ | DIV^^ | MOD^^ ) unaryExpression )*
            loop85:
            do {
                int alt85=2;
                int LA85_0 = input.LA(1);
                if ( (LA85_0==STAR||(LA85_0>=DIV && LA85_0<=MOD)) ) {
                    alt85=1;
                }


                switch (alt85) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:708:21: ( STAR^^ | DIV^^ | MOD^^ ) unaryExpression
            	    {
            	    LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

            	    // org/asdt/core/internal/antlr/as3.g3:708:21: ( STAR^^ | DIV^^ | MOD^^ )
            	    int alt84=3;
            	    switch ( input.LA(1) ) {
            	    case STAR:
            	        alt84=1;
            	        break;
            	    case DIV:
            	        alt84=2;
            	        break;
            	    case MOD:
            	        alt84=3;
            	        break;
            	    default:
            	        if (backtracking>0) {failed=true; return retval;}
            	        NoViableAltException nvae =
            	            new NoViableAltException("708:21: ( STAR^^ | DIV^^ | MOD^^ )", 84, 0, input);

            	        throw nvae;
            	    }

            	    switch (alt84) {
            	        case 1 :
            	            // org/asdt/core/internal/antlr/as3.g3:708:22: STAR^^
            	            {
            	            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

            	            STAR315=(Token)input.LT(1);
            	            match(input,STAR,FOLLOW_STAR_in_multiplicativeExpression3239); if (failed) return retval;
            	            if ( backtracking==0 ) {
            	            STAR315_tree = (LinkedListTree)adaptor.create(STAR315);
            	            root_0 = (LinkedListTree)adaptor.becomeRoot(STAR315_tree, root_0);
            	            }

            	            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

            	            }
            	            break;
            	        case 2 :
            	            // org/asdt/core/internal/antlr/as3.g3:708:31: DIV^^
            	            {
            	            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

            	            DIV316=(Token)input.LT(1);
            	            match(input,DIV,FOLLOW_DIV_in_multiplicativeExpression3244); if (failed) return retval;
            	            if ( backtracking==0 ) {
            	            DIV316_tree = (LinkedListTree)adaptor.create(DIV316);
            	            root_0 = (LinkedListTree)adaptor.becomeRoot(DIV316_tree, root_0);
            	            }

            	            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

            	            }
            	            break;
            	        case 3 :
            	            // org/asdt/core/internal/antlr/as3.g3:708:39: MOD^^
            	            {
            	            LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

            	            MOD317=(Token)input.LT(1);
            	            match(input,MOD,FOLLOW_MOD_in_multiplicativeExpression3249); if (failed) return retval;
            	            if ( backtracking==0 ) {
            	            MOD317_tree = (LinkedListTree)adaptor.create(MOD317);
            	            root_0 = (LinkedListTree)adaptor.becomeRoot(MOD317_tree, root_0);
            	            }

            	            if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

            	            }
            	            break;

            	    }

            	    pushFollow(FOLLOW_unaryExpression_in_multiplicativeExpression3253);
            	    unaryExpression318=unaryExpression();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_1, unaryExpression318.tree);

            	    if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

            	    }
            	    break;

            	default :
            	    break loop85;
                }
            } while (true);


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end multiplicativeExpression

    public static class unaryExpression_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start unaryExpression
    // org/asdt/core/internal/antlr/as3.g3:711:1: unaryExpression : ( INC^^ unaryExpression | DEC^^ unaryExpression | MINUS unaryExpression -> ^( UNARY_MINUS unaryExpression ) | PLUS unaryExpression -> ^( UNARY_PLUS unaryExpression ) | unaryExpressionNotPlusMinus );
    public unaryExpression_return unaryExpression() throws RecognitionException {   
        unaryExpression_return retval = new unaryExpression_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token INC319=null;
        Token DEC321=null;
        Token MINUS323=null;
        Token PLUS325=null;
        unaryExpression_return unaryExpression320 = null;

        unaryExpression_return unaryExpression322 = null;

        unaryExpression_return unaryExpression324 = null;

        unaryExpression_return unaryExpression326 = null;

        unaryExpressionNotPlusMinus_return unaryExpressionNotPlusMinus327 = null;

        List list_unaryExpression=new ArrayList();
        List list_MINUS=new ArrayList();
        List list_PLUS=new ArrayList();
        LinkedListTree INC319_tree=null;
        LinkedListTree DEC321_tree=null;
        LinkedListTree MINUS323_tree=null;
        LinkedListTree PLUS325_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:712:4: ( INC^^ unaryExpression | DEC^^ unaryExpression | MINUS unaryExpression -> ^( UNARY_MINUS unaryExpression ) | PLUS unaryExpression -> ^( UNARY_PLUS unaryExpression ) | unaryExpressionNotPlusMinus )
            int alt86=5;
            switch ( input.LA(1) ) {
            case INC:
                alt86=1;
                break;
            case DEC:
                alt86=2;
                break;
            case MINUS:
                alt86=3;
                break;
            case PLUS:
                alt86=4;
                break;
            case LCURLY:
            case IDENT:
            case FUNCTION:
            case LPAREN:
            case LBRACK:
            case LT:
            case LNOT:
            case BNOT:
            case STRING_LITERAL:
            case TRUE:
            case FALSE:
            case HEX_LITERAL:
            case DECIMAL_LITERAL:
            case OCTAL_LITERAL:
            case FLOAT_LITERAL:
            case 152:
            case 162:
            case 163:
            case 164:
            case 165:
            case 166:
                alt86=5;
                break;
            default:
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("711:1: unaryExpression : ( INC^^ unaryExpression | DEC^^ unaryExpression | MINUS unaryExpression -> ^( UNARY_MINUS unaryExpression ) | PLUS unaryExpression -> ^( UNARY_PLUS unaryExpression ) | unaryExpressionNotPlusMinus );", 86, 0, input);

                throw nvae;
            }

            switch (alt86) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:712:4: INC^^ unaryExpression
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    INC319=(Token)input.LT(1);
                    match(input,INC,FOLLOW_INC_in_unaryExpression3266); if (failed) return retval;
                    if ( backtracking==0 ) {
                    INC319_tree = (LinkedListTree)adaptor.create(INC319);
                    root_0 = (LinkedListTree)adaptor.becomeRoot(INC319_tree, root_0);
                    }
                    pushFollow(FOLLOW_unaryExpression_in_unaryExpression3269);
                    unaryExpression320=unaryExpression();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, unaryExpression320.tree);

                    }
                    break;
                case 2 :
                    // org/asdt/core/internal/antlr/as3.g3:713:4: DEC^^ unaryExpression
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    DEC321=(Token)input.LT(1);
                    match(input,DEC,FOLLOW_DEC_in_unaryExpression3274); if (failed) return retval;
                    if ( backtracking==0 ) {
                    DEC321_tree = (LinkedListTree)adaptor.create(DEC321);
                    root_0 = (LinkedListTree)adaptor.becomeRoot(DEC321_tree, root_0);
                    }
                    pushFollow(FOLLOW_unaryExpression_in_unaryExpression3277);
                    unaryExpression322=unaryExpression();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, unaryExpression322.tree);

                    }
                    break;
                case 3 :
                    // org/asdt/core/internal/antlr/as3.g3:714:4: MINUS unaryExpression
                    {
                    MINUS323=(Token)input.LT(1);
                    match(input,MINUS,FOLLOW_MINUS_in_unaryExpression3282); if (failed) return retval;
                    if ( backtracking==0 ) list_MINUS.add(MINUS323);

                    pushFollow(FOLLOW_unaryExpression_in_unaryExpression3284);
                    unaryExpression324=unaryExpression();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) list_unaryExpression.add(unaryExpression324.tree);

                    // AST REWRITE
                    if ( backtracking==0 ) {
                    int i_0 = 0;
                    retval.tree = root_0;
                    root_0 = (LinkedListTree)adaptor.nil();
                    // 714:26: -> ^( UNARY_MINUS unaryExpression )
                    {
                        // org/asdt/core/internal/antlr/as3.g3:714:29: ^( UNARY_MINUS unaryExpression )
                        {
                        LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                        root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(UNARY_MINUS, "UNARY_MINUS"), root_1);

                        adaptor.addChild(root_1, list_unaryExpression.get(i_0));

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    }

                    }
                    break;
                case 4 :
                    // org/asdt/core/internal/antlr/as3.g3:715:4: PLUS unaryExpression
                    {
                    PLUS325=(Token)input.LT(1);
                    match(input,PLUS,FOLLOW_PLUS_in_unaryExpression3297); if (failed) return retval;
                    if ( backtracking==0 ) list_PLUS.add(PLUS325);

                    pushFollow(FOLLOW_unaryExpression_in_unaryExpression3299);
                    unaryExpression326=unaryExpression();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) list_unaryExpression.add(unaryExpression326.tree);

                    // AST REWRITE
                    if ( backtracking==0 ) {
                    int i_0 = 0;
                    retval.tree = root_0;
                    root_0 = (LinkedListTree)adaptor.nil();
                    // 715:25: -> ^( UNARY_PLUS unaryExpression )
                    {
                        // org/asdt/core/internal/antlr/as3.g3:715:28: ^( UNARY_PLUS unaryExpression )
                        {
                        LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                        root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(UNARY_PLUS, "UNARY_PLUS"), root_1);

                        adaptor.addChild(root_1, list_unaryExpression.get(i_0));

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    }

                    }
                    break;
                case 5 :
                    // org/asdt/core/internal/antlr/as3.g3:716:4: unaryExpressionNotPlusMinus
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_unaryExpressionNotPlusMinus_in_unaryExpression3312);
                    unaryExpressionNotPlusMinus327=unaryExpressionNotPlusMinus();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, unaryExpressionNotPlusMinus327.tree);

                    }
                    break;

            }
        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end unaryExpression

    public static class unaryExpressionNotPlusMinus_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start unaryExpressionNotPlusMinus
    // org/asdt/core/internal/antlr/as3.g3:719:1: unaryExpressionNotPlusMinus : ( 'delete'^^ postfixExpression | 'void'^^ unaryExpression | 'typeof'^^ unaryExpression | LNOT^^ unaryExpression | BNOT^^ unaryExpression | postfixExpression );
    public unaryExpressionNotPlusMinus_return unaryExpressionNotPlusMinus() throws RecognitionException {   
        unaryExpressionNotPlusMinus_return retval = new unaryExpressionNotPlusMinus_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token string_literal328=null;
        Token string_literal330=null;
        Token string_literal332=null;
        Token LNOT334=null;
        Token BNOT336=null;
        postfixExpression_return postfixExpression329 = null;

        unaryExpression_return unaryExpression331 = null;

        unaryExpression_return unaryExpression333 = null;

        unaryExpression_return unaryExpression335 = null;

        unaryExpression_return unaryExpression337 = null;

        postfixExpression_return postfixExpression338 = null;


        LinkedListTree string_literal328_tree=null;
        LinkedListTree string_literal330_tree=null;
        LinkedListTree string_literal332_tree=null;
        LinkedListTree LNOT334_tree=null;
        LinkedListTree BNOT336_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:720:4: ( 'delete'^^ postfixExpression | 'void'^^ unaryExpression | 'typeof'^^ unaryExpression | LNOT^^ unaryExpression | BNOT^^ unaryExpression | postfixExpression )
            int alt87=6;
            switch ( input.LA(1) ) {
            case 162:
                alt87=1;
                break;
            case 152:
                alt87=2;
                break;
            case 163:
                alt87=3;
                break;
            case LNOT:
                alt87=4;
                break;
            case BNOT:
                alt87=5;
                break;
            case LCURLY:
            case IDENT:
            case FUNCTION:
            case LPAREN:
            case LBRACK:
            case LT:
            case STRING_LITERAL:
            case TRUE:
            case FALSE:
            case HEX_LITERAL:
            case DECIMAL_LITERAL:
            case OCTAL_LITERAL:
            case FLOAT_LITERAL:
            case 164:
            case 165:
            case 166:
                alt87=6;
                break;
            default:
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("719:1: unaryExpressionNotPlusMinus : ( 'delete'^^ postfixExpression | 'void'^^ unaryExpression | 'typeof'^^ unaryExpression | LNOT^^ unaryExpression | BNOT^^ unaryExpression | postfixExpression );", 87, 0, input);

                throw nvae;
            }

            switch (alt87) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:720:4: 'delete'^^ postfixExpression
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    string_literal328=(Token)input.LT(1);
                    match(input,162,FOLLOW_162_in_unaryExpressionNotPlusMinus3323); if (failed) return retval;
                    if ( backtracking==0 ) {
                    string_literal328_tree = (LinkedListTree)adaptor.create(string_literal328);
                    root_0 = (LinkedListTree)adaptor.becomeRoot(string_literal328_tree, root_0);
                    }
                    pushFollow(FOLLOW_postfixExpression_in_unaryExpressionNotPlusMinus3326);
                    postfixExpression329=postfixExpression();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, postfixExpression329.tree);

                    }
                    break;
                case 2 :
                    // org/asdt/core/internal/antlr/as3.g3:721:4: 'void'^^ unaryExpression
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    string_literal330=(Token)input.LT(1);
                    match(input,152,FOLLOW_152_in_unaryExpressionNotPlusMinus3331); if (failed) return retval;
                    if ( backtracking==0 ) {
                    string_literal330_tree = (LinkedListTree)adaptor.create(string_literal330);
                    root_0 = (LinkedListTree)adaptor.becomeRoot(string_literal330_tree, root_0);
                    }
                    pushFollow(FOLLOW_unaryExpression_in_unaryExpressionNotPlusMinus3334);
                    unaryExpression331=unaryExpression();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, unaryExpression331.tree);

                    }
                    break;
                case 3 :
                    // org/asdt/core/internal/antlr/as3.g3:722:4: 'typeof'^^ unaryExpression
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    string_literal332=(Token)input.LT(1);
                    match(input,163,FOLLOW_163_in_unaryExpressionNotPlusMinus3339); if (failed) return retval;
                    if ( backtracking==0 ) {
                    string_literal332_tree = (LinkedListTree)adaptor.create(string_literal332);
                    root_0 = (LinkedListTree)adaptor.becomeRoot(string_literal332_tree, root_0);
                    }
                    pushFollow(FOLLOW_unaryExpression_in_unaryExpressionNotPlusMinus3342);
                    unaryExpression333=unaryExpression();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, unaryExpression333.tree);

                    }
                    break;
                case 4 :
                    // org/asdt/core/internal/antlr/as3.g3:723:4: LNOT^^ unaryExpression
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    LNOT334=(Token)input.LT(1);
                    match(input,LNOT,FOLLOW_LNOT_in_unaryExpressionNotPlusMinus3347); if (failed) return retval;
                    if ( backtracking==0 ) {
                    LNOT334_tree = (LinkedListTree)adaptor.create(LNOT334);
                    root_0 = (LinkedListTree)adaptor.becomeRoot(LNOT334_tree, root_0);
                    }
                    pushFollow(FOLLOW_unaryExpression_in_unaryExpressionNotPlusMinus3350);
                    unaryExpression335=unaryExpression();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, unaryExpression335.tree);

                    }
                    break;
                case 5 :
                    // org/asdt/core/internal/antlr/as3.g3:724:4: BNOT^^ unaryExpression
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    BNOT336=(Token)input.LT(1);
                    match(input,BNOT,FOLLOW_BNOT_in_unaryExpressionNotPlusMinus3355); if (failed) return retval;
                    if ( backtracking==0 ) {
                    BNOT336_tree = (LinkedListTree)adaptor.create(BNOT336);
                    root_0 = (LinkedListTree)adaptor.becomeRoot(BNOT336_tree, root_0);
                    }
                    pushFollow(FOLLOW_unaryExpression_in_unaryExpressionNotPlusMinus3358);
                    unaryExpression337=unaryExpression();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, unaryExpression337.tree);

                    }
                    break;
                case 6 :
                    // org/asdt/core/internal/antlr/as3.g3:725:4: postfixExpression
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_postfixExpression_in_unaryExpressionNotPlusMinus3363);
                    postfixExpression338=postfixExpression();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, postfixExpression338.tree);

                    }
                    break;

            }
        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end unaryExpressionNotPlusMinus

    public static class postfixExpression_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start postfixExpression
    // org/asdt/core/internal/antlr/as3.g3:729:1: postfixExpression : ( primaryExpression -> primaryExpression ) ( options {greedy=true; } : ( DOT ( identPart | e4xExpression ) | ( LBRACK expression RBRACK -> ^( ARRAY_ACC $postfixExpression expression ) ) | E4X_DESC e4xExpression ) methodCall )* ( options {greedy=true; } : in= INC -> ^( POST_INC[$in] $postfixExpression) | de= DEC -> ^( POST_DEC[$de] $postfixExpression) )? ;
    public postfixExpression_return postfixExpression() throws RecognitionException {   
        postfixExpression_return retval = new postfixExpression_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token in=null;
        Token de=null;
        Token DOT340=null;
        Token LBRACK343=null;
        Token RBRACK345=null;
        Token E4X_DESC346=null;
        primaryExpression_return primaryExpression339 = null;

        identPart_return identPart341 = null;

        e4xExpression_return e4xExpression342 = null;

        expression_return expression344 = null;

        e4xExpression_return e4xExpression347 = null;

        methodCall_return methodCall348 = null;

        List list_identPart=new ArrayList();
        List list_methodCall=new ArrayList();
        List list_primaryExpression=new ArrayList();
        List list_e4xExpression=new ArrayList();
        List list_expression=new ArrayList();
        List list_RBRACK=new ArrayList();
        List list_DEC=new ArrayList();
        List list_INC=new ArrayList();
        List list_E4X_DESC=new ArrayList();
        List list_DOT=new ArrayList();
        List list_LBRACK=new ArrayList();
        LinkedListTree in_tree=null;
        LinkedListTree de_tree=null;
        LinkedListTree DOT340_tree=null;
        LinkedListTree LBRACK343_tree=null;
        LinkedListTree RBRACK345_tree=null;
        LinkedListTree E4X_DESC346_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:730:4: ( ( primaryExpression -> primaryExpression ) ( options {greedy=true; } : ( DOT ( identPart | e4xExpression ) | ( LBRACK expression RBRACK -> ^( ARRAY_ACC $postfixExpression expression ) ) | E4X_DESC e4xExpression ) methodCall )* ( options {greedy=true; } : in= INC -> ^( POST_INC[$in] $postfixExpression) | de= DEC -> ^( POST_DEC[$de] $postfixExpression) )? )
            // org/asdt/core/internal/antlr/as3.g3:730:4: ( primaryExpression -> primaryExpression ) ( options {greedy=true; } : ( DOT ( identPart | e4xExpression ) | ( LBRACK expression RBRACK -> ^( ARRAY_ACC $postfixExpression expression ) ) | E4X_DESC e4xExpression ) methodCall )* ( options {greedy=true; } : in= INC -> ^( POST_INC[$in] $postfixExpression) | de= DEC -> ^( POST_DEC[$de] $postfixExpression) )?
            {
            // org/asdt/core/internal/antlr/as3.g3:730:4: ( primaryExpression -> primaryExpression )
            // org/asdt/core/internal/antlr/as3.g3:730:5: primaryExpression
            {
            pushFollow(FOLLOW_primaryExpression_in_postfixExpression3376);
            primaryExpression339=primaryExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_primaryExpression.add(primaryExpression339.tree);

            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 730:23: -> primaryExpression
            {
                adaptor.addChild(root_0, list_primaryExpression.get(i_0));

            }

            }

            }

            // org/asdt/core/internal/antlr/as3.g3:731:3: ( options {greedy=true; } : ( DOT ( identPart | e4xExpression ) | ( LBRACK expression RBRACK -> ^( ARRAY_ACC $postfixExpression expression ) ) | E4X_DESC e4xExpression ) methodCall )*
            loop90:
            do {
                int alt90=2;
                switch ( input.LA(1) ) {
                case LBRACK:
                    alt90=1;
                    break;
                case DOT:
                    alt90=1;
                    break;
                case E4X_DESC:
                    alt90=1;
                    break;

                }

                switch (alt90) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:732:4: ( DOT ( identPart | e4xExpression ) | ( LBRACK expression RBRACK -> ^( ARRAY_ACC $postfixExpression expression ) ) | E4X_DESC e4xExpression ) methodCall
            	    {
            	    // org/asdt/core/internal/antlr/as3.g3:732:4: ( DOT ( identPart | e4xExpression ) | ( LBRACK expression RBRACK -> ^( ARRAY_ACC $postfixExpression expression ) ) | E4X_DESC e4xExpression )
            	    int alt89=3;
            	    switch ( input.LA(1) ) {
            	    case DOT:
            	        alt89=1;
            	        break;
            	    case LBRACK:
            	        alt89=2;
            	        break;
            	    case E4X_DESC:
            	        alt89=3;
            	        break;
            	    default:
            	        if (backtracking>0) {failed=true; return retval;}
            	        NoViableAltException nvae =
            	            new NoViableAltException("732:4: ( DOT ( identPart | e4xExpression ) | ( LBRACK expression RBRACK -> ^( ARRAY_ACC $postfixExpression expression ) ) | E4X_DESC e4xExpression )", 89, 0, input);

            	        throw nvae;
            	    }

            	    switch (alt89) {
            	        case 1 :
            	            // org/asdt/core/internal/antlr/as3.g3:732:6: DOT ( identPart | e4xExpression )
            	            {
            	            DOT340=(Token)input.LT(1);
            	            match(input,DOT,FOLLOW_DOT_in_postfixExpression3401); if (failed) return retval;
            	            if ( backtracking==0 ) list_DOT.add(DOT340);

            	            // org/asdt/core/internal/antlr/as3.g3:733:5: ( identPart | e4xExpression )
            	            int alt88=2;
            	            int LA88_0 = input.LA(1);
            	            if ( (LA88_0==IDENT) ) {
            	                alt88=1;
            	            }
            	            else if ( (LA88_0==STAR||LA88_0==E4X_ATTRI) ) {
            	                alt88=2;
            	            }
            	            else {
            	                if (backtracking>0) {failed=true; return retval;}
            	                NoViableAltException nvae =
            	                    new NoViableAltException("733:5: ( identPart | e4xExpression )", 88, 0, input);

            	                throw nvae;
            	            }
            	            switch (alt88) {
            	                case 1 :
            	                    // org/asdt/core/internal/antlr/as3.g3:734:6: identPart
            	                    {
            	                    pushFollow(FOLLOW_identPart_in_postfixExpression3414);
            	                    identPart341=identPart();
            	                    _fsp--;
            	                    if (failed) return retval;
            	                    if ( backtracking==0 ) list_identPart.add(identPart341.tree);

            	                    }
            	                    break;
            	                case 2 :
            	                    // org/asdt/core/internal/antlr/as3.g3:735:7: e4xExpression
            	                    {
            	                    pushFollow(FOLLOW_e4xExpression_in_postfixExpression3422);
            	                    e4xExpression342=e4xExpression();
            	                    _fsp--;
            	                    if (failed) return retval;
            	                    if ( backtracking==0 ) list_e4xExpression.add(e4xExpression342.tree);

            	                    }
            	                    break;

            	            }


            	            }
            	            break;
            	        case 2 :
            	            // org/asdt/core/internal/antlr/as3.g3:737:6: ( LBRACK expression RBRACK -> ^( ARRAY_ACC $postfixExpression expression ) )
            	            {
            	            // org/asdt/core/internal/antlr/as3.g3:737:6: ( LBRACK expression RBRACK -> ^( ARRAY_ACC $postfixExpression expression ) )
            	            // org/asdt/core/internal/antlr/as3.g3:737:8: LBRACK expression RBRACK
            	            {
            	            LBRACK343=(Token)input.LT(1);
            	            match(input,LBRACK,FOLLOW_LBRACK_in_postfixExpression3437); if (failed) return retval;
            	            if ( backtracking==0 ) list_LBRACK.add(LBRACK343);

            	            pushFollow(FOLLOW_expression_in_postfixExpression3439);
            	            expression344=expression();
            	            _fsp--;
            	            if (failed) return retval;
            	            if ( backtracking==0 ) list_expression.add(expression344.tree);
            	            RBRACK345=(Token)input.LT(1);
            	            match(input,RBRACK,FOLLOW_RBRACK_in_postfixExpression3441); if (failed) return retval;
            	            if ( backtracking==0 ) list_RBRACK.add(RBRACK345);


            	            // AST REWRITE
            	            if ( backtracking==0 ) {
            	            int i_0 = 0;
            	            retval.tree = root_0;
            	            root_0 = (LinkedListTree)adaptor.nil();
            	            // 738:6: -> ^( ARRAY_ACC $postfixExpression expression )
            	            {
            	                // org/asdt/core/internal/antlr/as3.g3:738:9: ^( ARRAY_ACC $postfixExpression expression )
            	                {
            	                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
            	                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(ARRAY_ACC, "ARRAY_ACC"), root_1);

            	                adaptor.addChild(root_1, retval.tree);
            	                adaptor.addChild(root_1, list_expression.get(i_0));

            	                adaptor.addChild(root_0, root_1);
            	                }

            	            }

            	            }

            	            }


            	            }
            	            break;
            	        case 3 :
            	            // org/asdt/core/internal/antlr/as3.g3:740:6: E4X_DESC e4xExpression
            	            {
            	            E4X_DESC346=(Token)input.LT(1);
            	            match(input,E4X_DESC,FOLLOW_E4X_DESC_in_postfixExpression3471); if (failed) return retval;
            	            if ( backtracking==0 ) list_E4X_DESC.add(E4X_DESC346);

            	            pushFollow(FOLLOW_e4xExpression_in_postfixExpression3473);
            	            e4xExpression347=e4xExpression();
            	            _fsp--;
            	            if (failed) return retval;
            	            if ( backtracking==0 ) list_e4xExpression.add(e4xExpression347.tree);

            	            }
            	            break;

            	    }

            	    pushFollow(FOLLOW_methodCall_in_postfixExpression3483);
            	    methodCall348=methodCall();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) list_methodCall.add(methodCall348.tree);

            	    }
            	    break;

            	default :
            	    break loop90;
                }
            } while (true);

            // org/asdt/core/internal/antlr/as3.g3:744:3: ( options {greedy=true; } : in= INC -> ^( POST_INC[$in] $postfixExpression) | de= DEC -> ^( POST_DEC[$de] $postfixExpression) )?
            int alt91=3;
            int LA91_0 = input.LA(1);
            if ( (LA91_0==INC) ) {
                alt91=1;
            }
            else if ( (LA91_0==DEC) ) {
                alt91=2;
            }
            switch (alt91) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:745:6: in= INC
                    {
                    in=(Token)input.LT(1);
                    match(input,INC,FOLLOW_INC_in_postfixExpression3508); if (failed) return retval;
                    if ( backtracking==0 ) list_INC.add(in);


                    // AST REWRITE
                    if ( backtracking==0 ) {
                    int i_0 = 0;
                    retval.tree = root_0;
                    root_0 = (LinkedListTree)adaptor.nil();
                    // 745:13: -> ^( POST_INC[$in] $postfixExpression)
                    {
                        // org/asdt/core/internal/antlr/as3.g3:745:16: ^( POST_INC[$in] $postfixExpression)
                        {
                        LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                        root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(POST_INC, in), root_1);

                        adaptor.addChild(root_1, retval.tree);

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    }

                    }
                    break;
                case 2 :
                    // org/asdt/core/internal/antlr/as3.g3:746:6: de= DEC
                    {
                    de=(Token)input.LT(1);
                    match(input,DEC,FOLLOW_DEC_in_postfixExpression3527); if (failed) return retval;
                    if ( backtracking==0 ) list_DEC.add(de);


                    // AST REWRITE
                    if ( backtracking==0 ) {
                    int i_0 = 0;
                    retval.tree = root_0;
                    root_0 = (LinkedListTree)adaptor.nil();
                    // 746:13: -> ^( POST_DEC[$de] $postfixExpression)
                    {
                        // org/asdt/core/internal/antlr/as3.g3:746:16: ^( POST_DEC[$de] $postfixExpression)
                        {
                        LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                        root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(POST_DEC, de), root_1);

                        adaptor.addChild(root_1, retval.tree);

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    }

                    }
                    break;

            }


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end postfixExpression

    public static class methodCall_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start methodCall
    // org/asdt/core/internal/antlr/as3.g3:750:1: methodCall : ( options {greedy=true; } : arguments -> ^( METHOD_CALL arguments ) )* ;
    public methodCall_return methodCall() throws RecognitionException {   
        methodCall_return retval = new methodCall_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        arguments_return arguments349 = null;

        List list_arguments=new ArrayList();

        try {
            // org/asdt/core/internal/antlr/as3.g3:751:4: ( ( options {greedy=true; } : arguments -> ^( METHOD_CALL arguments ) )* )
            // org/asdt/core/internal/antlr/as3.g3:751:4: ( options {greedy=true; } : arguments -> ^( METHOD_CALL arguments ) )*
            {
            // org/asdt/core/internal/antlr/as3.g3:751:4: ( options {greedy=true; } : arguments -> ^( METHOD_CALL arguments ) )*
            loop92:
            do {
                int alt92=2;
                int LA92_0 = input.LA(1);
                if ( (LA92_0==LPAREN) ) {
                    switch ( input.LA(2) ) {
                    case INC:
                        alt92=1;
                        break;
                    case DEC:
                        alt92=1;
                        break;
                    case MINUS:
                        alt92=1;
                        break;
                    case PLUS:
                        alt92=1;
                        break;
                    case 162:
                        alt92=1;
                        break;
                    case 152:
                        alt92=1;
                        break;
                    case 163:
                        alt92=1;
                        break;
                    case LNOT:
                        alt92=1;
                        break;
                    case BNOT:
                        alt92=1;
                        break;
                    case IDENT:
                        alt92=1;
                        break;
                    case 164:
                        alt92=1;
                        break;
                    case 165:
                        alt92=1;
                        break;
                    case LT:
                        alt92=1;
                        break;
                    case HEX_LITERAL:
                    case DECIMAL_LITERAL:
                    case OCTAL_LITERAL:
                    case FLOAT_LITERAL:
                        alt92=1;
                        break;
                    case STRING_LITERAL:
                        alt92=1;
                        break;
                    case TRUE:
                        alt92=1;
                        break;
                    case FALSE:
                        alt92=1;
                        break;
                    case LBRACK:
                        alt92=1;
                        break;
                    case LCURLY:
                        alt92=1;
                        break;
                    case FUNCTION:
                        alt92=1;
                        break;
                    case 166:
                        alt92=1;
                        break;
                    case LPAREN:
                        alt92=1;
                        break;
                    case RPAREN:
                        alt92=1;
                        break;

                    }

                }


                switch (alt92) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:752:5: arguments
            	    {
            	    pushFollow(FOLLOW_arguments_in_methodCall3567);
            	    arguments349=arguments();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) list_arguments.add(arguments349.tree);

            	    // AST REWRITE
            	    if ( backtracking==0 ) {
            	    int i_0 = 0;
            	    retval.tree = root_0;
            	    root_0 = (LinkedListTree)adaptor.nil();
            	    // 753:4: -> ^( METHOD_CALL arguments )
            	    {
            	        // org/asdt/core/internal/antlr/as3.g3:753:7: ^( METHOD_CALL arguments )
            	        {
            	        LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
            	        root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(METHOD_CALL, "METHOD_CALL"), root_1);

            	        adaptor.addChild(root_1, list_arguments.get(i_0));

            	        adaptor.addChild(root_0, root_1);
            	        }

            	    }

            	    }

            	    }
            	    break;

            	default :
            	    break loop92;
                }
            } while (true);


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end methodCall

    public static class e4xExpression_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start e4xExpression
    // org/asdt/core/internal/antlr/as3.g3:756:1: e4xExpression : ( IDENT | STAR^ | E4X_ATTRI^ ( IDENT | ( STAR )? LBRACK^ expression RBRACK! ) );
    public e4xExpression_return e4xExpression() throws RecognitionException {   
        e4xExpression_return retval = new e4xExpression_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token IDENT350=null;
        Token STAR351=null;
        Token E4X_ATTRI352=null;
        Token IDENT353=null;
        Token STAR354=null;
        Token LBRACK355=null;
        Token RBRACK357=null;
        expression_return expression356 = null;


        LinkedListTree IDENT350_tree=null;
        LinkedListTree STAR351_tree=null;
        LinkedListTree E4X_ATTRI352_tree=null;
        LinkedListTree IDENT353_tree=null;
        LinkedListTree STAR354_tree=null;
        LinkedListTree LBRACK355_tree=null;
        LinkedListTree RBRACK357_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:757:4: ( IDENT | STAR^ | E4X_ATTRI^ ( IDENT | ( STAR )? LBRACK^ expression RBRACK! ) )
            int alt95=3;
            switch ( input.LA(1) ) {
            case IDENT:
                alt95=1;
                break;
            case STAR:
                alt95=2;
                break;
            case E4X_ATTRI:
                alt95=3;
                break;
            default:
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("756:1: e4xExpression : ( IDENT | STAR^ | E4X_ATTRI^ ( IDENT | ( STAR )? LBRACK^ expression RBRACK! ) );", 95, 0, input);

                throw nvae;
            }

            switch (alt95) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:757:4: IDENT
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    IDENT350=(Token)input.LT(1);
                    match(input,IDENT,FOLLOW_IDENT_in_e4xExpression3593); if (failed) return retval;
                    if ( backtracking==0 ) {
                    IDENT350_tree = (LinkedListTree)adaptor.create(IDENT350);
                    adaptor.addChild(root_0, IDENT350_tree);
                    }

                    }
                    break;
                case 2 :
                    // org/asdt/core/internal/antlr/as3.g3:758:4: STAR^
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    STAR351=(Token)input.LT(1);
                    match(input,STAR,FOLLOW_STAR_in_e4xExpression3598); if (failed) return retval;
                    if ( backtracking==0 ) {
                    STAR351_tree = (LinkedListTree)adaptor.create(STAR351);
                    root_0 = (LinkedListTree)adaptor.becomeRoot(STAR351_tree, root_0);
                    }

                    }
                    break;
                case 3 :
                    // org/asdt/core/internal/antlr/as3.g3:759:4: E4X_ATTRI^ ( IDENT | ( STAR )? LBRACK^ expression RBRACK! )
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    E4X_ATTRI352=(Token)input.LT(1);
                    match(input,E4X_ATTRI,FOLLOW_E4X_ATTRI_in_e4xExpression3604); if (failed) return retval;
                    if ( backtracking==0 ) {
                    E4X_ATTRI352_tree = (LinkedListTree)adaptor.create(E4X_ATTRI352);
                    root_0 = (LinkedListTree)adaptor.becomeRoot(E4X_ATTRI352_tree, root_0);
                    }
                    // org/asdt/core/internal/antlr/as3.g3:760:3: ( IDENT | ( STAR )? LBRACK^ expression RBRACK! )
                    int alt94=2;
                    int LA94_0 = input.LA(1);
                    if ( (LA94_0==IDENT) ) {
                        alt94=1;
                    }
                    else if ( (LA94_0==STAR||LA94_0==LBRACK) ) {
                        alt94=2;
                    }
                    else {
                        if (backtracking>0) {failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("760:3: ( IDENT | ( STAR )? LBRACK^ expression RBRACK! )", 94, 0, input);

                        throw nvae;
                    }
                    switch (alt94) {
                        case 1 :
                            // org/asdt/core/internal/antlr/as3.g3:760:5: IDENT
                            {
                            LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                            IDENT353=(Token)input.LT(1);
                            match(input,IDENT,FOLLOW_IDENT_in_e4xExpression3612); if (failed) return retval;
                            if ( backtracking==0 ) {
                            IDENT353_tree = (LinkedListTree)adaptor.create(IDENT353);
                            adaptor.addChild(root_1, IDENT353_tree);
                            }

                            if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                            }
                            break;
                        case 2 :
                            // org/asdt/core/internal/antlr/as3.g3:761:5: ( STAR )? LBRACK^ expression RBRACK!
                            {
                            LinkedListTree root_1 = (LinkedListTree)adaptor.nil();

                            // org/asdt/core/internal/antlr/as3.g3:761:5: ( STAR )?
                            int alt93=2;
                            int LA93_0 = input.LA(1);
                            if ( (LA93_0==STAR) ) {
                                alt93=1;
                            }
                            switch (alt93) {
                                case 1 :
                                    // org/asdt/core/internal/antlr/as3.g3:761:5: STAR
                                    {
                                    LinkedListTree root_2 = (LinkedListTree)adaptor.nil();

                                    STAR354=(Token)input.LT(1);
                                    match(input,STAR,FOLLOW_STAR_in_e4xExpression3618); if (failed) return retval;
                                    if ( backtracking==0 ) {
                                    STAR354_tree = (LinkedListTree)adaptor.create(STAR354);
                                    adaptor.addChild(root_2, STAR354_tree);
                                    }

                                    if ( backtracking==0 ) adaptor.addChild(root_1, root_2);

                                    }
                                    break;

                            }

                            LBRACK355=(Token)input.LT(1);
                            match(input,LBRACK,FOLLOW_LBRACK_in_e4xExpression3621); if (failed) return retval;
                            if ( backtracking==0 ) {
                            LBRACK355_tree = (LinkedListTree)adaptor.create(LBRACK355);
                            root_1 = (LinkedListTree)adaptor.becomeRoot(LBRACK355_tree, root_1);
                            }
                            pushFollow(FOLLOW_expression_in_e4xExpression3624);
                            expression356=expression();
                            _fsp--;
                            if (failed) return retval;
                            if ( backtracking==0 ) adaptor.addChild(root_1, expression356.tree);
                            RBRACK357=(Token)input.LT(1);
                            match(input,RBRACK,FOLLOW_RBRACK_in_e4xExpression3626); if (failed) return retval;

                            if ( backtracking==0 ) adaptor.addChild(root_0, root_1);

                            }
                            break;

                    }


                    }
                    break;

            }
        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end e4xExpression

    public static class primaryExpression_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start primaryExpression
    // org/asdt/core/internal/antlr/as3.g3:764:1: primaryExpression : ( identPrimary | 'null' | 'undefined' | constant | arrayLiteral | objectLiteral | functionDefinition | newExpression | encapsulatedExpression );
    public primaryExpression_return primaryExpression() throws RecognitionException {   
        primaryExpression_return retval = new primaryExpression_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token string_literal359=null;
        Token string_literal360=null;
        identPrimary_return identPrimary358 = null;

        constant_return constant361 = null;

        arrayLiteral_return arrayLiteral362 = null;

        objectLiteral_return objectLiteral363 = null;

        functionDefinition_return functionDefinition364 = null;

        newExpression_return newExpression365 = null;

        encapsulatedExpression_return encapsulatedExpression366 = null;


        LinkedListTree string_literal359_tree=null;
        LinkedListTree string_literal360_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:765:4: ( identPrimary | 'null' | 'undefined' | constant | arrayLiteral | objectLiteral | functionDefinition | newExpression | encapsulatedExpression )
            int alt96=9;
            switch ( input.LA(1) ) {
            case IDENT:
                alt96=1;
                break;
            case 164:
                alt96=2;
                break;
            case 165:
                alt96=3;
                break;
            case LT:
            case STRING_LITERAL:
            case TRUE:
            case FALSE:
            case HEX_LITERAL:
            case DECIMAL_LITERAL:
            case OCTAL_LITERAL:
            case FLOAT_LITERAL:
                alt96=4;
                break;
            case LBRACK:
                alt96=5;
                break;
            case LCURLY:
                alt96=6;
                break;
            case FUNCTION:
                alt96=7;
                break;
            case 166:
                alt96=8;
                break;
            case LPAREN:
                alt96=9;
                break;
            default:
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("764:1: primaryExpression : ( identPrimary | 'null' | 'undefined' | constant | arrayLiteral | objectLiteral | functionDefinition | newExpression | encapsulatedExpression );", 96, 0, input);

                throw nvae;
            }

            switch (alt96) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:765:4: identPrimary
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_identPrimary_in_primaryExpression3642);
                    identPrimary358=identPrimary();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, identPrimary358.tree);

                    }
                    break;
                case 2 :
                    // org/asdt/core/internal/antlr/as3.g3:766:4: 'null'
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    string_literal359=(Token)input.LT(1);
                    match(input,164,FOLLOW_164_in_primaryExpression3647); if (failed) return retval;
                    if ( backtracking==0 ) {
                    string_literal359_tree = (LinkedListTree)adaptor.create(string_literal359);
                    adaptor.addChild(root_0, string_literal359_tree);
                    }

                    }
                    break;
                case 3 :
                    // org/asdt/core/internal/antlr/as3.g3:767:4: 'undefined'
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    string_literal360=(Token)input.LT(1);
                    match(input,165,FOLLOW_165_in_primaryExpression3652); if (failed) return retval;
                    if ( backtracking==0 ) {
                    string_literal360_tree = (LinkedListTree)adaptor.create(string_literal360);
                    adaptor.addChild(root_0, string_literal360_tree);
                    }

                    }
                    break;
                case 4 :
                    // org/asdt/core/internal/antlr/as3.g3:768:4: constant
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_constant_in_primaryExpression3657);
                    constant361=constant();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, constant361.tree);

                    }
                    break;
                case 5 :
                    // org/asdt/core/internal/antlr/as3.g3:769:4: arrayLiteral
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_arrayLiteral_in_primaryExpression3662);
                    arrayLiteral362=arrayLiteral();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, arrayLiteral362.tree);

                    }
                    break;
                case 6 :
                    // org/asdt/core/internal/antlr/as3.g3:770:4: objectLiteral
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_objectLiteral_in_primaryExpression3667);
                    objectLiteral363=objectLiteral();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, objectLiteral363.tree);

                    }
                    break;
                case 7 :
                    // org/asdt/core/internal/antlr/as3.g3:771:4: functionDefinition
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_functionDefinition_in_primaryExpression3672);
                    functionDefinition364=functionDefinition();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, functionDefinition364.tree);

                    }
                    break;
                case 8 :
                    // org/asdt/core/internal/antlr/as3.g3:772:4: newExpression
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_newExpression_in_primaryExpression3677);
                    newExpression365=newExpression();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, newExpression365.tree);

                    }
                    break;
                case 9 :
                    // org/asdt/core/internal/antlr/as3.g3:773:4: encapsulatedExpression
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_encapsulatedExpression_in_primaryExpression3682);
                    encapsulatedExpression366=encapsulatedExpression();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, encapsulatedExpression366.tree);

                    }
                    break;

            }
        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end primaryExpression

    public static class identPrimary_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start identPrimary
    // org/asdt/core/internal/antlr/as3.g3:777:1: identPrimary : ( identPart -> identPart ) ( options {greedy=true; } : (poi= propOrIdent[root_0, retval.start] -> $poi) | ( LBRACK expr= expression RBRACK -> ^( ARRAY_ACC $identPrimary $expr) ) )* ( options {greedy=true; } : a= arguments -> ^( METHOD_CALL $identPrimary $a) )* ;
    public identPrimary_return identPrimary() throws RecognitionException {   
        identPrimary_return retval = new identPrimary_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token LBRACK368=null;
        Token RBRACK369=null;
        propOrIdent_return poi = null;

        expression_return expr = null;

        arguments_return a = null;

        identPart_return identPart367 = null;

        List list_arguments=new ArrayList();
        List list_propOrIdent=new ArrayList();
        List list_identPart=new ArrayList();
        List list_expression=new ArrayList();
        List list_RBRACK=new ArrayList();
        List list_LBRACK=new ArrayList();
        LinkedListTree LBRACK368_tree=null;
        LinkedListTree RBRACK369_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:778:4: ( ( identPart -> identPart ) ( options {greedy=true; } : (poi= propOrIdent[root_0, retval.start] -> $poi) | ( LBRACK expr= expression RBRACK -> ^( ARRAY_ACC $identPrimary $expr) ) )* ( options {greedy=true; } : a= arguments -> ^( METHOD_CALL $identPrimary $a) )* )
            // org/asdt/core/internal/antlr/as3.g3:778:4: ( identPart -> identPart ) ( options {greedy=true; } : (poi= propOrIdent[root_0, retval.start] -> $poi) | ( LBRACK expr= expression RBRACK -> ^( ARRAY_ACC $identPrimary $expr) ) )* ( options {greedy=true; } : a= arguments -> ^( METHOD_CALL $identPrimary $a) )*
            {
            // org/asdt/core/internal/antlr/as3.g3:778:4: ( identPart -> identPart )
            // org/asdt/core/internal/antlr/as3.g3:778:5: identPart
            {
            pushFollow(FOLLOW_identPart_in_identPrimary3695);
            identPart367=identPart();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_identPart.add(identPart367.tree);

            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 778:15: -> identPart
            {
                adaptor.addChild(root_0, list_identPart.get(i_0));

            }

            }

            }

            // org/asdt/core/internal/antlr/as3.g3:779:3: ( options {greedy=true; } : (poi= propOrIdent[root_0, retval.start] -> $poi) | ( LBRACK expr= expression RBRACK -> ^( ARRAY_ACC $identPrimary $expr) ) )*
            loop97:
            do {
                int alt97=3;
                int LA97_0 = input.LA(1);
                if ( (LA97_0==DOT) ) {
                    int LA97_2 = input.LA(2);
                    if ( (LA97_2==IDENT) ) {
                        alt97=1;
                    }


                }
                else if ( (LA97_0==LBRACK) ) {
                    switch ( input.LA(2) ) {
                    case IDENT:
                        alt97=2;
                        break;
                    case INC:
                        alt97=2;
                        break;
                    case DEC:
                        alt97=2;
                        break;
                    case MINUS:
                        alt97=2;
                        break;
                    case PLUS:
                        alt97=2;
                        break;
                    case 162:
                        alt97=2;
                        break;
                    case 152:
                        alt97=2;
                        break;
                    case 163:
                        alt97=2;
                        break;
                    case LNOT:
                        alt97=2;
                        break;
                    case BNOT:
                        alt97=2;
                        break;
                    case 164:
                        alt97=2;
                        break;
                    case 165:
                        alt97=2;
                        break;
                    case LT:
                        alt97=2;
                        break;
                    case HEX_LITERAL:
                    case DECIMAL_LITERAL:
                    case OCTAL_LITERAL:
                    case FLOAT_LITERAL:
                        alt97=2;
                        break;
                    case STRING_LITERAL:
                        alt97=2;
                        break;
                    case TRUE:
                        alt97=2;
                        break;
                    case FALSE:
                        alt97=2;
                        break;
                    case LBRACK:
                        alt97=2;
                        break;
                    case LCURLY:
                        alt97=2;
                        break;
                    case FUNCTION:
                        alt97=2;
                        break;
                    case 166:
                        alt97=2;
                        break;
                    case LPAREN:
                        alt97=2;
                        break;

                    }

                }


                switch (alt97) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:782:5: (poi= propOrIdent[root_0, retval.start] -> $poi)
            	    {
            	    // org/asdt/core/internal/antlr/as3.g3:782:5: (poi= propOrIdent[root_0, retval.start] -> $poi)
            	    // org/asdt/core/internal/antlr/as3.g3:782:7: poi= propOrIdent[root_0, retval.start]
            	    {
            	    pushFollow(FOLLOW_propOrIdent_in_identPrimary3726);
            	    poi=propOrIdent(root_0,  retval.start);
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) list_propOrIdent.add(poi.tree);

            	    // AST REWRITE
            	    if ( backtracking==0 ) {
            	    int i_0 = 0;
            	    retval.tree = root_0;
            	    root_0 = (LinkedListTree)adaptor.nil();
            	    // 782:45: -> $poi
            	    {
            	        adaptor.addChild(root_0, poi.tree);

            	    }

            	    }

            	    }


            	    }
            	    break;
            	case 2 :
            	    // org/asdt/core/internal/antlr/as3.g3:784:5: ( LBRACK expr= expression RBRACK -> ^( ARRAY_ACC $identPrimary $expr) )
            	    {
            	    // org/asdt/core/internal/antlr/as3.g3:784:5: ( LBRACK expr= expression RBRACK -> ^( ARRAY_ACC $identPrimary $expr) )
            	    // org/asdt/core/internal/antlr/as3.g3:784:7: LBRACK expr= expression RBRACK
            	    {
            	    LBRACK368=(Token)input.LT(1);
            	    match(input,LBRACK,FOLLOW_LBRACK_in_identPrimary3745); if (failed) return retval;
            	    if ( backtracking==0 ) list_LBRACK.add(LBRACK368);

            	    pushFollow(FOLLOW_expression_in_identPrimary3749);
            	    expr=expression();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) list_expression.add(expr.tree);
            	    RBRACK369=(Token)input.LT(1);
            	    match(input,RBRACK,FOLLOW_RBRACK_in_identPrimary3751); if (failed) return retval;
            	    if ( backtracking==0 ) list_RBRACK.add(RBRACK369);


            	    // AST REWRITE
            	    if ( backtracking==0 ) {
            	    int i_0 = 0;
            	    retval.tree = root_0;
            	    root_0 = (LinkedListTree)adaptor.nil();
            	    // 785:5: -> ^( ARRAY_ACC $identPrimary $expr)
            	    {
            	        // org/asdt/core/internal/antlr/as3.g3:785:8: ^( ARRAY_ACC $identPrimary $expr)
            	        {
            	        LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
            	        root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(ARRAY_ACC, "ARRAY_ACC"), root_1);

            	        adaptor.addChild(root_1, retval.tree);
            	        adaptor.addChild(root_1, expr.tree);

            	        adaptor.addChild(root_0, root_1);
            	        }

            	    }

            	    }

            	    }


            	    }
            	    break;

            	default :
            	    break loop97;
                }
            } while (true);

            // org/asdt/core/internal/antlr/as3.g3:788:3: ( options {greedy=true; } : a= arguments -> ^( METHOD_CALL $identPrimary $a) )*
            loop98:
            do {
                int alt98=2;
                int LA98_0 = input.LA(1);
                if ( (LA98_0==LPAREN) ) {
                    switch ( input.LA(2) ) {
                    case INC:
                        alt98=1;
                        break;
                    case DEC:
                        alt98=1;
                        break;
                    case MINUS:
                        alt98=1;
                        break;
                    case PLUS:
                        alt98=1;
                        break;
                    case 162:
                        alt98=1;
                        break;
                    case 152:
                        alt98=1;
                        break;
                    case 163:
                        alt98=1;
                        break;
                    case LNOT:
                        alt98=1;
                        break;
                    case BNOT:
                        alt98=1;
                        break;
                    case IDENT:
                        alt98=1;
                        break;
                    case 164:
                        alt98=1;
                        break;
                    case 165:
                        alt98=1;
                        break;
                    case LT:
                        alt98=1;
                        break;
                    case HEX_LITERAL:
                    case DECIMAL_LITERAL:
                    case OCTAL_LITERAL:
                    case FLOAT_LITERAL:
                        alt98=1;
                        break;
                    case STRING_LITERAL:
                        alt98=1;
                        break;
                    case TRUE:
                        alt98=1;
                        break;
                    case FALSE:
                        alt98=1;
                        break;
                    case LBRACK:
                        alt98=1;
                        break;
                    case LCURLY:
                        alt98=1;
                        break;
                    case FUNCTION:
                        alt98=1;
                        break;
                    case 166:
                        alt98=1;
                        break;
                    case LPAREN:
                        alt98=1;
                        break;
                    case RPAREN:
                        alt98=1;
                        break;

                    }

                }


                switch (alt98) {
            	case 1 :
            	    // org/asdt/core/internal/antlr/as3.g3:789:5: a= arguments
            	    {
            	    pushFollow(FOLLOW_arguments_in_identPrimary3796);
            	    a=arguments();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) list_arguments.add(a.tree);

            	    // AST REWRITE
            	    if ( backtracking==0 ) {
            	    int i_0 = 0;
            	    retval.tree = root_0;
            	    root_0 = (LinkedListTree)adaptor.nil();
            	    // 790:4: -> ^( METHOD_CALL $identPrimary $a)
            	    {
            	        // org/asdt/core/internal/antlr/as3.g3:790:7: ^( METHOD_CALL $identPrimary $a)
            	        {
            	        LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
            	        root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(METHOD_CALL, "METHOD_CALL"), root_1);

            	        adaptor.addChild(root_1, retval.tree);
            	        adaptor.addChild(root_1, a.tree);

            	        adaptor.addChild(root_0, root_1);
            	        }

            	    }

            	    }

            	    }
            	    break;

            	default :
            	    break loop98;
                }
            } while (true);


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end identPrimary

    public static class propOrIdent_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start propOrIdent
    // org/asdt/core/internal/antlr/as3.g3:794:1: propOrIdent[LinkedListTree identPrimary, Token startToken] : DOT propId= identPart -> ^( PROPERTY_OR_IDENTIFIER $propId) ;
    public propOrIdent_return propOrIdent(LinkedListTree identPrimary, Token startToken) throws RecognitionException {   
        propOrIdent_return retval = new propOrIdent_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token DOT370=null;
        identPart_return propId = null;

        List list_identPart=new ArrayList();
        List list_DOT=new ArrayList();
        LinkedListTree DOT370_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:796:3: ( DOT propId= identPart -> ^( PROPERTY_OR_IDENTIFIER $propId) )
            // org/asdt/core/internal/antlr/as3.g3:796:3: DOT propId= identPart
            {
            if ( backtracking==0 ) {
               retval.start = startToken; 
            }
            DOT370=(Token)input.LT(1);
            match(input,DOT,FOLLOW_DOT_in_propOrIdent3838); if (failed) return retval;
            if ( backtracking==0 ) list_DOT.add(DOT370);

            pushFollow(FOLLOW_identPart_in_propOrIdent3842);
            propId=identPart();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_identPart.add(propId.tree);

            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 803:3: -> ^( PROPERTY_OR_IDENTIFIER $propId)
            {
                // org/asdt/core/internal/antlr/as3.g3:803:6: ^( PROPERTY_OR_IDENTIFIER $propId)
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(PROPERTY_OR_IDENTIFIER, "PROPERTY_OR_IDENTIFIER"), root_1);

                adaptor.addChild(root_1, identPrimary);
                adaptor.addChild(root_1, propId.tree);

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end propOrIdent

    public static class constant_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start constant
    // org/asdt/core/internal/antlr/as3.g3:806:1: constant : ( xmlLiteral | number | STRING_LITERAL | TRUE | FALSE );
    public constant_return constant() throws RecognitionException {   
        constant_return retval = new constant_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token STRING_LITERAL373=null;
        Token TRUE374=null;
        Token FALSE375=null;
        xmlLiteral_return xmlLiteral371 = null;

        number_return number372 = null;


        LinkedListTree STRING_LITERAL373_tree=null;
        LinkedListTree TRUE374_tree=null;
        LinkedListTree FALSE375_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:807:4: ( xmlLiteral | number | STRING_LITERAL | TRUE | FALSE )
            int alt99=5;
            switch ( input.LA(1) ) {
            case LT:
                alt99=1;
                break;
            case HEX_LITERAL:
            case DECIMAL_LITERAL:
            case OCTAL_LITERAL:
            case FLOAT_LITERAL:
                alt99=2;
                break;
            case STRING_LITERAL:
                alt99=3;
                break;
            case TRUE:
                alt99=4;
                break;
            case FALSE:
                alt99=5;
                break;
            default:
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("806:1: constant : ( xmlLiteral | number | STRING_LITERAL | TRUE | FALSE );", 99, 0, input);

                throw nvae;
            }

            switch (alt99) {
                case 1 :
                    // org/asdt/core/internal/antlr/as3.g3:807:4: xmlLiteral
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_xmlLiteral_in_constant3870);
                    xmlLiteral371=xmlLiteral();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, xmlLiteral371.tree);

                    }
                    break;
                case 2 :
                    // org/asdt/core/internal/antlr/as3.g3:808:4: number
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    pushFollow(FOLLOW_number_in_constant3875);
                    number372=number();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, number372.tree);

                    }
                    break;
                case 3 :
                    // org/asdt/core/internal/antlr/as3.g3:809:4: STRING_LITERAL
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    STRING_LITERAL373=(Token)input.LT(1);
                    match(input,STRING_LITERAL,FOLLOW_STRING_LITERAL_in_constant3880); if (failed) return retval;
                    if ( backtracking==0 ) {
                    STRING_LITERAL373_tree = (LinkedListTree)adaptor.create(STRING_LITERAL373);
                    adaptor.addChild(root_0, STRING_LITERAL373_tree);
                    }

                    }
                    break;
                case 4 :
                    // org/asdt/core/internal/antlr/as3.g3:810:4: TRUE
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    TRUE374=(Token)input.LT(1);
                    match(input,TRUE,FOLLOW_TRUE_in_constant3885); if (failed) return retval;
                    if ( backtracking==0 ) {
                    TRUE374_tree = (LinkedListTree)adaptor.create(TRUE374);
                    adaptor.addChild(root_0, TRUE374_tree);
                    }

                    }
                    break;
                case 5 :
                    // org/asdt/core/internal/antlr/as3.g3:811:4: FALSE
                    {
                    root_0 = (LinkedListTree)adaptor.nil();

                    FALSE375=(Token)input.LT(1);
                    match(input,FALSE,FOLLOW_FALSE_in_constant3890); if (failed) return retval;
                    if ( backtracking==0 ) {
                    FALSE375_tree = (LinkedListTree)adaptor.create(FALSE375);
                    adaptor.addChild(root_0, FALSE375_tree);
                    }

                    }
                    break;

            }
        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end constant

    public static class number_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start number
    // org/asdt/core/internal/antlr/as3.g3:814:1: number : (HEX_LITERAL|DECIMAL_LITERAL|OCTAL_LITERAL|FLOAT_LITERAL);
    public number_return number() throws RecognitionException {   
        number_return retval = new number_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token set376=null;

        LinkedListTree set376_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:814:8: ( (HEX_LITERAL|DECIMAL_LITERAL|OCTAL_LITERAL|FLOAT_LITERAL))
            // org/asdt/core/internal/antlr/as3.g3:814:10: (HEX_LITERAL|DECIMAL_LITERAL|OCTAL_LITERAL|FLOAT_LITERAL)
            {
            root_0 = (LinkedListTree)adaptor.nil();

            set376=(Token)input.LT(1);
            if ( (input.LA(1)>=HEX_LITERAL && input.LA(1)<=FLOAT_LITERAL) ) {
                if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set376));
                input.consume();
                errorRecovery=false;failed=false;
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                MismatchedSetException mse =
                    new MismatchedSetException(null,input);
                recoverFromMismatchedSet(input,mse,FOLLOW_set_in_number3900);    throw mse;
            }


            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end number

    public static class xmlLiteral_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start xmlLiteral
    // org/asdt/core/internal/antlr/as3.g3:821:1: xmlLiteral : s= LT -> ^() ;
    public xmlLiteral_return xmlLiteral() throws RecognitionException {   
        xmlLiteral_return retval = new xmlLiteral_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token s=null;
        List list_LT=new ArrayList();
        LinkedListTree s_tree=null;

        
        		LinkedListTree xml = null;
        	
        try {
            // org/asdt/core/internal/antlr/as3.g3:825:4: (s= LT -> ^() )
            // org/asdt/core/internal/antlr/as3.g3:825:4: s= LT
            {
            s=(Token)input.LT(1);
            match(input,LT,FOLLOW_LT_in_xmlLiteral3936); if (failed) return retval;
            if ( backtracking==0 ) list_LT.add(s);

            if ( backtracking==0 ) {
               xml=parseXMLLiteral((LinkedListToken)s); 
            }

            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 826:3: -> ^()
            {
                // org/asdt/core/internal/antlr/as3.g3:826:6: ^()
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(xml, root_1);

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end xmlLiteral

    public static class newExpression_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start newExpression
    // org/asdt/core/internal/antlr/as3.g3:829:1: newExpression : 'new'^ postfixExpression ;
    public newExpression_return newExpression() throws RecognitionException {   
        newExpression_return retval = new newExpression_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token string_literal377=null;
        postfixExpression_return postfixExpression378 = null;


        LinkedListTree string_literal377_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:830:4: ( 'new'^ postfixExpression )
            // org/asdt/core/internal/antlr/as3.g3:830:4: 'new'^ postfixExpression
            {
            root_0 = (LinkedListTree)adaptor.nil();

            string_literal377=(Token)input.LT(1);
            match(input,166,FOLLOW_166_in_newExpression3957); if (failed) return retval;
            if ( backtracking==0 ) {
            string_literal377_tree = (LinkedListTree)adaptor.create(string_literal377);
            root_0 = (LinkedListTree)adaptor.becomeRoot(string_literal377_tree, root_0);
            }
            pushFollow(FOLLOW_postfixExpression_in_newExpression3960);
            postfixExpression378=postfixExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, postfixExpression378.tree);

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end newExpression

    public static class encapsulatedExpression_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start encapsulatedExpression
    // org/asdt/core/internal/antlr/as3.g3:832:1: encapsulatedExpression : LPAREN assignmentExpression RPAREN -> ^( ENCPS_EXPR assignmentExpression ) ;
    public encapsulatedExpression_return encapsulatedExpression() throws RecognitionException {   
        encapsulatedExpression_return retval = new encapsulatedExpression_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token LPAREN379=null;
        Token RPAREN381=null;
        assignmentExpression_return assignmentExpression380 = null;

        List list_assignmentExpression=new ArrayList();
        List list_RPAREN=new ArrayList();
        List list_LPAREN=new ArrayList();
        LinkedListTree LPAREN379_tree=null;
        LinkedListTree RPAREN381_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:833:4: ( LPAREN assignmentExpression RPAREN -> ^( ENCPS_EXPR assignmentExpression ) )
            // org/asdt/core/internal/antlr/as3.g3:833:4: LPAREN assignmentExpression RPAREN
            {
            LPAREN379=(Token)input.LT(1);
            match(input,LPAREN,FOLLOW_LPAREN_in_encapsulatedExpression3970); if (failed) return retval;
            if ( backtracking==0 ) list_LPAREN.add(LPAREN379);

            pushFollow(FOLLOW_assignmentExpression_in_encapsulatedExpression3972);
            assignmentExpression380=assignmentExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_assignmentExpression.add(assignmentExpression380.tree);
            RPAREN381=(Token)input.LT(1);
            match(input,RPAREN,FOLLOW_RPAREN_in_encapsulatedExpression3974); if (failed) return retval;
            if ( backtracking==0 ) list_RPAREN.add(RPAREN381);


            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 834:3: -> ^( ENCPS_EXPR assignmentExpression )
            {
                // org/asdt/core/internal/antlr/as3.g3:834:6: ^( ENCPS_EXPR assignmentExpression )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(ENCPS_EXPR, "ENCPS_EXPR"), root_1);

                adaptor.addChild(root_1, list_assignmentExpression.get(i_0));

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end encapsulatedExpression

    public static class functionDefinition_return extends ParserRuleReturnScope {
        LinkedListTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start functionDefinition
    // org/asdt/core/internal/antlr/as3.g3:836:1: functionDefinition : FUNCTION parameterDeclarationList typeExpression block -> ^( FUNC_DEF parameterDeclarationList typeExpression block ) ;
    public functionDefinition_return functionDefinition() throws RecognitionException {   
        functionDefinition_return retval = new functionDefinition_return();
        retval.start = input.LT(1);

        LinkedListTree root_0 = null;

        Token FUNCTION382=null;
        parameterDeclarationList_return parameterDeclarationList383 = null;

        typeExpression_return typeExpression384 = null;

        block_return block385 = null;

        List list_typeExpression=new ArrayList();
        List list_parameterDeclarationList=new ArrayList();
        List list_block=new ArrayList();
        List list_FUNCTION=new ArrayList();
        LinkedListTree FUNCTION382_tree=null;

        try {
            // org/asdt/core/internal/antlr/as3.g3:837:4: ( FUNCTION parameterDeclarationList typeExpression block -> ^( FUNC_DEF parameterDeclarationList typeExpression block ) )
            // org/asdt/core/internal/antlr/as3.g3:837:4: FUNCTION parameterDeclarationList typeExpression block
            {
            FUNCTION382=(Token)input.LT(1);
            match(input,FUNCTION,FOLLOW_FUNCTION_in_functionDefinition3994); if (failed) return retval;
            if ( backtracking==0 ) list_FUNCTION.add(FUNCTION382);

            pushFollow(FOLLOW_parameterDeclarationList_in_functionDefinition3996);
            parameterDeclarationList383=parameterDeclarationList();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_parameterDeclarationList.add(parameterDeclarationList383.tree);
            pushFollow(FOLLOW_typeExpression_in_functionDefinition3998);
            typeExpression384=typeExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_typeExpression.add(typeExpression384.tree);
            pushFollow(FOLLOW_block_in_functionDefinition4000);
            block385=block();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) list_block.add(block385.tree);

            // AST REWRITE
            if ( backtracking==0 ) {
            int i_0 = 0;
            retval.tree = root_0;
            root_0 = (LinkedListTree)adaptor.nil();
            // 838:3: -> ^( FUNC_DEF parameterDeclarationList typeExpression block )
            {
                // org/asdt/core/internal/antlr/as3.g3:838:6: ^( FUNC_DEF parameterDeclarationList typeExpression block )
                {
                LinkedListTree root_1 = (LinkedListTree)adaptor.nil();
                root_1 = (LinkedListTree)adaptor.becomeRoot(adaptor.create(FUNC_DEF, "FUNC_DEF"), root_1);

                adaptor.addChild(root_1, list_parameterDeclarationList.get(i_0));
                adaptor.addChild(root_1, list_typeExpression.get(i_0));
                adaptor.addChild(root_1, list_block.get(i_0));

                adaptor.addChild(root_0, root_1);
                }

            }

            }

            }

        }
             finally {
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (LinkedListTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        return retval;
    }
    // $ANTLR end functionDefinition

    // $ANTLR start synpred1
    public void synpred1_fragment() throws RecognitionException {   
        // org/asdt/core/internal/antlr/as3.g3:428:5: ( LPAREN forInit SEMI )
        // org/asdt/core/internal/antlr/as3.g3:428:6: LPAREN forInit SEMI
        {
        match(input,LPAREN,FOLLOW_LPAREN_in_synpred11764); if (failed) return ;
        pushFollow(FOLLOW_forInit_in_synpred11766);
        forInit();
        _fsp--;
        if (failed) return ;
        match(input,SEMI,FOLLOW_SEMI_in_synpred11768); if (failed) return ;

        }
    }
    // $ANTLR end synpred1

    // $ANTLR start synpred3
    public void synpred3_fragment() throws RecognitionException {   
        // org/asdt/core/internal/antlr/as3.g3:618:4: ( (ASSIGN|STAR_ASSIGN|DIV_ASSIGN|MOD_ASSIGN|PLUS_ASSIGN|MINUS_ASSIGN|SL_ASSIGN|SR_ASSIGN|BSR_ASSIGN|BAND_ASSIGN|BXOR_ASSIGN|BOR_ASSIGN|LAND_ASSIGN|LOR_ASSIGN)~ ASSIGN )
        // org/asdt/core/internal/antlr/as3.g3:618:6: (ASSIGN|STAR_ASSIGN|DIV_ASSIGN|MOD_ASSIGN|PLUS_ASSIGN|MINUS_ASSIGN|SL_ASSIGN|SR_ASSIGN|BSR_ASSIGN|BAND_ASSIGN|BXOR_ASSIGN|BOR_ASSIGN|LAND_ASSIGN|LOR_ASSIGN)~ ASSIGN
        {
        if ( input.LA(1)==ASSIGN||(input.LA(1)>=STAR_ASSIGN && input.LA(1)<=LOR_ASSIGN) ) {
            input.consume();
            errorRecovery=false;failed=false;
        }
        else {
            if (backtracking>0) {failed=true; return ;}
            MismatchedSetException mse =
                new MismatchedSetException(null,input);
            recoverFromMismatchedSet(input,mse,FOLLOW_set_in_synpred32693);    throw mse;
        }

        if ( (input.LA(1)>=COMPILATION_UNIT && input.LA(1)<=CONST)||(input.LA(1)>=LPAREN && input.LA(1)<=166) ) {
            input.consume();
            errorRecovery=false;failed=false;
        }
        else {
            if (backtracking>0) {failed=true; return ;}
            MismatchedSetException mse =
                new MismatchedSetException(null,input);
            recoverFromMismatchedSet(input,mse,FOLLOW_set_in_synpred32792);    throw mse;
        }


        }
    }
    // $ANTLR end synpred3

    public boolean synpred3() {
        backtracking++;
        int start = input.mark();
        try {
            synpred3_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !failed;
        input.rewind(start);
        backtracking--;
        failed=false;
        return success;
    }
    public boolean synpred1() {
        backtracking++;
        int start = input.mark();
        try {
            synpred1_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !failed;
        input.rewind(start);
        backtracking--;
        failed=false;
        return success;
    }


 

    public static final BitSet FOLLOW_as2CompilationUnit_in_compilationUnit239 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_as3CompilationUnit_in_compilationUnit245 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_importDefinition_in_as2CompilationUnit272 = new BitSet(new long[]{0x0030000000000000L});
    public static final BitSet FOLLOW_classDefinition_in_as2CompilationUnit277 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_interfaceDefinition_in_as2CompilationUnit283 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_packageDecl_in_as3CompilationUnit295 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_as3CompilationUnit299 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PACKAGE_in_packageDecl311 = new BitSet(new long[]{0x0042000000000000L});
    public static final BitSet FOLLOW_identifier_in_packageDecl314 = new BitSet(new long[]{0x0002000000000000L});
    public static final BitSet FOLLOW_packageBlock_in_packageDecl319 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LCURLY_in_packageBlock330 = new BitSet(new long[]{0x38FC000000000000L,0x00000000001D0000L,0x00000000FE000000L});
    public static final BitSet FOLLOW_packageBlockEntry_in_packageBlock334 = new BitSet(new long[]{0x38FC000000000000L,0x00000000001D0000L,0x00000000FE000000L});
    public static final BitSet FOLLOW_RCURLY_in_packageBlock339 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_importDefinition_in_packageBlockEntry363 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_annotations_in_packageBlockEntry371 = new BitSet(new long[]{0x38E0000000000000L,0x00000000001C0000L,0x00000000FE000000L});
    public static final BitSet FOLLOW_modifiers_in_packageBlockEntry376 = new BitSet(new long[]{0x38E0000000000000L});
    public static final BitSet FOLLOW_classDefinition_in_packageBlockEntry384 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_interfaceDefinition_in_packageBlockEntry392 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_variableDefinition_in_packageBlockEntry400 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_methodDefinition_in_packageBlockEntry408 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_namespaceDefinition_in_packageBlockEntry416 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SEMI_in_packageBlockEntry428 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_EOF_in_endOfFile444 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IMPORT_in_importDefinition456 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_identifierStar_in_importDefinition459 = new BitSet(new long[]{0x0008000000000002L});
    public static final BitSet FOLLOW_SEMI_in_importDefinition463 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CLASS_in_classDefinition480 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_IDENT_in_classDefinition482 = new BitSet(new long[]{0x0502000000000000L});
    public static final BitSet FOLLOW_classExtendsClause_in_classDefinition486 = new BitSet(new long[]{0x0402000000000000L});
    public static final BitSet FOLLOW_implementsClause_in_classDefinition490 = new BitSet(new long[]{0x0002000000000000L});
    public static final BitSet FOLLOW_typeBlock_in_classDefinition494 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INTERFACE_in_interfaceDefinition526 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_IDENT_in_interfaceDefinition528 = new BitSet(new long[]{0x0102000000000000L});
    public static final BitSet FOLLOW_interfaceExtendsClause_in_interfaceDefinition532 = new BitSet(new long[]{0x0002000000000000L});
    public static final BitSet FOLLOW_typeBlock_in_interfaceDefinition536 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_EXTENDS_in_classExtendsClause564 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_identifier_in_classExtendsClause567 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_EXTENDS_in_interfaceExtendsClause580 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_identifier_in_interfaceExtendsClause583 = new BitSet(new long[]{0x0200000000000002L});
    public static final BitSet FOLLOW_COMMA_in_interfaceExtendsClause587 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_identifier_in_interfaceExtendsClause590 = new BitSet(new long[]{0x0200000000000002L});
    public static final BitSet FOLLOW_IMPLEMENTS_in_implementsClause605 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_identifier_in_implementsClause608 = new BitSet(new long[]{0x0200000000000002L});
    public static final BitSet FOLLOW_COMMA_in_implementsClause612 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_identifier_in_implementsClause615 = new BitSet(new long[]{0x0200000000000002L});
    public static final BitSet FOLLOW_LCURLY_in_typeBlock629 = new BitSet(new long[]{0x381C000000000000L,0x00000000001D0000L,0x00000000FE000000L});
    public static final BitSet FOLLOW_typeBlockEntry_in_typeBlock633 = new BitSet(new long[]{0x381C000000000000L,0x00000000001D0000L,0x00000000FE000000L});
    public static final BitSet FOLLOW_RCURLY_in_typeBlock638 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_annotations_in_typeBlockEntry664 = new BitSet(new long[]{0x3800000000000000L,0x00000000001C0000L,0x00000000FE000000L});
    public static final BitSet FOLLOW_modifiers_in_typeBlockEntry669 = new BitSet(new long[]{0x3800000000000000L});
    public static final BitSet FOLLOW_variableDefinition_in_typeBlockEntry677 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_methodDefinition_in_typeBlockEntry685 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SEMI_in_typeBlockEntry697 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_importDefinition_in_typeBlockEntry703 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_functionDecl_in_methodDefinition719 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_IDENT_in_methodDefinition721 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_parameterDeclarationList_in_methodDefinition725 = new BitSet(new long[]{0x0002000000000002L,0x0000000000000100L});
    public static final BitSet FOLLOW_typeExpression_in_methodDefinition729 = new BitSet(new long[]{0x0002000000000002L});
    public static final BitSet FOLLOW_block_in_methodDefinition734 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FUNCTION_in_functionDecl800 = new BitSet(new long[]{0x0040000000000002L});
    public static final BitSet FOLLOW_accessorRole_in_functionDecl806 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_getKeyword_in_accessorRole819 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_setKeyword_in_accessorRole823 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IDENT_in_getKeyword838 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IDENT_in_setKeyword860 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_namespaceKeyword_in_namespaceDefinition879 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_IDENT_in_namespaceDefinition881 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IDENT_in_namespaceKeyword909 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IDENT_in_xmlKeyword922 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_varOrConst_in_variableDefinition936 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_variableDeclarator_in_variableDefinition938 = new BitSet(new long[]{0x0200000000000002L});
    public static final BitSet FOLLOW_COMMA_in_variableDefinition943 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_variableDeclarator_in_variableDefinition945 = new BitSet(new long[]{0x0200000000000002L});
    public static final BitSet FOLLOW_set_in_varOrConst976 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IDENT_in_variableDeclarator991 = new BitSet(new long[]{0x4000000000000002L,0x0000000000000100L});
    public static final BitSet FOLLOW_typeExpression_in_variableDeclarator994 = new BitSet(new long[]{0x4000000000000002L});
    public static final BitSet FOLLOW_variableInitializer_in_variableDeclarator996 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VAR_in_declaration1007 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_variableDeclarator_in_declaration1010 = new BitSet(new long[]{0x0200000000000002L});
    public static final BitSet FOLLOW_COMMA_in_declaration1015 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_variableDeclarator_in_declaration1018 = new BitSet(new long[]{0x0200000000000002L});
    public static final BitSet FOLLOW_ASSIGN_in_variableInitializer1030 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_expression_in_variableInitializer1033 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAREN_in_parameterDeclarationList1046 = new BitSet(new long[]{0x2040000000000000L,0x0000000000000003L});
    public static final BitSet FOLLOW_parameterDeclaration_in_parameterDeclarationList1052 = new BitSet(new long[]{0x0200000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_COMMA_in_parameterDeclarationList1058 = new BitSet(new long[]{0x2040000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_parameterDeclaration_in_parameterDeclarationList1060 = new BitSet(new long[]{0x0200000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_RPAREN_in_parameterDeclarationList1071 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_basicParameterDeclaration_in_parameterDeclaration1094 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_parameterRestDeclaration_in_parameterDeclaration1098 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CONST_in_basicParameterDeclaration1109 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_IDENT_in_basicParameterDeclaration1112 = new BitSet(new long[]{0x4000000000000002L,0x0000000000000100L});
    public static final BitSet FOLLOW_typeExpression_in_basicParameterDeclaration1114 = new BitSet(new long[]{0x4000000000000002L});
    public static final BitSet FOLLOW_parameterDefault_in_basicParameterDeclaration1116 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ASSIGN_in_parameterDefault1149 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_assignmentExpression_in_parameterDefault1152 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_REST_in_parameterRestDeclaration1163 = new BitSet(new long[]{0x2040000000000000L});
    public static final BitSet FOLLOW_CONST_in_parameterRestDeclaration1165 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_IDENT_in_parameterRestDeclaration1168 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LCURLY_in_block1193 = new BitSet(new long[]{0x984E000000000000L,0xE79810000001065CL,0x0000007C01E7000FL});
    public static final BitSet FOLLOW_statement_in_block1196 = new BitSet(new long[]{0x984E000000000000L,0xE79810000001065CL,0x0000007C01E7000FL});
    public static final BitSet FOLLOW_RCURLY_in_block1200 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAREN_in_condition1222 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_expression_in_condition1225 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_RPAREN_in_condition1227 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_block_in_statement1241 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_declarationStatement_in_statement1247 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expressionStatement_in_statement1252 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ifStatement_in_statement1257 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_forEachStatement_in_statement1264 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_forStatement_in_statement1269 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_WHILE_in_statement1277 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_condition_in_statement1279 = new BitSet(new long[]{0x984A000000000000L,0xE79810000001065CL,0x0000007C01E7000FL});
    public static final BitSet FOLLOW_statement_in_statement1281 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DO_in_statement1289 = new BitSet(new long[]{0x984A000000000000L,0xE79810000001065CL,0x0000007C01E7000FL});
    public static final BitSet FOLLOW_statement_in_statement1291 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_WHILE_in_statement1293 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_condition_in_statement1296 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_144_in_statement1305 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_condition_in_statement1307 = new BitSet(new long[]{0x984A000000000000L,0xE79810000001065CL,0x0000007C01E7000FL});
    public static final BitSet FOLLOW_statement_in_statement1309 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_switchStatement_in_statement1318 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_breakStatement_in_statement1327 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_continueStatement_in_statement1335 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_returnStatement_in_statement1343 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_throwStatement_in_statement1351 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_tryStatement_in_statement1360 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_defaultXMLNamespaceStatement_in_statement1369 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SEMI_in_statement1377 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_declaration_in_declarationStatement1389 = new BitSet(new long[]{0x0008000000000002L});
    public static final BitSet FOLLOW_SEMI_in_declarationStatement1393 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_assignmentExpression_in_expressionStatement1407 = new BitSet(new long[]{0x0008000000000002L});
    public static final BitSet FOLLOW_SEMI_in_expressionStatement1411 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IF_in_ifStatement1435 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_condition_in_ifStatement1438 = new BitSet(new long[]{0x984A000000000000L,0xE79810000001065CL,0x0000007C01E7000FL});
    public static final BitSet FOLLOW_statement_in_ifStatement1440 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000020L});
    public static final BitSet FOLLOW_ELSE_in_ifStatement1445 = new BitSet(new long[]{0x984A000000000000L,0xE79810000001065CL,0x0000007C01E7000FL});
    public static final BitSet FOLLOW_statement_in_ifStatement1447 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_145_in_throwStatement1460 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_expression_in_throwStatement1463 = new BitSet(new long[]{0x0008000000000002L});
    public static final BitSet FOLLOW_SEMI_in_throwStatement1467 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_146_in_tryStatement1481 = new BitSet(new long[]{0x0002000000000000L});
    public static final BitSet FOLLOW_block_in_tryStatement1485 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000180000L});
    public static final BitSet FOLLOW_147_in_tryStatement1491 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_LPAREN_in_tryStatement1493 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_IDENT_in_tryStatement1496 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000101L});
    public static final BitSet FOLLOW_typeExpression_in_tryStatement1498 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_RPAREN_in_tryStatement1500 = new BitSet(new long[]{0x0002000000000000L});
    public static final BitSet FOLLOW_block_in_tryStatement1506 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000100000L});
    public static final BitSet FOLLOW_148_in_tryStatement1520 = new BitSet(new long[]{0x0002000000000000L});
    public static final BitSet FOLLOW_block_in_tryStatement1525 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_149_in_returnStatement1541 = new BitSet(new long[]{0x884A000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_expression_in_returnStatement1545 = new BitSet(new long[]{0x0008000000000000L});
    public static final BitSet FOLLOW_SEMI_in_returnStatement1549 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_150_in_continueStatement1563 = new BitSet(new long[]{0x0008000000000002L});
    public static final BitSet FOLLOW_SEMI_in_continueStatement1569 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_151_in_breakStatement1584 = new BitSet(new long[]{0x0008000000000002L});
    public static final BitSet FOLLOW_SEMI_in_breakStatement1590 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SWITCH_in_switchStatement1605 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_condition_in_switchStatement1608 = new BitSet(new long[]{0x0002000000000000L});
    public static final BitSet FOLLOW_switchBlock_in_switchStatement1612 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LCURLY_in_switchBlock1623 = new BitSet(new long[]{0x0004000000000000L,0x0000000000000280L});
    public static final BitSet FOLLOW_caseStatement_in_switchBlock1628 = new BitSet(new long[]{0x0004000000000000L,0x0000000000000280L});
    public static final BitSet FOLLOW_defaultStatement_in_switchBlock1635 = new BitSet(new long[]{0x0004000000000000L});
    public static final BitSet FOLLOW_RCURLY_in_switchBlock1641 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CASE_in_caseStatement1666 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_expression_in_caseStatement1669 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000100L});
    public static final BitSet FOLLOW_COLON_in_caseStatement1671 = new BitSet(new long[]{0x984A000000000002L,0xE79810000001065CL,0x0000007C01E7000FL});
    public static final BitSet FOLLOW_switchStatementList_in_caseStatement1674 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DEFAULT_in_defaultStatement1686 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000100L});
    public static final BitSet FOLLOW_COLON_in_defaultStatement1689 = new BitSet(new long[]{0x984A000000000002L,0xE79810000001065CL,0x0000007C01E7000FL});
    public static final BitSet FOLLOW_switchStatementList_in_defaultStatement1692 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_statement_in_switchStatementList1703 = new BitSet(new long[]{0x984A000000000002L,0xE79810000001065CL,0x0000007C01E7000FL});
    public static final BitSet FOLLOW_FOR_in_forEachStatement1724 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_EACH_in_forEachStatement1726 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_forInClause_in_forEachStatement1730 = new BitSet(new long[]{0x984A000000000000L,0xE79810000001065CL,0x0000007C01E7000FL});
    public static final BitSet FOLLOW_statement_in_forEachStatement1734 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FOR_in_forStatement1756 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_traditionalForClause_in_forStatement1771 = new BitSet(new long[]{0x984A000000000000L,0xE79810000001065CL,0x0000007C01E7000FL});
    public static final BitSet FOLLOW_forInClause_in_forStatement1777 = new BitSet(new long[]{0x984A000000000000L,0xE79810000001065CL,0x0000007C01E7000FL});
    public static final BitSet FOLLOW_statement_in_forStatement1785 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAREN_in_traditionalForClause1801 = new BitSet(new long[]{0x984A000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_forInit_in_traditionalForClause1806 = new BitSet(new long[]{0x0008000000000000L});
    public static final BitSet FOLLOW_SEMI_in_traditionalForClause1808 = new BitSet(new long[]{0x884A000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_forCond_in_traditionalForClause1814 = new BitSet(new long[]{0x0008000000000000L});
    public static final BitSet FOLLOW_SEMI_in_traditionalForClause1816 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010001L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_forIter_in_traditionalForClause1822 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_RPAREN_in_traditionalForClause1829 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAREN_in_forInClause1841 = new BitSet(new long[]{0x1000000000000000L});
    public static final BitSet FOLLOW_declaration_in_forInClause1846 = new BitSet(new long[]{0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_IN_in_forInClause1848 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_expression_in_forInClause1850 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_RPAREN_in_forInClause1854 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_declaration_in_forInit1873 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expressionList_in_forInit1877 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expression_in_forCond1903 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expressionList_in_forIter1928 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DEFAULT_in_defaultXMLNamespaceStatement1953 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_xmlKeyword_in_defaultXMLNamespaceStatement1955 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_namespaceKeyword_in_defaultXMLNamespaceStatement1957 = new BitSet(new long[]{0x4000000000000000L});
    public static final BitSet FOLLOW_ASSIGN_in_defaultXMLNamespaceStatement1959 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_expression_in_defaultXMLNamespaceStatement1961 = new BitSet(new long[]{0x0008000000000000L});
    public static final BitSet FOLLOW_SEMI_in_defaultXMLNamespaceStatement1963 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_COLON_in_typeExpression1989 = new BitSet(new long[]{0x0040000000000000L,0x0000000000002000L,0x0000000001000000L});
    public static final BitSet FOLLOW_identifier_in_typeExpression1999 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_152_in_typeExpression2003 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STAR_in_typeExpression2007 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_identPart_in_identifier2045 = new BitSet(new long[]{0x0000000000000002L,0x0000000000004000L});
    public static final BitSet FOLLOW_DOT_in_identifier2063 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_identPart_in_identifier2065 = new BitSet(new long[]{0x0000000000000002L,0x0000000000004000L});
    public static final BitSet FOLLOW_IDENT_in_identPart2092 = new BitSet(new long[]{0x0000000000000002L,0x0000000000008000L});
    public static final BitSet FOLLOW_DBL_COLON_in_identPart2095 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_IDENT_in_identPart2098 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IDENT_in_identifierStar2111 = new BitSet(new long[]{0x0000000000000002L,0x0000000000004000L});
    public static final BitSet FOLLOW_DOT_in_identifierStar2128 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_IDENT_in_identifierStar2130 = new BitSet(new long[]{0x0000000000000002L,0x0000000000004000L});
    public static final BitSet FOLLOW_DOT_in_identifierStar2142 = new BitSet(new long[]{0x0000000000000000L,0x0000000000002000L});
    public static final BitSet FOLLOW_STAR_in_identifierStar2144 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_annotation_in_annotations2174 = new BitSet(new long[]{0x0000000000000002L,0x0000000000010000L});
    public static final BitSet FOLLOW_LBRACK_in_annotation2197 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_IDENT_in_annotation2201 = new BitSet(new long[]{0x8000000000000000L,0x0000000000020000L});
    public static final BitSet FOLLOW_annotationParamList_in_annotation2205 = new BitSet(new long[]{0x0000000000000000L,0x0000000000020000L});
    public static final BitSet FOLLOW_RBRACK_in_annotation2210 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAREN_in_annotationParamList2236 = new BitSet(new long[]{0x0040000000000000L,0xE000100000000001L,0x000000000000000FL});
    public static final BitSet FOLLOW_annotationParam_in_annotationParamList2242 = new BitSet(new long[]{0x0200000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_COMMA_in_annotationParamList2248 = new BitSet(new long[]{0x0040000000000000L,0xE000100000000000L,0x000000000000000FL});
    public static final BitSet FOLLOW_annotationParam_in_annotationParamList2250 = new BitSet(new long[]{0x0200000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_RPAREN_in_annotationParamList2261 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IDENT_in_annotationParam2288 = new BitSet(new long[]{0x4000000000000000L});
    public static final BitSet FOLLOW_ASSIGN_in_annotationParam2290 = new BitSet(new long[]{0x0000000000000000L,0xE000100000000000L,0x000000000000000FL});
    public static final BitSet FOLLOW_constant_in_annotationParam2292 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_constant_in_annotationParam2307 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IDENT_in_annotationParam2316 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_modifier_in_modifiers2331 = new BitSet(new long[]{0x0000000000000002L,0x00000000001C0000L,0x00000000FE000000L});
    public static final BitSet FOLLOW_set_in_modifier2353 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAREN_in_arguments2408 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010001L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_expressionList_in_arguments2414 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_RPAREN_in_arguments2428 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LBRACK_in_arrayLiteral2450 = new BitSet(new long[]{0x8A42000000000000L,0xE798100000030000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_elementList_in_arrayLiteral2452 = new BitSet(new long[]{0x0000000000000000L,0x0000000000020000L});
    public static final BitSet FOLLOW_RBRACK_in_arrayLiteral2455 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_COMMA_in_elementList2479 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_nonemptyElementList_in_elementList2485 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_assignmentExpression_in_nonemptyElementList2495 = new BitSet(new long[]{0x0200000000000002L});
    public static final BitSet FOLLOW_COMMA_in_nonemptyElementList2498 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_assignmentExpression_in_nonemptyElementList2501 = new BitSet(new long[]{0x0200000000000002L});
    public static final BitSet FOLLOW_assignmentExpression_in_element2514 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LCURLY_in_objectLiteral2536 = new BitSet(new long[]{0x0044000000000000L,0x0000000000000000L,0x000000000000000FL});
    public static final BitSet FOLLOW_fieldList_in_objectLiteral2538 = new BitSet(new long[]{0x0004000000000000L});
    public static final BitSet FOLLOW_RCURLY_in_objectLiteral2541 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_literalField_in_fieldList2564 = new BitSet(new long[]{0x0200000000000002L});
    public static final BitSet FOLLOW_COMMA_in_fieldList2567 = new BitSet(new long[]{0x0240000000000002L,0x0000000000000000L,0x000000000000000FL});
    public static final BitSet FOLLOW_literalField_in_fieldList2570 = new BitSet(new long[]{0x0200000000000002L});
    public static final BitSet FOLLOW_fieldName_in_literalField2587 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000100L});
    public static final BitSet FOLLOW_COLON_in_literalField2589 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_element_in_literalField2591 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IDENT_in_fieldName2615 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_number_in_fieldName2620 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_assignmentExpression_in_expression2632 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expression_in_expressionList2654 = new BitSet(new long[]{0x0200000000000002L});
    public static final BitSet FOLLOW_COMMA_in_expressionList2657 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_expression_in_expressionList2659 = new BitSet(new long[]{0x0200000000000002L});
    public static final BitSet FOLLOW_conditionalExpression_in_assignmentExpression2684 = new BitSet(new long[]{0x4000000000000002L,0x00000003FFE00000L});
    public static final BitSet FOLLOW_ASSIGN_in_assignmentExpression2805 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_STAR_ASSIGN_in_assignmentExpression2814 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_DIV_ASSIGN_in_assignmentExpression2822 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_MOD_ASSIGN_in_assignmentExpression2830 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_PLUS_ASSIGN_in_assignmentExpression2838 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_MINUS_ASSIGN_in_assignmentExpression2846 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_SL_ASSIGN_in_assignmentExpression2854 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_SR_ASSIGN_in_assignmentExpression2862 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_BSR_ASSIGN_in_assignmentExpression2870 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_BAND_ASSIGN_in_assignmentExpression2878 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_BXOR_ASSIGN_in_assignmentExpression2886 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_BOR_ASSIGN_in_assignmentExpression2894 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_LAND_ASSIGN_in_assignmentExpression2902 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_LOR_ASSIGN_in_assignmentExpression2910 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_assignmentExpression_in_assignmentExpression2920 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_logicalOrExpression_in_conditionalExpression2935 = new BitSet(new long[]{0x0000000000000002L,0x0000000400000000L});
    public static final BitSet FOLLOW_QUESTION_in_conditionalExpression2945 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_conditionalSubExpression_in_conditionalExpression2951 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_assignmentExpression_in_conditionalSubExpression2966 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000100L});
    public static final BitSet FOLLOW_COLON_in_conditionalSubExpression2968 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_assignmentExpression_in_conditionalSubExpression2971 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_logicalAndExpression_in_logicalOrExpression2982 = new BitSet(new long[]{0x0000000000000002L,0x0000000800000000L});
    public static final BitSet FOLLOW_LOR_in_logicalOrExpression2985 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_logicalAndExpression_in_logicalOrExpression2988 = new BitSet(new long[]{0x0000000000000002L,0x0000000800000000L});
    public static final BitSet FOLLOW_bitwiseOrExpression_in_logicalAndExpression3001 = new BitSet(new long[]{0x0000000000000002L,0x0000001000000000L});
    public static final BitSet FOLLOW_LAND_in_logicalAndExpression3004 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_bitwiseOrExpression_in_logicalAndExpression3007 = new BitSet(new long[]{0x0000000000000002L,0x0000001000000000L});
    public static final BitSet FOLLOW_bitwiseXorExpression_in_bitwiseOrExpression3020 = new BitSet(new long[]{0x0000000000000002L,0x0000002000000000L});
    public static final BitSet FOLLOW_BOR_in_bitwiseOrExpression3023 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_bitwiseXorExpression_in_bitwiseOrExpression3026 = new BitSet(new long[]{0x0000000000000002L,0x0000002000000000L});
    public static final BitSet FOLLOW_bitwiseAndExpression_in_bitwiseXorExpression3040 = new BitSet(new long[]{0x0000000000000002L,0x0000004000000000L});
    public static final BitSet FOLLOW_BXOR_in_bitwiseXorExpression3043 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_bitwiseAndExpression_in_bitwiseXorExpression3046 = new BitSet(new long[]{0x0000000000000002L,0x0000004000000000L});
    public static final BitSet FOLLOW_equalityExpression_in_bitwiseAndExpression3059 = new BitSet(new long[]{0x0000000000000002L,0x0000008000000000L});
    public static final BitSet FOLLOW_BAND_in_bitwiseAndExpression3062 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_equalityExpression_in_bitwiseAndExpression3065 = new BitSet(new long[]{0x0000000000000002L,0x0000008000000000L});
    public static final BitSet FOLLOW_relationalExpression_in_equalityExpression3078 = new BitSet(new long[]{0x0000000000000002L,0x00000F0000000000L});
    public static final BitSet FOLLOW_STRICT_EQUAL_in_equalityExpression3086 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_STRICT_NOT_EQUAL_in_equalityExpression3091 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_NOT_EQUAL_in_equalityExpression3096 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_EQUAL_in_equalityExpression3101 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_relationalExpression_in_equalityExpression3108 = new BitSet(new long[]{0x0000000000000002L,0x00000F0000000000L});
    public static final BitSet FOLLOW_shiftExpression_in_relationalExpression3125 = new BitSet(new long[]{0x0000000000000002L,0x0000F00000000000L,0x0000000300000000L});
    public static final BitSet FOLLOW_LT_in_relationalExpression3129 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_GT_in_relationalExpression3134 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_LE_in_relationalExpression3139 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_GE_in_relationalExpression3144 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_160_in_relationalExpression3149 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_161_in_relationalExpression3154 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_shiftExpression_in_relationalExpression3158 = new BitSet(new long[]{0x0000000000000002L,0x0000F00000000000L,0x0000000300000000L});
    public static final BitSet FOLLOW_additiveExpression_in_shiftExpression3174 = new BitSet(new long[]{0x0000000000000002L,0x0007000000000000L});
    public static final BitSet FOLLOW_SL_in_shiftExpression3178 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_SR_in_shiftExpression3183 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_BSR_in_shiftExpression3188 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_additiveExpression_in_shiftExpression3192 = new BitSet(new long[]{0x0000000000000002L,0x0007000000000000L});
    public static final BitSet FOLLOW_multiplicativeExpression_in_additiveExpression3208 = new BitSet(new long[]{0x0000000000000002L,0x0018000000000000L});
    public static final BitSet FOLLOW_PLUS_in_additiveExpression3212 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_MINUS_in_additiveExpression3217 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_multiplicativeExpression_in_additiveExpression3221 = new BitSet(new long[]{0x0000000000000002L,0x0018000000000000L});
    public static final BitSet FOLLOW_unaryExpression_in_multiplicativeExpression3235 = new BitSet(new long[]{0x0000000000000002L,0x0060000000002000L});
    public static final BitSet FOLLOW_STAR_in_multiplicativeExpression3239 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_DIV_in_multiplicativeExpression3244 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_MOD_in_multiplicativeExpression3249 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_unaryExpression_in_multiplicativeExpression3253 = new BitSet(new long[]{0x0000000000000002L,0x0060000000002000L});
    public static final BitSet FOLLOW_INC_in_unaryExpression3266 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_unaryExpression_in_unaryExpression3269 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DEC_in_unaryExpression3274 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_unaryExpression_in_unaryExpression3277 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_MINUS_in_unaryExpression3282 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_unaryExpression_in_unaryExpression3284 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PLUS_in_unaryExpression3297 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_unaryExpression_in_unaryExpression3299 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_unaryExpressionNotPlusMinus_in_unaryExpression3312 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_162_in_unaryExpressionNotPlusMinus3323 = new BitSet(new long[]{0x8842000000000000L,0xE000100000010000L,0x000000700000000FL});
    public static final BitSet FOLLOW_postfixExpression_in_unaryExpressionNotPlusMinus3326 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_152_in_unaryExpressionNotPlusMinus3331 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_unaryExpression_in_unaryExpressionNotPlusMinus3334 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_163_in_unaryExpressionNotPlusMinus3339 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_unaryExpression_in_unaryExpressionNotPlusMinus3342 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LNOT_in_unaryExpressionNotPlusMinus3347 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_unaryExpression_in_unaryExpressionNotPlusMinus3350 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_BNOT_in_unaryExpressionNotPlusMinus3355 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_unaryExpression_in_unaryExpressionNotPlusMinus3358 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_postfixExpression_in_unaryExpressionNotPlusMinus3363 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_primaryExpression_in_postfixExpression3376 = new BitSet(new long[]{0x0000000000000002L,0x0980000000014000L});
    public static final BitSet FOLLOW_DOT_in_postfixExpression3401 = new BitSet(new long[]{0x0040000000000000L,0x1000000000002000L});
    public static final BitSet FOLLOW_identPart_in_postfixExpression3414 = new BitSet(new long[]{0x8000000000000002L,0x0980000000014000L});
    public static final BitSet FOLLOW_e4xExpression_in_postfixExpression3422 = new BitSet(new long[]{0x8000000000000002L,0x0980000000014000L});
    public static final BitSet FOLLOW_LBRACK_in_postfixExpression3437 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_expression_in_postfixExpression3439 = new BitSet(new long[]{0x0000000000000000L,0x0000000000020000L});
    public static final BitSet FOLLOW_RBRACK_in_postfixExpression3441 = new BitSet(new long[]{0x8000000000000002L,0x0980000000014000L});
    public static final BitSet FOLLOW_E4X_DESC_in_postfixExpression3471 = new BitSet(new long[]{0x0040000000000000L,0x1000000000002000L});
    public static final BitSet FOLLOW_e4xExpression_in_postfixExpression3473 = new BitSet(new long[]{0x8000000000000002L,0x0980000000014000L});
    public static final BitSet FOLLOW_methodCall_in_postfixExpression3483 = new BitSet(new long[]{0x0000000000000002L,0x0980000000014000L});
    public static final BitSet FOLLOW_INC_in_postfixExpression3508 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DEC_in_postfixExpression3527 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_arguments_in_methodCall3567 = new BitSet(new long[]{0x8000000000000002L});
    public static final BitSet FOLLOW_IDENT_in_e4xExpression3593 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STAR_in_e4xExpression3598 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_E4X_ATTRI_in_e4xExpression3604 = new BitSet(new long[]{0x0040000000000000L,0x0000000000012000L});
    public static final BitSet FOLLOW_IDENT_in_e4xExpression3612 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STAR_in_e4xExpression3618 = new BitSet(new long[]{0x0000000000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_LBRACK_in_e4xExpression3621 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_expression_in_e4xExpression3624 = new BitSet(new long[]{0x0000000000000000L,0x0000000000020000L});
    public static final BitSet FOLLOW_RBRACK_in_e4xExpression3626 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_identPrimary_in_primaryExpression3642 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_164_in_primaryExpression3647 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_165_in_primaryExpression3652 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_constant_in_primaryExpression3657 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_arrayLiteral_in_primaryExpression3662 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_objectLiteral_in_primaryExpression3667 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_functionDefinition_in_primaryExpression3672 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_newExpression_in_primaryExpression3677 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_encapsulatedExpression_in_primaryExpression3682 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_identPart_in_identPrimary3695 = new BitSet(new long[]{0x8000000000000002L,0x0000000000014000L});
    public static final BitSet FOLLOW_propOrIdent_in_identPrimary3726 = new BitSet(new long[]{0x8000000000000002L,0x0000000000014000L});
    public static final BitSet FOLLOW_LBRACK_in_identPrimary3745 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_expression_in_identPrimary3749 = new BitSet(new long[]{0x0000000000000000L,0x0000000000020000L});
    public static final BitSet FOLLOW_RBRACK_in_identPrimary3751 = new BitSet(new long[]{0x8000000000000002L,0x0000000000014000L});
    public static final BitSet FOLLOW_arguments_in_identPrimary3796 = new BitSet(new long[]{0x8000000000000002L});
    public static final BitSet FOLLOW_DOT_in_propOrIdent3838 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_identPart_in_propOrIdent3842 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_xmlLiteral_in_constant3870 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_number_in_constant3875 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STRING_LITERAL_in_constant3880 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TRUE_in_constant3885 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FALSE_in_constant3890 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_number3900 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LT_in_xmlLiteral3936 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_166_in_newExpression3957 = new BitSet(new long[]{0x8842000000000000L,0xE000100000010000L,0x000000700000000FL});
    public static final BitSet FOLLOW_postfixExpression_in_newExpression3960 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAREN_in_encapsulatedExpression3970 = new BitSet(new long[]{0x8842000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_assignmentExpression_in_encapsulatedExpression3972 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_RPAREN_in_encapsulatedExpression3974 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FUNCTION_in_functionDefinition3994 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_parameterDeclarationList_in_functionDefinition3996 = new BitSet(new long[]{0x0002000000000000L,0x0000000000000100L});
    public static final BitSet FOLLOW_typeExpression_in_functionDefinition3998 = new BitSet(new long[]{0x0002000000000000L});
    public static final BitSet FOLLOW_block_in_functionDefinition4000 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAREN_in_synpred11764 = new BitSet(new long[]{0x984A000000000000L,0xE798100000010000L,0x0000007C0100000FL});
    public static final BitSet FOLLOW_forInit_in_synpred11766 = new BitSet(new long[]{0x0008000000000000L});
    public static final BitSet FOLLOW_SEMI_in_synpred11768 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_synpred32693 = new BitSet(new long[]{0xBFFFFFFFFFFFFFF0L,0xFFFFFFFFFFFFFFFFL,0x0000007FFFFFFFFFL});
    public static final BitSet FOLLOW_set_in_synpred32792 = new BitSet(new long[]{0x0000000000000002L});

}